/* sudoku-saver.c generated by valac 0.56.18, the Vala compiler
 * generated from sudoku-saver.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libsudoku.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <json-glib/json-glib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SUDOKU_SAVER_0_PROPERTY,
	SUDOKU_SAVER_NUM_PROPERTIES
};
static GParamSpec* sudoku_saver_properties[SUDOKU_SAVER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

static gpointer sudoku_saver_parent_class = NULL;
static gchar* sudoku_saver__savegame_file;
static gchar* sudoku_saver__savegame_file = NULL;
static gchar* sudoku_saver__finishgame_dir;
static gchar* sudoku_saver__finishgame_dir = NULL;

static void sudoku_saver_set_savegame_file (const gchar* value);
static void sudoku_saver_set_finishgame_dir (const gchar* value);
static SudokuGame* sudoku_saver_parse_json_to_game (SudokuSaver* self,
                                             const gchar* file_path);
static void sudoku_saver_create_file_for_game (SudokuSaver* self,
                                        SudokuGame* game,
                                        const gchar* file_name,
                                        gboolean save_timer);
static gchar* sudoku_saver_serialize_game_to_json (SudokuSaver* self,
                                            SudokuGame* game,
                                            gboolean save_timer);
static void _vala_array_add1 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static void _vala_JsonNode_free (JsonNode* self);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void sudoku_saver_finalize (GObject * obj);
static GType sudoku_saver_get_type_once (void);
static void _vala_sudoku_saver_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_sudoku_saver_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

SudokuSaver*
sudoku_saver_construct (GType object_type)
{
	SudokuSaver * self = NULL;
	GError* _inner_error0_ = NULL;
#line 29 "../lib/sudoku-saver.vala"
	self = (SudokuSaver*) g_object_new (object_type, NULL);
#line 99 "sudoku-saver.c"
	{
		gchar* config_dir = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* sudoku_data_dir = NULL;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* file = NULL;
		const gchar* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 33 "../lib/sudoku-saver.vala"
		_tmp0_ = g_get_user_data_dir ();
#line 33 "../lib/sudoku-saver.vala"
		_tmp1_ = g_strdup (_tmp0_);
#line 33 "../lib/sudoku-saver.vala"
		config_dir = _tmp1_;
#line 34 "../lib/sudoku-saver.vala"
		_tmp2_ = config_dir;
#line 34 "../lib/sudoku-saver.vala"
		_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, "gnome-sudoku", NULL);
#line 34 "../lib/sudoku-saver.vala"
		sudoku_data_dir = _tmp3_;
#line 35 "../lib/sudoku-saver.vala"
		_tmp4_ = sudoku_data_dir;
#line 35 "../lib/sudoku-saver.vala"
		_tmp5_ = g_build_path (G_DIR_SEPARATOR_S, _tmp4_, "savefile", NULL);
#line 35 "../lib/sudoku-saver.vala"
		_tmp6_ = _tmp5_;
#line 35 "../lib/sudoku-saver.vala"
		sudoku_saver_set_savegame_file (_tmp6_);
#line 35 "../lib/sudoku-saver.vala"
		_g_free0 (_tmp6_);
#line 36 "../lib/sudoku-saver.vala"
		_tmp7_ = sudoku_data_dir;
#line 36 "../lib/sudoku-saver.vala"
		_tmp8_ = g_build_path (G_DIR_SEPARATOR_S, _tmp7_, "finished", NULL);
#line 36 "../lib/sudoku-saver.vala"
		_tmp9_ = _tmp8_;
#line 36 "../lib/sudoku-saver.vala"
		sudoku_saver_set_finishgame_dir (_tmp9_);
#line 36 "../lib/sudoku-saver.vala"
		_g_free0 (_tmp9_);
#line 37 "../lib/sudoku-saver.vala"
		_tmp10_ = sudoku_data_dir;
#line 37 "../lib/sudoku-saver.vala"
		_tmp11_ = g_file_new_for_path (_tmp10_);
#line 37 "../lib/sudoku-saver.vala"
		file = _tmp11_;
#line 38 "../lib/sudoku-saver.vala"
		_tmp12_ = file;
#line 38 "../lib/sudoku-saver.vala"
		if (!g_file_query_exists (_tmp12_, NULL)) {
#line 163 "sudoku-saver.c"
			GFile* _tmp13_;
#line 39 "../lib/sudoku-saver.vala"
			_tmp13_ = file;
#line 39 "../lib/sudoku-saver.vala"
			g_file_make_directory (_tmp13_, NULL, &_inner_error0_);
#line 39 "../lib/sudoku-saver.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 39 "../lib/sudoku-saver.vala"
				_g_object_unref0 (file);
#line 39 "../lib/sudoku-saver.vala"
				_g_free0 (sudoku_data_dir);
#line 39 "../lib/sudoku-saver.vala"
				_g_free0 (config_dir);
#line 177 "sudoku-saver.c"
				goto __catch0_g_error;
			}
		}
#line 41 "../lib/sudoku-saver.vala"
		_tmp14_ = sudoku_saver_get_finishgame_dir ();
#line 41 "../lib/sudoku-saver.vala"
		_tmp15_ = _tmp14_;
#line 41 "../lib/sudoku-saver.vala"
		_tmp16_ = g_file_new_for_path (_tmp15_);
#line 41 "../lib/sudoku-saver.vala"
		_g_object_unref0 (file);
#line 41 "../lib/sudoku-saver.vala"
		file = _tmp16_;
#line 42 "../lib/sudoku-saver.vala"
		_tmp17_ = file;
#line 42 "../lib/sudoku-saver.vala"
		if (!g_file_query_exists (_tmp17_, NULL)) {
#line 195 "sudoku-saver.c"
			GFile* _tmp18_;
#line 43 "../lib/sudoku-saver.vala"
			_tmp18_ = file;
#line 43 "../lib/sudoku-saver.vala"
			g_file_make_directory (_tmp18_, NULL, &_inner_error0_);
#line 43 "../lib/sudoku-saver.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "../lib/sudoku-saver.vala"
				_g_object_unref0 (file);
#line 43 "../lib/sudoku-saver.vala"
				_g_free0 (sudoku_data_dir);
#line 43 "../lib/sudoku-saver.vala"
				_g_free0 (config_dir);
#line 209 "sudoku-saver.c"
				goto __catch0_g_error;
			}
		}
#line 31 "../lib/sudoku-saver.vala"
		_g_object_unref0 (file);
#line 31 "../lib/sudoku-saver.vala"
		_g_free0 (sudoku_data_dir);
#line 31 "../lib/sudoku-saver.vala"
		_g_free0 (config_dir);
#line 219 "sudoku-saver.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
#line 31 "../lib/sudoku-saver.vala"
		e = _inner_error0_;
#line 31 "../lib/sudoku-saver.vala"
		_inner_error0_ = NULL;
#line 47 "../lib/sudoku-saver.vala"
		_tmp19_ = e;
#line 47 "../lib/sudoku-saver.vala"
		_tmp20_ = _tmp19_->message;
#line 47 "../lib/sudoku-saver.vala"
		g_warning ("sudoku-saver.vala:47: %s", _tmp20_);
#line 31 "../lib/sudoku-saver.vala"
		_g_error_free0 (e);
#line 239 "sudoku-saver.c"
	}
	__finally0:
#line 31 "../lib/sudoku-saver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31 "../lib/sudoku-saver.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 31 "../lib/sudoku-saver.vala"
		g_clear_error (&_inner_error0_);
#line 31 "../lib/sudoku-saver.vala"
		return NULL;
#line 250 "sudoku-saver.c"
	}
#line 29 "../lib/sudoku-saver.vala"
	return self;
#line 254 "sudoku-saver.c"
}

SudokuSaver*
sudoku_saver_new (void)
{
#line 29 "../lib/sudoku-saver.vala"
	return sudoku_saver_construct (TYPE_SUDOKU_SAVER);
#line 262 "sudoku-saver.c"
}

SudokuGame*
sudoku_saver_get_savedgame (SudokuSaver* self)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	SudokuGame* _tmp6_;
	SudokuGame* result;
#line 51 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver_get_savegame_file ();
#line 53 "../lib/sudoku-saver.vala"
	_tmp1_ = _tmp0_;
#line 53 "../lib/sudoku-saver.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 53 "../lib/sudoku-saver.vala"
	file = _tmp2_;
#line 54 "../lib/sudoku-saver.vala"
	_tmp3_ = file;
#line 54 "../lib/sudoku-saver.vala"
	if (!g_file_query_exists (_tmp3_, NULL)) {
#line 55 "../lib/sudoku-saver.vala"
		result = NULL;
#line 55 "../lib/sudoku-saver.vala"
		_g_object_unref0 (file);
#line 55 "../lib/sudoku-saver.vala"
		return result;
#line 297 "sudoku-saver.c"
	}
#line 57 "../lib/sudoku-saver.vala"
	_tmp4_ = sudoku_saver_get_savegame_file ();
#line 57 "../lib/sudoku-saver.vala"
	_tmp5_ = _tmp4_;
#line 57 "../lib/sudoku-saver.vala"
	_tmp6_ = sudoku_saver_parse_json_to_game (self, _tmp5_);
#line 57 "../lib/sudoku-saver.vala"
	result = _tmp6_;
#line 57 "../lib/sudoku-saver.vala"
	_g_object_unref0 (file);
#line 57 "../lib/sudoku-saver.vala"
	return result;
#line 311 "sudoku-saver.c"
}

void
sudoku_saver_save_game (SudokuSaver* self,
                        SudokuGame* game)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 60 "../lib/sudoku-saver.vala"
	g_return_if_fail (self != NULL);
#line 60 "../lib/sudoku-saver.vala"
	g_return_if_fail (game != NULL);
#line 62 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver_get_savegame_file ();
#line 62 "../lib/sudoku-saver.vala"
	_tmp1_ = _tmp0_;
#line 62 "../lib/sudoku-saver.vala"
	sudoku_saver_create_file_for_game (self, game, _tmp1_, TRUE);
#line 330 "sudoku-saver.c"
}

void
sudoku_saver_delete_save (SudokuSaver* self)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 65 "../lib/sudoku-saver.vala"
	g_return_if_fail (self != NULL);
#line 67 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver_get_savegame_file ();
#line 67 "../lib/sudoku-saver.vala"
	_tmp1_ = _tmp0_;
#line 67 "../lib/sudoku-saver.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 67 "../lib/sudoku-saver.vala"
	file = _tmp2_;
#line 68 "../lib/sudoku-saver.vala"
	_tmp3_ = file;
#line 68 "../lib/sudoku-saver.vala"
	if (g_file_query_exists (_tmp3_, NULL)) {
#line 356 "sudoku-saver.c"
		{
			GFile* _tmp4_;
#line 72 "../lib/sudoku-saver.vala"
			_tmp4_ = file;
#line 72 "../lib/sudoku-saver.vala"
			g_file_delete (_tmp4_, NULL, &_inner_error0_);
#line 72 "../lib/sudoku-saver.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 365 "sudoku-saver.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GFile* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 70 "../lib/sudoku-saver.vala"
			e = _inner_error0_;
#line 70 "../lib/sudoku-saver.vala"
			_inner_error0_ = NULL;
#line 76 "../lib/sudoku-saver.vala"
			_tmp5_ = file;
#line 76 "../lib/sudoku-saver.vala"
			_tmp6_ = g_file_get_uri (_tmp5_);
#line 76 "../lib/sudoku-saver.vala"
			_tmp7_ = _tmp6_;
#line 76 "../lib/sudoku-saver.vala"
			_tmp8_ = e;
#line 76 "../lib/sudoku-saver.vala"
			_tmp9_ = _tmp8_->message;
#line 76 "../lib/sudoku-saver.vala"
			g_warning ("sudoku-saver.vala:76: Failed to delete %s: %s", _tmp7_, _tmp9_);
#line 76 "../lib/sudoku-saver.vala"
			_g_free0 (_tmp7_);
#line 70 "../lib/sudoku-saver.vala"
			_g_error_free0 (e);
#line 398 "sudoku-saver.c"
		}
		__finally0:
#line 70 "../lib/sudoku-saver.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../lib/sudoku-saver.vala"
			_g_object_unref0 (file);
#line 70 "../lib/sudoku-saver.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../lib/sudoku-saver.vala"
			g_clear_error (&_inner_error0_);
#line 70 "../lib/sudoku-saver.vala"
			return;
#line 411 "sudoku-saver.c"
		}
	}
#line 65 "../lib/sudoku-saver.vala"
	_g_object_unref0 (file);
#line 416 "sudoku-saver.c"
}

void
sudoku_saver_add_game_to_finished (SudokuSaver* self,
                                   SudokuGame* game,
                                   gboolean delete_savegame,
                                   gboolean save_timer)
{
	gchar* file_name = NULL;
	SudokuBoard* _tmp0_;
	SudokuBoard* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* file_path = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
#line 81 "../lib/sudoku-saver.vala"
	g_return_if_fail (self != NULL);
#line 81 "../lib/sudoku-saver.vala"
	g_return_if_fail (game != NULL);
#line 83 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_game_get_board (game);
#line 83 "../lib/sudoku-saver.vala"
	_tmp1_ = _tmp0_;
#line 83 "../lib/sudoku-saver.vala"
	_tmp2_ = sudoku_board_to_string (_tmp1_, TRUE);
#line 83 "../lib/sudoku-saver.vala"
	_tmp3_ = _tmp2_;
#line 83 "../lib/sudoku-saver.vala"
	_tmp4_ = g_strconcat (_tmp3_, ".save", NULL);
#line 83 "../lib/sudoku-saver.vala"
	_tmp5_ = _tmp4_;
#line 83 "../lib/sudoku-saver.vala"
	_g_free0 (_tmp3_);
#line 83 "../lib/sudoku-saver.vala"
	file_name = _tmp5_;
#line 84 "../lib/sudoku-saver.vala"
	_tmp6_ = sudoku_saver_get_finishgame_dir ();
#line 84 "../lib/sudoku-saver.vala"
	_tmp7_ = _tmp6_;
#line 84 "../lib/sudoku-saver.vala"
	_tmp8_ = file_name;
#line 84 "../lib/sudoku-saver.vala"
	_tmp9_ = g_build_path (G_DIR_SEPARATOR_S, _tmp7_, _tmp8_, NULL);
#line 84 "../lib/sudoku-saver.vala"
	file_path = _tmp9_;
#line 85 "../lib/sudoku-saver.vala"
	_tmp10_ = file_path;
#line 85 "../lib/sudoku-saver.vala"
	sudoku_saver_create_file_for_game (self, game, _tmp10_, save_timer);
#line 87 "../lib/sudoku-saver.vala"
	if (delete_savegame) {
#line 88 "../lib/sudoku-saver.vala"
		sudoku_saver_delete_save (self);
#line 476 "sudoku-saver.c"
	}
#line 81 "../lib/sudoku-saver.vala"
	_g_free0 (file_path);
#line 81 "../lib/sudoku-saver.vala"
	_g_free0 (file_name);
#line 482 "sudoku-saver.c"
}

static void
sudoku_saver_create_file_for_game (SudokuSaver* self,
                                   SudokuGame* game,
                                   const gchar* file_name,
                                   gboolean save_timer)
{
	gchar* json_str = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 91 "../lib/sudoku-saver.vala"
	g_return_if_fail (self != NULL);
#line 91 "../lib/sudoku-saver.vala"
	g_return_if_fail (game != NULL);
#line 91 "../lib/sudoku-saver.vala"
	g_return_if_fail (file_name != NULL);
#line 93 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver_serialize_game_to_json (self, game, save_timer);
#line 93 "../lib/sudoku-saver.vala"
	json_str = _tmp0_;
#line 504 "sudoku-saver.c"
	{
#line 97 "../lib/sudoku-saver.vala"
		g_file_set_contents (file_name, json_str, (gssize) -1, &_inner_error0_);
#line 97 "../lib/sudoku-saver.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 510 "sudoku-saver.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 95 "../lib/sudoku-saver.vala"
		e = _inner_error0_;
#line 95 "../lib/sudoku-saver.vala"
		_inner_error0_ = NULL;
#line 101 "../lib/sudoku-saver.vala"
		_tmp1_ = e;
#line 101 "../lib/sudoku-saver.vala"
		_tmp2_ = _tmp1_->message;
#line 101 "../lib/sudoku-saver.vala"
		g_warning ("sudoku-saver.vala:101: %s", _tmp2_);
#line 95 "../lib/sudoku-saver.vala"
		_g_error_free0 (e);
#line 532 "sudoku-saver.c"
	}
	__finally0:
#line 95 "../lib/sudoku-saver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "../lib/sudoku-saver.vala"
		_g_free0 (json_str);
#line 95 "../lib/sudoku-saver.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 95 "../lib/sudoku-saver.vala"
		g_clear_error (&_inner_error0_);
#line 95 "../lib/sudoku-saver.vala"
		return;
#line 545 "sudoku-saver.c"
	}
#line 91 "../lib/sudoku-saver.vala"
	_g_free0 (json_str);
#line 549 "sudoku-saver.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 107 "../lib/sudoku-saver.vala"
	return self ? g_object_ref (self) : NULL;
#line 557 "sudoku-saver.c"
}

static void
_vala_array_add1 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 133 "../lib/sudoku-saver.vala"
	if ((*length) == (*size)) {
#line 133 "../lib/sudoku-saver.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 133 "../lib/sudoku-saver.vala"
		*array = g_renew (gint, *array, *size);
#line 572 "sudoku-saver.c"
	}
#line 133 "../lib/sudoku-saver.vala"
	(*array)[(*length)++] = value;
#line 576 "sudoku-saver.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 169 "../lib/sudoku-saver.vala"
	g_boxed_free (json_node_get_type (), self);
#line 584 "sudoku-saver.c"
}

static gchar*
sudoku_saver_serialize_game_to_json (SudokuSaver* self,
                                     SudokuGame* game,
                                     gboolean save_timer)
{
	SudokuBoard* board = NULL;
	SudokuBoard* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gint* board_cells = NULL;
	SudokuBoard* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint* _tmp6_;
	gint board_cells_length1;
	gint board_cells_length2;
	JsonBuilder* builder = NULL;
	JsonBuilder* _tmp7_;
	JsonBuilder* _tmp8_;
	JsonBuilder* _tmp9_;
	JsonBuilder* _tmp10_;
	SudokuBoard* _tmp11_;
	DifficultyCategory _tmp12_;
	DifficultyCategory _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	JsonBuilder* _tmp16_;
	GameMode _tmp17_;
	GameMode _tmp18_;
	JsonBuilder* _tmp22_;
	JsonBuilder* _tmp23_;
	JsonBuilder* _tmp64_;
	JsonBuilder* _tmp65_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp66_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp67_;
	JsonNode* _tmp68_;
	gchar* _tmp69_;
	gchar* result;
#line 105 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 107 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_game_get_board (game);
#line 107 "../lib/sudoku-saver.vala"
	_tmp1_ = _tmp0_;
#line 107 "../lib/sudoku-saver.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 107 "../lib/sudoku-saver.vala"
	board = _tmp2_;
#line 108 "../lib/sudoku-saver.vala"
	_tmp3_ = board;
#line 108 "../lib/sudoku-saver.vala"
	_tmp6_ = sudoku_board_get_cells (_tmp3_, &_tmp4_, &_tmp5_);
#line 108 "../lib/sudoku-saver.vala"
	board_cells = _tmp6_;
#line 108 "../lib/sudoku-saver.vala"
	board_cells_length1 = _tmp4_;
#line 108 "../lib/sudoku-saver.vala"
	board_cells_length2 = _tmp5_;
#line 109 "../lib/sudoku-saver.vala"
	_tmp7_ = json_builder_new ();
#line 109 "../lib/sudoku-saver.vala"
	builder = _tmp7_;
#line 111 "../lib/sudoku-saver.vala"
	_tmp8_ = builder;
#line 111 "../lib/sudoku-saver.vala"
	json_builder_begin_object (_tmp8_);
#line 112 "../lib/sudoku-saver.vala"
	_tmp9_ = builder;
#line 112 "../lib/sudoku-saver.vala"
	json_builder_set_member_name (_tmp9_, "difficulty_category");
#line 113 "../lib/sudoku-saver.vala"
	_tmp10_ = builder;
#line 113 "../lib/sudoku-saver.vala"
	_tmp11_ = board;
#line 113 "../lib/sudoku-saver.vala"
	_tmp12_ = sudoku_board_get_difficulty_category (_tmp11_);
#line 113 "../lib/sudoku-saver.vala"
	_tmp13_ = _tmp12_;
#line 113 "../lib/sudoku-saver.vala"
	_tmp14_ = difficulty_category_to_untranslated_string (_tmp13_);
#line 113 "../lib/sudoku-saver.vala"
	_tmp15_ = _tmp14_;
#line 113 "../lib/sudoku-saver.vala"
	json_builder_add_string_value (_tmp10_, _tmp15_);
#line 113 "../lib/sudoku-saver.vala"
	_g_free0 (_tmp15_);
#line 115 "../lib/sudoku-saver.vala"
	_tmp16_ = builder;
#line 115 "../lib/sudoku-saver.vala"
	json_builder_set_member_name (_tmp16_, "time_elapsed");
#line 116 "../lib/sudoku-saver.vala"
	_tmp17_ = sudoku_game_get_mode (game);
#line 116 "../lib/sudoku-saver.vala"
	_tmp18_ = _tmp17_;
#line 116 "../lib/sudoku-saver.vala"
	if (_tmp18_ == GAME_MODE_CREATE) {
#line 687 "sudoku-saver.c"
		JsonBuilder* _tmp19_;
#line 117 "../lib/sudoku-saver.vala"
		_tmp19_ = builder;
#line 117 "../lib/sudoku-saver.vala"
		json_builder_add_double_value (_tmp19_, (gdouble) 0);
#line 693 "sudoku-saver.c"
	} else {
#line 118 "../lib/sudoku-saver.vala"
		if (save_timer) {
#line 697 "sudoku-saver.c"
			JsonBuilder* _tmp20_;
#line 119 "../lib/sudoku-saver.vala"
			_tmp20_ = builder;
#line 119 "../lib/sudoku-saver.vala"
			json_builder_add_double_value (_tmp20_, sudoku_game_get_total_time_played (game));
#line 703 "sudoku-saver.c"
		} else {
			JsonBuilder* _tmp21_;
#line 121 "../lib/sudoku-saver.vala"
			_tmp21_ = builder;
#line 121 "../lib/sudoku-saver.vala"
			json_builder_add_double_value (_tmp21_, (gdouble) -1);
#line 710 "sudoku-saver.c"
		}
	}
#line 123 "../lib/sudoku-saver.vala"
	_tmp22_ = builder;
#line 123 "../lib/sudoku-saver.vala"
	json_builder_set_member_name (_tmp22_, "cells");
#line 124 "../lib/sudoku-saver.vala"
	_tmp23_ = builder;
#line 124 "../lib/sudoku-saver.vala"
	json_builder_begin_array (_tmp23_);
#line 721 "sudoku-saver.c"
	{
		gint i = 0;
#line 126 "../lib/sudoku-saver.vala"
		i = 0;
#line 726 "sudoku-saver.c"
		{
			gboolean _tmp24_ = FALSE;
#line 126 "../lib/sudoku-saver.vala"
			_tmp24_ = TRUE;
#line 126 "../lib/sudoku-saver.vala"
			while (TRUE) {
#line 733 "sudoku-saver.c"
				SudokuBoard* _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
#line 126 "../lib/sudoku-saver.vala"
				if (!_tmp24_) {
#line 739 "sudoku-saver.c"
					gint _tmp25_;
#line 126 "../lib/sudoku-saver.vala"
					_tmp25_ = i;
#line 126 "../lib/sudoku-saver.vala"
					i = _tmp25_ + 1;
#line 745 "sudoku-saver.c"
				}
#line 126 "../lib/sudoku-saver.vala"
				_tmp24_ = FALSE;
#line 126 "../lib/sudoku-saver.vala"
				_tmp26_ = board;
#line 126 "../lib/sudoku-saver.vala"
				_tmp27_ = sudoku_board_get_rows (_tmp26_);
#line 126 "../lib/sudoku-saver.vala"
				_tmp28_ = _tmp27_;
#line 126 "../lib/sudoku-saver.vala"
				if (!(i < _tmp28_)) {
#line 126 "../lib/sudoku-saver.vala"
					break;
#line 759 "sudoku-saver.c"
				}
				{
					gint j = 0;
#line 128 "../lib/sudoku-saver.vala"
					j = 0;
#line 765 "sudoku-saver.c"
					{
						gboolean _tmp29_ = FALSE;
#line 128 "../lib/sudoku-saver.vala"
						_tmp29_ = TRUE;
#line 128 "../lib/sudoku-saver.vala"
						while (TRUE) {
#line 772 "sudoku-saver.c"
							SudokuBoard* _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							gint* earmarks = NULL;
							gint* _tmp34_;
							gint earmarks_length1;
							gint _earmarks_size_;
							gboolean _tmp41_ = FALSE;
							gint* _tmp42_;
							gint _tmp42__length1;
							gint _tmp42__length2;
							gint _tmp43_;
							JsonBuilder* _tmp45_;
							JsonBuilder* _tmp46_;
							JsonBuilder* _tmp47_;
							JsonBuilder* _tmp48_;
							JsonBuilder* _tmp49_;
							JsonBuilder* _tmp50_;
							JsonBuilder* _tmp51_;
							JsonBuilder* _tmp52_;
							gint* _tmp53_;
							gint _tmp53__length1;
							gint _tmp53__length2;
							gint _tmp54_;
							JsonBuilder* _tmp55_;
							JsonBuilder* _tmp56_;
							SudokuBoard* _tmp57_;
							JsonBuilder* _tmp58_;
							JsonBuilder* _tmp59_;
							gint* _tmp60_;
							gint _tmp60__length1;
							JsonBuilder* _tmp62_;
							JsonBuilder* _tmp63_;
#line 128 "../lib/sudoku-saver.vala"
							if (!_tmp29_) {
#line 808 "sudoku-saver.c"
								gint _tmp30_;
#line 128 "../lib/sudoku-saver.vala"
								_tmp30_ = j;
#line 128 "../lib/sudoku-saver.vala"
								j = _tmp30_ + 1;
#line 814 "sudoku-saver.c"
							}
#line 128 "../lib/sudoku-saver.vala"
							_tmp29_ = FALSE;
#line 128 "../lib/sudoku-saver.vala"
							_tmp31_ = board;
#line 128 "../lib/sudoku-saver.vala"
							_tmp32_ = sudoku_board_get_cols (_tmp31_);
#line 128 "../lib/sudoku-saver.vala"
							_tmp33_ = _tmp32_;
#line 128 "../lib/sudoku-saver.vala"
							if (!(j < _tmp33_)) {
#line 128 "../lib/sudoku-saver.vala"
								break;
#line 828 "sudoku-saver.c"
							}
#line 130 "../lib/sudoku-saver.vala"
							_tmp34_ = g_new0 (gint, 0);
#line 130 "../lib/sudoku-saver.vala"
							earmarks = _tmp34_;
#line 130 "../lib/sudoku-saver.vala"
							earmarks_length1 = 0;
#line 130 "../lib/sudoku-saver.vala"
							_earmarks_size_ = earmarks_length1;
#line 838 "sudoku-saver.c"
							{
								gint k = 0;
#line 131 "../lib/sudoku-saver.vala"
								k = 1;
#line 843 "sudoku-saver.c"
								{
									gboolean _tmp35_ = FALSE;
#line 131 "../lib/sudoku-saver.vala"
									_tmp35_ = TRUE;
#line 131 "../lib/sudoku-saver.vala"
									while (TRUE) {
#line 850 "sudoku-saver.c"
										SudokuBoard* _tmp37_;
										gint _tmp38_;
										gint _tmp39_;
										SudokuBoard* _tmp40_;
#line 131 "../lib/sudoku-saver.vala"
										if (!_tmp35_) {
#line 857 "sudoku-saver.c"
											gint _tmp36_;
#line 131 "../lib/sudoku-saver.vala"
											_tmp36_ = k;
#line 131 "../lib/sudoku-saver.vala"
											k = _tmp36_ + 1;
#line 863 "sudoku-saver.c"
										}
#line 131 "../lib/sudoku-saver.vala"
										_tmp35_ = FALSE;
#line 131 "../lib/sudoku-saver.vala"
										_tmp37_ = board;
#line 131 "../lib/sudoku-saver.vala"
										_tmp38_ = sudoku_board_get_max_val (_tmp37_);
#line 131 "../lib/sudoku-saver.vala"
										_tmp39_ = _tmp38_;
#line 131 "../lib/sudoku-saver.vala"
										if (!(k <= _tmp39_)) {
#line 131 "../lib/sudoku-saver.vala"
											break;
#line 877 "sudoku-saver.c"
										}
#line 132 "../lib/sudoku-saver.vala"
										_tmp40_ = board;
#line 132 "../lib/sudoku-saver.vala"
										if (sudoku_board_is_earmark_enabled (_tmp40_, i, j, k)) {
#line 133 "../lib/sudoku-saver.vala"
											_vala_array_add1 (&earmarks, &earmarks_length1, &_earmarks_size_, k);
#line 885 "sudoku-saver.c"
										}
									}
								}
							}
#line 135 "../lib/sudoku-saver.vala"
							_tmp42_ = board_cells;
#line 135 "../lib/sudoku-saver.vala"
							_tmp42__length1 = board_cells_length1;
#line 135 "../lib/sudoku-saver.vala"
							_tmp42__length2 = board_cells_length2;
#line 135 "../lib/sudoku-saver.vala"
							_tmp43_ = _tmp42_[(i * _tmp42__length2) + j];
#line 135 "../lib/sudoku-saver.vala"
							if (_tmp43_ == 0) {
#line 900 "sudoku-saver.c"
								gint* _tmp44_;
								gint _tmp44__length1;
#line 135 "../lib/sudoku-saver.vala"
								_tmp44_ = earmarks;
#line 135 "../lib/sudoku-saver.vala"
								_tmp44__length1 = earmarks_length1;
#line 135 "../lib/sudoku-saver.vala"
								_tmp41_ = _tmp44__length1 == 0;
#line 909 "sudoku-saver.c"
							} else {
#line 135 "../lib/sudoku-saver.vala"
								_tmp41_ = FALSE;
#line 913 "sudoku-saver.c"
							}
#line 135 "../lib/sudoku-saver.vala"
							if (_tmp41_) {
#line 136 "../lib/sudoku-saver.vala"
								earmarks = (g_free (earmarks), NULL);
#line 136 "../lib/sudoku-saver.vala"
								continue;
#line 921 "sudoku-saver.c"
							}
#line 138 "../lib/sudoku-saver.vala"
							_tmp45_ = builder;
#line 138 "../lib/sudoku-saver.vala"
							json_builder_begin_object (_tmp45_);
#line 140 "../lib/sudoku-saver.vala"
							_tmp46_ = builder;
#line 140 "../lib/sudoku-saver.vala"
							json_builder_set_member_name (_tmp46_, "position");
#line 141 "../lib/sudoku-saver.vala"
							_tmp47_ = builder;
#line 141 "../lib/sudoku-saver.vala"
							json_builder_begin_array (_tmp47_);
#line 142 "../lib/sudoku-saver.vala"
							_tmp48_ = builder;
#line 142 "../lib/sudoku-saver.vala"
							json_builder_add_int_value (_tmp48_, (gint64) i);
#line 143 "../lib/sudoku-saver.vala"
							_tmp49_ = builder;
#line 143 "../lib/sudoku-saver.vala"
							json_builder_add_int_value (_tmp49_, (gint64) j);
#line 144 "../lib/sudoku-saver.vala"
							_tmp50_ = builder;
#line 144 "../lib/sudoku-saver.vala"
							json_builder_end_array (_tmp50_);
#line 145 "../lib/sudoku-saver.vala"
							_tmp51_ = builder;
#line 145 "../lib/sudoku-saver.vala"
							json_builder_set_member_name (_tmp51_, "value");
#line 146 "../lib/sudoku-saver.vala"
							_tmp52_ = builder;
#line 146 "../lib/sudoku-saver.vala"
							_tmp53_ = board_cells;
#line 146 "../lib/sudoku-saver.vala"
							_tmp53__length1 = board_cells_length1;
#line 146 "../lib/sudoku-saver.vala"
							_tmp53__length2 = board_cells_length2;
#line 146 "../lib/sudoku-saver.vala"
							_tmp54_ = _tmp53_[(i * _tmp53__length2) + j];
#line 146 "../lib/sudoku-saver.vala"
							json_builder_add_int_value (_tmp52_, (gint64) _tmp54_);
#line 147 "../lib/sudoku-saver.vala"
							_tmp55_ = builder;
#line 147 "../lib/sudoku-saver.vala"
							json_builder_set_member_name (_tmp55_, "fixed");
#line 148 "../lib/sudoku-saver.vala"
							_tmp56_ = builder;
#line 148 "../lib/sudoku-saver.vala"
							_tmp57_ = board;
#line 148 "../lib/sudoku-saver.vala"
							json_builder_add_boolean_value (_tmp56_, sudoku_board_get_is_fixed (_tmp57_, i, j));
#line 149 "../lib/sudoku-saver.vala"
							_tmp58_ = builder;
#line 149 "../lib/sudoku-saver.vala"
							json_builder_set_member_name (_tmp58_, "earmarks");
#line 150 "../lib/sudoku-saver.vala"
							_tmp59_ = builder;
#line 150 "../lib/sudoku-saver.vala"
							json_builder_begin_array (_tmp59_);
#line 152 "../lib/sudoku-saver.vala"
							_tmp60_ = earmarks;
#line 152 "../lib/sudoku-saver.vala"
							_tmp60__length1 = earmarks_length1;
#line 985 "sudoku-saver.c"
							{
								gint* k_collection = NULL;
								gint k_collection_length1 = 0;
								gint _k_collection_size_ = 0;
								gint k_it = 0;
#line 152 "../lib/sudoku-saver.vala"
								k_collection = _tmp60_;
#line 152 "../lib/sudoku-saver.vala"
								k_collection_length1 = _tmp60__length1;
#line 152 "../lib/sudoku-saver.vala"
								for (k_it = 0; k_it < k_collection_length1; k_it = k_it + 1) {
#line 997 "sudoku-saver.c"
									gint k = 0;
#line 152 "../lib/sudoku-saver.vala"
									k = k_collection[k_it];
#line 1001 "sudoku-saver.c"
									{
										JsonBuilder* _tmp61_;
#line 153 "../lib/sudoku-saver.vala"
										_tmp61_ = builder;
#line 153 "../lib/sudoku-saver.vala"
										json_builder_add_int_value (_tmp61_, (gint64) k);
#line 1008 "sudoku-saver.c"
									}
								}
							}
#line 155 "../lib/sudoku-saver.vala"
							_tmp62_ = builder;
#line 155 "../lib/sudoku-saver.vala"
							json_builder_end_array (_tmp62_);
#line 157 "../lib/sudoku-saver.vala"
							_tmp63_ = builder;
#line 157 "../lib/sudoku-saver.vala"
							json_builder_end_object (_tmp63_);
#line 128 "../lib/sudoku-saver.vala"
							earmarks = (g_free (earmarks), NULL);
#line 1022 "sudoku-saver.c"
						}
					}
				}
			}
		}
	}
#line 161 "../lib/sudoku-saver.vala"
	_tmp64_ = builder;
#line 161 "../lib/sudoku-saver.vala"
	json_builder_end_array (_tmp64_);
#line 162 "../lib/sudoku-saver.vala"
	_tmp65_ = builder;
#line 162 "../lib/sudoku-saver.vala"
	json_builder_end_object (_tmp65_);
#line 164 "../lib/sudoku-saver.vala"
	_tmp66_ = json_generator_new ();
#line 164 "../lib/sudoku-saver.vala"
	generator = _tmp66_;
#line 165 "../lib/sudoku-saver.vala"
	json_generator_set_pretty (generator, TRUE);
#line 166 "../lib/sudoku-saver.vala"
	_tmp67_ = builder;
#line 166 "../lib/sudoku-saver.vala"
	_tmp68_ = json_builder_get_root (_tmp67_);
#line 166 "../lib/sudoku-saver.vala"
	root = _tmp68_;
#line 167 "../lib/sudoku-saver.vala"
	json_generator_set_root (generator, root);
#line 169 "../lib/sudoku-saver.vala"
	_tmp69_ = json_generator_to_data (generator, NULL);
#line 169 "../lib/sudoku-saver.vala"
	result = _tmp69_;
#line 169 "../lib/sudoku-saver.vala"
	__vala_JsonNode_free0 (root);
#line 169 "../lib/sudoku-saver.vala"
	_g_object_unref0 (generator);
#line 169 "../lib/sudoku-saver.vala"
	_g_object_unref0 (builder);
#line 169 "../lib/sudoku-saver.vala"
	board_cells = (g_free (board_cells), NULL);
#line 169 "../lib/sudoku-saver.vala"
	_g_object_unref0 (board);
#line 169 "../lib/sudoku-saver.vala"
	return result;
#line 1067 "sudoku-saver.c"
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 185 "../lib/sudoku-saver.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 1075 "sudoku-saver.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 185 "../lib/sudoku-saver.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 1083 "sudoku-saver.c"
}

static SudokuGame*
sudoku_saver_parse_json_to_game (SudokuSaver* self,
                                 const gchar* file_path)
{
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	SudokuBoard* board = NULL;
	SudokuBoard* _tmp2_;
	JsonNode* node = NULL;
	JsonParser* _tmp3_;
	JsonNode* _tmp4_;
	JsonNode* _tmp5_;
	JsonReader* reader = NULL;
	JsonNode* _tmp6_;
	JsonReader* _tmp7_;
	JsonReader* _tmp8_;
	JsonReader* _tmp9_;
	JsonReader* _tmp53_;
	JsonReader* _tmp54_;
	JsonReader* _tmp55_;
	SudokuBoard* _tmp56_;
	JsonReader* _tmp57_;
	SudokuBoard* _tmp58_;
	gdouble _tmp59_;
	gdouble _tmp60_;
	JsonReader* _tmp61_;
	JsonReader* _tmp62_;
	JsonReader* _tmp63_;
	SudokuBoard* _tmp64_;
	JsonReader* _tmp65_;
	const gchar* _tmp66_;
	SudokuBoard* _tmp67_;
	DifficultyCategory _tmp68_;
	DifficultyCategory _tmp69_;
	JsonReader* _tmp70_;
	SudokuBoard* _tmp71_;
	SudokuGame* _tmp72_;
	GError* _inner_error0_ = NULL;
	SudokuGame* result;
#line 172 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 172 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 174 "../lib/sudoku-saver.vala"
	_tmp0_ = json_parser_new ();
#line 174 "../lib/sudoku-saver.vala"
	parser = _tmp0_;
#line 1133 "sudoku-saver.c"
	{
		JsonParser* _tmp1_;
#line 177 "../lib/sudoku-saver.vala"
		_tmp1_ = parser;
#line 177 "../lib/sudoku-saver.vala"
		json_parser_load_from_file (_tmp1_, file_path, &_inner_error0_);
#line 177 "../lib/sudoku-saver.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1142 "sudoku-saver.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 175 "../lib/sudoku-saver.vala"
		g_clear_error (&_inner_error0_);
#line 181 "../lib/sudoku-saver.vala"
		result = NULL;
#line 181 "../lib/sudoku-saver.vala"
		_g_object_unref0 (parser);
#line 181 "../lib/sudoku-saver.vala"
		return result;
#line 1157 "sudoku-saver.c"
	}
	__finally0:
#line 175 "../lib/sudoku-saver.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 175 "../lib/sudoku-saver.vala"
		_g_object_unref0 (parser);
#line 175 "../lib/sudoku-saver.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 175 "../lib/sudoku-saver.vala"
		g_clear_error (&_inner_error0_);
#line 175 "../lib/sudoku-saver.vala"
		return NULL;
#line 1170 "sudoku-saver.c"
	}
#line 184 "../lib/sudoku-saver.vala"
	_tmp2_ = sudoku_board_new (3, 3);
#line 184 "../lib/sudoku-saver.vala"
	board = _tmp2_;
#line 185 "../lib/sudoku-saver.vala"
	_tmp3_ = parser;
#line 185 "../lib/sudoku-saver.vala"
	_tmp4_ = json_parser_get_root (_tmp3_);
#line 185 "../lib/sudoku-saver.vala"
	_tmp5_ = __vala_JsonNode_copy0 (_tmp4_);
#line 185 "../lib/sudoku-saver.vala"
	node = _tmp5_;
#line 186 "../lib/sudoku-saver.vala"
	_tmp6_ = node;
#line 186 "../lib/sudoku-saver.vala"
	_tmp7_ = json_reader_new (_tmp6_);
#line 186 "../lib/sudoku-saver.vala"
	reader = _tmp7_;
#line 187 "../lib/sudoku-saver.vala"
	_tmp8_ = reader;
#line 187 "../lib/sudoku-saver.vala"
	json_reader_read_member (_tmp8_, "cells");
#line 188 "../lib/sudoku-saver.vala"
	_tmp9_ = reader;
#line 188 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (json_reader_is_array (_tmp9_), NULL);
#line 1198 "sudoku-saver.c"
	{
		gint i = 0;
#line 190 "../lib/sudoku-saver.vala"
		i = 0;
#line 1203 "sudoku-saver.c"
		{
			gboolean _tmp10_ = FALSE;
#line 190 "../lib/sudoku-saver.vala"
			_tmp10_ = TRUE;
#line 190 "../lib/sudoku-saver.vala"
			while (TRUE) {
#line 1210 "sudoku-saver.c"
				JsonReader* _tmp12_;
				JsonReader* _tmp13_;
				JsonReader* _tmp14_;
				JsonReader* _tmp15_;
				JsonReader* _tmp16_;
				JsonReader* _tmp17_;
				JsonReader* _tmp18_;
				gint row = 0;
				JsonReader* _tmp19_;
				gboolean _tmp20_ = FALSE;
				JsonReader* _tmp21_;
				JsonReader* _tmp22_;
				JsonReader* _tmp23_;
				gint col = 0;
				JsonReader* _tmp24_;
				gboolean _tmp25_ = FALSE;
				JsonReader* _tmp26_;
				JsonReader* _tmp27_;
				JsonReader* _tmp28_;
				JsonReader* _tmp29_;
				gint val = 0;
				JsonReader* _tmp30_;
				gboolean _tmp31_ = FALSE;
				JsonReader* _tmp32_;
				JsonReader* _tmp33_;
				JsonReader* _tmp34_;
				gboolean is_fixed = FALSE;
				JsonReader* _tmp35_;
				JsonReader* _tmp36_;
				JsonReader* _tmp38_;
				JsonReader* _tmp39_;
				JsonReader* _tmp51_;
				JsonReader* _tmp52_;
#line 190 "../lib/sudoku-saver.vala"
				if (!_tmp10_) {
#line 1246 "sudoku-saver.c"
					gint _tmp11_;
#line 190 "../lib/sudoku-saver.vala"
					_tmp11_ = i;
#line 190 "../lib/sudoku-saver.vala"
					i = _tmp11_ + 1;
#line 1252 "sudoku-saver.c"
				}
#line 190 "../lib/sudoku-saver.vala"
				_tmp10_ = FALSE;
#line 190 "../lib/sudoku-saver.vala"
				_tmp12_ = reader;
#line 190 "../lib/sudoku-saver.vala"
				if (!(i < json_reader_count_elements (_tmp12_))) {
#line 190 "../lib/sudoku-saver.vala"
					break;
#line 1262 "sudoku-saver.c"
				}
#line 192 "../lib/sudoku-saver.vala"
				_tmp13_ = reader;
#line 192 "../lib/sudoku-saver.vala"
				json_reader_read_element (_tmp13_, (guint) i);
#line 194 "../lib/sudoku-saver.vala"
				_tmp14_ = reader;
#line 194 "../lib/sudoku-saver.vala"
				json_reader_read_member (_tmp14_, "position");
#line 195 "../lib/sudoku-saver.vala"
				_tmp15_ = reader;
#line 195 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_array (_tmp15_), NULL);
#line 196 "../lib/sudoku-saver.vala"
				_tmp16_ = reader;
#line 196 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_count_elements (_tmp16_) == 2, NULL);
#line 197 "../lib/sudoku-saver.vala"
				_tmp17_ = reader;
#line 197 "../lib/sudoku-saver.vala"
				json_reader_read_element (_tmp17_, (guint) 0);
#line 198 "../lib/sudoku-saver.vala"
				_tmp18_ = reader;
#line 198 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_value (_tmp18_), NULL);
#line 199 "../lib/sudoku-saver.vala"
				_tmp19_ = reader;
#line 199 "../lib/sudoku-saver.vala"
				row = (gint) json_reader_get_int_value (_tmp19_);
#line 200 "../lib/sudoku-saver.vala"
				if (row >= 0) {
#line 200 "../lib/sudoku-saver.vala"
					_tmp20_ = row < 9;
#line 1296 "sudoku-saver.c"
				} else {
#line 200 "../lib/sudoku-saver.vala"
					_tmp20_ = FALSE;
#line 1300 "sudoku-saver.c"
				}
#line 200 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (_tmp20_, NULL);
#line 202 "../lib/sudoku-saver.vala"
				_tmp21_ = reader;
#line 202 "../lib/sudoku-saver.vala"
				json_reader_end_element (_tmp21_);
#line 204 "../lib/sudoku-saver.vala"
				_tmp22_ = reader;
#line 204 "../lib/sudoku-saver.vala"
				json_reader_read_element (_tmp22_, (guint) 1);
#line 205 "../lib/sudoku-saver.vala"
				_tmp23_ = reader;
#line 205 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_value (_tmp23_), NULL);
#line 206 "../lib/sudoku-saver.vala"
				_tmp24_ = reader;
#line 206 "../lib/sudoku-saver.vala"
				col = (gint) json_reader_get_int_value (_tmp24_);
#line 207 "../lib/sudoku-saver.vala"
				if (col >= 0) {
#line 207 "../lib/sudoku-saver.vala"
					_tmp25_ = col < 9;
#line 1324 "sudoku-saver.c"
				} else {
#line 207 "../lib/sudoku-saver.vala"
					_tmp25_ = FALSE;
#line 1328 "sudoku-saver.c"
				}
#line 207 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (_tmp25_, NULL);
#line 208 "../lib/sudoku-saver.vala"
				_tmp26_ = reader;
#line 208 "../lib/sudoku-saver.vala"
				json_reader_end_element (_tmp26_);
#line 209 "../lib/sudoku-saver.vala"
				_tmp27_ = reader;
#line 209 "../lib/sudoku-saver.vala"
				json_reader_end_member (_tmp27_);
#line 211 "../lib/sudoku-saver.vala"
				_tmp28_ = reader;
#line 211 "../lib/sudoku-saver.vala"
				json_reader_read_member (_tmp28_, "value");
#line 212 "../lib/sudoku-saver.vala"
				_tmp29_ = reader;
#line 212 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_value (_tmp29_), NULL);
#line 213 "../lib/sudoku-saver.vala"
				_tmp30_ = reader;
#line 213 "../lib/sudoku-saver.vala"
				val = (gint) json_reader_get_int_value (_tmp30_);
#line 214 "../lib/sudoku-saver.vala"
				if (val >= 0) {
#line 214 "../lib/sudoku-saver.vala"
					_tmp31_ = val < 10;
#line 1356 "sudoku-saver.c"
				} else {
#line 214 "../lib/sudoku-saver.vala"
					_tmp31_ = FALSE;
#line 1360 "sudoku-saver.c"
				}
#line 214 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (_tmp31_, NULL);
#line 215 "../lib/sudoku-saver.vala"
				_tmp32_ = reader;
#line 215 "../lib/sudoku-saver.vala"
				json_reader_end_member (_tmp32_);
#line 217 "../lib/sudoku-saver.vala"
				_tmp33_ = reader;
#line 217 "../lib/sudoku-saver.vala"
				json_reader_read_member (_tmp33_, "fixed");
#line 218 "../lib/sudoku-saver.vala"
				_tmp34_ = reader;
#line 218 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_value (_tmp34_), NULL);
#line 219 "../lib/sudoku-saver.vala"
				_tmp35_ = reader;
#line 219 "../lib/sudoku-saver.vala"
				is_fixed = json_reader_get_boolean_value (_tmp35_);
#line 220 "../lib/sudoku-saver.vala"
				_tmp36_ = reader;
#line 220 "../lib/sudoku-saver.vala"
				json_reader_end_member (_tmp36_);
#line 222 "../lib/sudoku-saver.vala"
				if (val != 0) {
#line 1386 "sudoku-saver.c"
					SudokuBoard* _tmp37_;
#line 223 "../lib/sudoku-saver.vala"
					_tmp37_ = board;
#line 223 "../lib/sudoku-saver.vala"
					sudoku_board_insert (_tmp37_, row, col, val, is_fixed);
#line 1392 "sudoku-saver.c"
				}
#line 225 "../lib/sudoku-saver.vala"
				_tmp38_ = reader;
#line 225 "../lib/sudoku-saver.vala"
				json_reader_read_member (_tmp38_, "earmarks");
#line 226 "../lib/sudoku-saver.vala"
				_tmp39_ = reader;
#line 226 "../lib/sudoku-saver.vala"
				g_return_val_if_fail (json_reader_is_array (_tmp39_), NULL);
#line 1402 "sudoku-saver.c"
				{
					gint k = 0;
#line 227 "../lib/sudoku-saver.vala"
					k = 0;
#line 1407 "sudoku-saver.c"
					{
						gboolean _tmp40_ = FALSE;
#line 227 "../lib/sudoku-saver.vala"
						_tmp40_ = TRUE;
#line 227 "../lib/sudoku-saver.vala"
						while (TRUE) {
#line 1414 "sudoku-saver.c"
							JsonReader* _tmp42_;
							JsonReader* _tmp43_;
							JsonReader* _tmp44_;
							gint earmark = 0;
							JsonReader* _tmp45_;
							gboolean _tmp46_ = FALSE;
							gboolean _tmp47_ = FALSE;
							SudokuBoard* _tmp49_;
							JsonReader* _tmp50_;
#line 227 "../lib/sudoku-saver.vala"
							if (!_tmp40_) {
#line 1426 "sudoku-saver.c"
								gint _tmp41_;
#line 227 "../lib/sudoku-saver.vala"
								_tmp41_ = k;
#line 227 "../lib/sudoku-saver.vala"
								k = _tmp41_ + 1;
#line 1432 "sudoku-saver.c"
							}
#line 227 "../lib/sudoku-saver.vala"
							_tmp40_ = FALSE;
#line 227 "../lib/sudoku-saver.vala"
							_tmp42_ = reader;
#line 227 "../lib/sudoku-saver.vala"
							if (!(k < json_reader_count_elements (_tmp42_))) {
#line 227 "../lib/sudoku-saver.vala"
								break;
#line 1442 "sudoku-saver.c"
							}
#line 229 "../lib/sudoku-saver.vala"
							_tmp43_ = reader;
#line 229 "../lib/sudoku-saver.vala"
							json_reader_read_element (_tmp43_, (guint) k);
#line 230 "../lib/sudoku-saver.vala"
							_tmp44_ = reader;
#line 230 "../lib/sudoku-saver.vala"
							g_return_val_if_fail (json_reader_is_value (_tmp44_), NULL);
#line 231 "../lib/sudoku-saver.vala"
							_tmp45_ = reader;
#line 231 "../lib/sudoku-saver.vala"
							earmark = (gint) json_reader_get_int_value (_tmp45_);
#line 232 "../lib/sudoku-saver.vala"
							if (earmark > 0) {
#line 232 "../lib/sudoku-saver.vala"
								_tmp47_ = earmark < 10;
#line 1460 "sudoku-saver.c"
							} else {
#line 232 "../lib/sudoku-saver.vala"
								_tmp47_ = FALSE;
#line 1464 "sudoku-saver.c"
							}
#line 232 "../lib/sudoku-saver.vala"
							if (_tmp47_) {
#line 1468 "sudoku-saver.c"
								SudokuBoard* _tmp48_;
#line 233 "../lib/sudoku-saver.vala"
								_tmp48_ = board;
#line 233 "../lib/sudoku-saver.vala"
								_tmp46_ = !sudoku_board_is_earmark_enabled (_tmp48_, row, col, earmark);
#line 1474 "sudoku-saver.c"
							} else {
#line 232 "../lib/sudoku-saver.vala"
								_tmp46_ = FALSE;
#line 1478 "sudoku-saver.c"
							}
#line 232 "../lib/sudoku-saver.vala"
							g_return_val_if_fail (_tmp46_, NULL);
#line 235 "../lib/sudoku-saver.vala"
							_tmp49_ = board;
#line 235 "../lib/sudoku-saver.vala"
							sudoku_board_enable_earmark (_tmp49_, row, col, earmark);
#line 236 "../lib/sudoku-saver.vala"
							_tmp50_ = reader;
#line 236 "../lib/sudoku-saver.vala"
							json_reader_end_element (_tmp50_);
#line 1490 "sudoku-saver.c"
						}
					}
				}
#line 238 "../lib/sudoku-saver.vala"
				_tmp51_ = reader;
#line 238 "../lib/sudoku-saver.vala"
				json_reader_end_member (_tmp51_);
#line 240 "../lib/sudoku-saver.vala"
				_tmp52_ = reader;
#line 240 "../lib/sudoku-saver.vala"
				json_reader_end_element (_tmp52_);
#line 1502 "sudoku-saver.c"
			}
		}
	}
#line 242 "../lib/sudoku-saver.vala"
	_tmp53_ = reader;
#line 242 "../lib/sudoku-saver.vala"
	json_reader_end_member (_tmp53_);
#line 244 "../lib/sudoku-saver.vala"
	_tmp54_ = reader;
#line 244 "../lib/sudoku-saver.vala"
	json_reader_read_member (_tmp54_, "time_elapsed");
#line 245 "../lib/sudoku-saver.vala"
	_tmp55_ = reader;
#line 245 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (json_reader_is_value (_tmp55_), NULL);
#line 246 "../lib/sudoku-saver.vala"
	_tmp56_ = board;
#line 246 "../lib/sudoku-saver.vala"
	_tmp57_ = reader;
#line 246 "../lib/sudoku-saver.vala"
	sudoku_board_set_previous_played_time (_tmp56_, json_reader_get_double_value (_tmp57_));
#line 247 "../lib/sudoku-saver.vala"
	_tmp58_ = board;
#line 247 "../lib/sudoku-saver.vala"
	_tmp59_ = sudoku_board_get_previous_played_time (_tmp58_);
#line 247 "../lib/sudoku-saver.vala"
	_tmp60_ = _tmp59_;
#line 247 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (_tmp60_ >= ((gdouble) 0), NULL);
#line 248 "../lib/sudoku-saver.vala"
	_tmp61_ = reader;
#line 248 "../lib/sudoku-saver.vala"
	json_reader_end_member (_tmp61_);
#line 250 "../lib/sudoku-saver.vala"
	_tmp62_ = reader;
#line 250 "../lib/sudoku-saver.vala"
	json_reader_read_member (_tmp62_, "difficulty_category");
#line 251 "../lib/sudoku-saver.vala"
	_tmp63_ = reader;
#line 251 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (json_reader_is_value (_tmp63_), NULL);
#line 252 "../lib/sudoku-saver.vala"
	_tmp64_ = board;
#line 252 "../lib/sudoku-saver.vala"
	_tmp65_ = reader;
#line 252 "../lib/sudoku-saver.vala"
	_tmp66_ = json_reader_get_string_value (_tmp65_);
#line 252 "../lib/sudoku-saver.vala"
	sudoku_board_set_difficulty_category (_tmp64_, difficulty_category_from_string (_tmp66_));
#line 253 "../lib/sudoku-saver.vala"
	_tmp67_ = board;
#line 253 "../lib/sudoku-saver.vala"
	_tmp68_ = sudoku_board_get_difficulty_category (_tmp67_);
#line 253 "../lib/sudoku-saver.vala"
	_tmp69_ = _tmp68_;
#line 253 "../lib/sudoku-saver.vala"
	g_return_val_if_fail (_tmp69_ != DIFFICULTY_CATEGORY_UNKNOWN, NULL);
#line 254 "../lib/sudoku-saver.vala"
	_tmp70_ = reader;
#line 254 "../lib/sudoku-saver.vala"
	json_reader_end_member (_tmp70_);
#line 256 "../lib/sudoku-saver.vala"
	_tmp71_ = board;
#line 256 "../lib/sudoku-saver.vala"
	_tmp72_ = sudoku_game_new (_tmp71_);
#line 256 "../lib/sudoku-saver.vala"
	result = _tmp72_;
#line 256 "../lib/sudoku-saver.vala"
	_g_object_unref0 (reader);
#line 256 "../lib/sudoku-saver.vala"
	__vala_JsonNode_free0 (node);
#line 256 "../lib/sudoku-saver.vala"
	_g_object_unref0 (board);
#line 256 "../lib/sudoku-saver.vala"
	_g_object_unref0 (parser);
#line 256 "../lib/sudoku-saver.vala"
	return result;
#line 1580 "sudoku-saver.c"
}

const gchar*
sudoku_saver_get_savegame_file (void)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver__savegame_file;
#line 26 "../lib/sudoku-saver.vala"
	result = _tmp0_;
#line 26 "../lib/sudoku-saver.vala"
	return result;
#line 1594 "sudoku-saver.c"
}

static void
sudoku_saver_set_savegame_file (const gchar* value)
{
	gchar* _tmp0_;
#line 26 "../lib/sudoku-saver.vala"
	_tmp0_ = g_strdup (value);
#line 26 "../lib/sudoku-saver.vala"
	_g_free0 (sudoku_saver__savegame_file);
#line 26 "../lib/sudoku-saver.vala"
	sudoku_saver__savegame_file = _tmp0_;
#line 1607 "sudoku-saver.c"
}

const gchar*
sudoku_saver_get_finishgame_dir (void)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../lib/sudoku-saver.vala"
	_tmp0_ = sudoku_saver__finishgame_dir;
#line 27 "../lib/sudoku-saver.vala"
	result = _tmp0_;
#line 27 "../lib/sudoku-saver.vala"
	return result;
#line 1621 "sudoku-saver.c"
}

static void
sudoku_saver_set_finishgame_dir (const gchar* value)
{
	gchar* _tmp0_;
#line 27 "../lib/sudoku-saver.vala"
	_tmp0_ = g_strdup (value);
#line 27 "../lib/sudoku-saver.vala"
	_g_free0 (sudoku_saver__finishgame_dir);
#line 27 "../lib/sudoku-saver.vala"
	sudoku_saver__finishgame_dir = _tmp0_;
#line 1634 "sudoku-saver.c"
}

static void
sudoku_saver_class_init (SudokuSaverClass * klass,
                         gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 24 "../lib/sudoku-saver.vala"
	sudoku_saver_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/sudoku-saver.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_saver_get_property;
#line 24 "../lib/sudoku-saver.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_saver_set_property;
#line 24 "../lib/sudoku-saver.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_saver_finalize;
#line 26 "../lib/sudoku-saver.vala"
	_tmp0_ = g_strdup ("");
#line 26 "../lib/sudoku-saver.vala"
	sudoku_saver__savegame_file = _tmp0_;
#line 27 "../lib/sudoku-saver.vala"
	_tmp1_ = g_strdup ("");
#line 27 "../lib/sudoku-saver.vala"
	sudoku_saver__finishgame_dir = _tmp1_;
#line 1659 "sudoku-saver.c"
}

static void
sudoku_saver_instance_init (SudokuSaver * self,
                            gpointer klass)
{
}

static void
sudoku_saver_finalize (GObject * obj)
{
	SudokuSaver * self;
#line 24 "../lib/sudoku-saver.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_SAVER, SudokuSaver);
#line 24 "../lib/sudoku-saver.vala"
	G_OBJECT_CLASS (sudoku_saver_parent_class)->finalize (obj);
#line 1676 "sudoku-saver.c"
}

static GType
sudoku_saver_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuSaverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_saver_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuSaver), 0, (GInstanceInitFunc) sudoku_saver_instance_init, NULL };
	GType sudoku_saver_type_id;
	sudoku_saver_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuSaver", &g_define_type_info, 0);
	return sudoku_saver_type_id;
}

GType
sudoku_saver_get_type (void)
{
	static volatile gsize sudoku_saver_type_id__once = 0;
	if (g_once_init_enter (&sudoku_saver_type_id__once)) {
		GType sudoku_saver_type_id;
		sudoku_saver_type_id = sudoku_saver_get_type_once ();
		g_once_init_leave (&sudoku_saver_type_id__once, sudoku_saver_type_id);
	}
	return sudoku_saver_type_id__once;
}

static void
_vala_sudoku_saver_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	SudokuSaver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_SAVER, SudokuSaver);
#line 24 "../lib/sudoku-saver.vala"
	switch (property_id) {
#line 1710 "sudoku-saver.c"
		default:
#line 24 "../lib/sudoku-saver.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-saver.vala"
		break;
#line 1716 "sudoku-saver.c"
	}
}

static void
_vala_sudoku_saver_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	SudokuSaver * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_SAVER, SudokuSaver);
#line 24 "../lib/sudoku-saver.vala"
	switch (property_id) {
#line 1730 "sudoku-saver.c"
		default:
#line 24 "../lib/sudoku-saver.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-saver.vala"
		break;
#line 1736 "sudoku-saver.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

