/* cell.c generated by valac 0.56.18, the Vala compiler
 * generated from cell.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <adwaita.h>
#include <glib.h>
#include "libsudoku.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
typedef struct _SudokuCellPrivate SudokuCellPrivate;

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
enum  {
	SUDOKU_CELL_0_PROPERTY,
	SUDOKU_CELL_ROW_PROPERTY,
	SUDOKU_CELL_COL_PROPERTY,
	SUDOKU_CELL_VALUE_PROPERTY,
	SUDOKU_CELL_IS_FIXED_PROPERTY,
	SUDOKU_CELL_SELECTED_PROPERTY,
	SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY,
	SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY,
	SUDOKU_CELL_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_properties[SUDOKU_CELL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SudokuViewPrivate SudokuViewPrivate;

#define TYPE_SUDOKU_NUMBER_PICKER (sudoku_number_picker_get_type ())
#define SUDOKU_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPicker))
#define SUDOKU_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPickerClass))
#define IS_SUDOKU_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_NUMBER_PICKER))
#define IS_SUDOKU_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_NUMBER_PICKER))
#define SUDOKU_NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPickerClass))

typedef struct _SudokuNumberPicker SudokuNumberPicker;
typedef struct _SudokuNumberPickerClass SudokuNumberPickerClass;
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
	SudokuView* view;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

struct _SudokuCellPrivate {
	gint _row;
	gint _col;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	GtkLabel* value_label;
	GtkLabel** earmark_labels;
	gint earmark_labels_length1;
	gint _earmark_labels_size_;
	gboolean _selected;
	gboolean _highlight_coord;
	gboolean _highlight_number;
};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	SudokuNumberPicker* number_picker;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

static gint SudokuCell_private_offset;
static gpointer sudoku_cell_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame* game,
                             SudokuView* view);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame* game,
                                   SudokuView* view);
static void sudoku_cell_set_row (SudokuCell* self,
                          gint value);
static void sudoku_cell_set_col (SudokuCell* self,
                          gint value);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
static void sudoku_cell_focus_changed_cb (SudokuCell* self);
static void _sudoku_cell_focus_changed_cb_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void sudoku_cell_paused_cb (SudokuCell* self);
static void _sudoku_cell_paused_cb_g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self);
static void sudoku_cell_set_fixed_css (SudokuCell* self,
                                gboolean enabled);
static void sudoku_cell_button_released_cb (SudokuCell* self,
                                     GtkGestureClick* gesture,
                                     gint n_press,
                                     gdouble x,
                                     gdouble y);
static void _sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static void sudoku_cell_long_press_cb (SudokuCell* self,
                                GtkGestureLongPress* gesture,
                                gdouble x,
                                gdouble y);
static void _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN void sudoku_cell_update_content_visibility (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_earmark_visibility (SudokuCell* self,
                                            gint num);
VALA_EXTERN gboolean sudoku_view_get_number_picker_second_click (SudokuView* self);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN gboolean sudoku_view_get_earmark_mode (SudokuView* self);
VALA_EXTERN GType sudoku_number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuNumberPicker, g_object_unref)
VALA_EXTERN void sudoku_number_picker_show_value_picker (SudokuNumberPicker* self,
                                             SudokuCell* cell);
VALA_EXTERN void sudoku_number_picker_show_earmark_picker (SudokuNumberPicker* self,
                                               SudokuCell* cell);
VALA_EXTERN void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN gint sudoku_cell_get_row (SudokuCell* self);
VALA_EXTERN gint sudoku_cell_get_col (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_value_warnings (SudokuCell* self);
VALA_EXTERN gboolean sudoku_view_get_solution_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_update_all_earmark_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_earmark_warnings (SudokuCell* self,
                                          gint num);
VALA_EXTERN gboolean sudoku_view_get_show_earmark_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
static void sudoku_cell_real_size_allocate (GtkWidget* base,
                                     gint width,
                                     gint height,
                                     gint baseline);
VALA_EXTERN gdouble sudoku_view_get_value_zoom_multiplier (SudokuView* self);
static void sudoku_cell_set_font_size (SudokuCell* self,
                                GtkLabel* label,
                                gint font_size);
static void sudoku_cell_real_dispose (GObject* base);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
VALA_EXTERN gboolean sudoku_view_get_autoclean_earmarks (SudokuView* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlight_coord (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlight_coord (SudokuCell* self,
                                      gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlight_number (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlight_number (SudokuCell* self,
                                       gboolean value);
static void sudoku_cell_finalize (GObject * obj);
static GType sudoku_cell_get_type_once (void);
static void _vala_sudoku_cell_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_cell_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_cell_get_instance_private (SudokuCell* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCell_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 43 "../src/cell.vala"
	return self ? g_object_ref (self) : NULL;
#line 263 "cell.c"
}

static void
_sudoku_cell_focus_changed_cb_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 53 "../src/cell.vala"
	sudoku_cell_focus_changed_cb ((SudokuCell*) self);
#line 273 "cell.c"
}

static void
_sudoku_cell_paused_cb_g_object_notify (GObject* _sender,
                                        GParamSpec* pspec,
                                        gpointer self)
{
#line 54 "../src/cell.vala"
	sudoku_cell_paused_cb ((SudokuCell*) self);
#line 283 "cell.c"
}

static void
_sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
#line 60 "../src/cell.vala"
	sudoku_cell_button_released_cb ((SudokuCell*) self, _sender, n_press, x, y);
#line 295 "cell.c"
}

static void
_sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 64 "../src/cell.vala"
	sudoku_cell_long_press_cb ((SudokuCell*) self, _sender, x, y);
#line 306 "cell.c"
}

SudokuCell*
sudoku_cell_construct (GType object_type,
                       gint row,
                       gint col,
                       SudokuGame* game,
                       SudokuView* view)
{
	SudokuCell * self = NULL;
	SudokuGame* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkGestureClick* _tmp11_;
	GtkGestureClick* _tmp12_;
	GtkGestureClick* _tmp13_;
	GtkGestureClick* _tmp14_;
	GtkEventController* _tmp15_;
	GtkGestureLongPress* _tmp16_;
	GtkGestureLongPress* _tmp17_;
	GtkGestureLongPress* _tmp18_;
	GtkEventController* _tmp19_;
	GtkLabel** _tmp20_;
#line 37 "../src/cell.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 37 "../src/cell.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 37 "../src/cell.vala"
	self = (SudokuCell*) g_object_new (object_type, NULL);
#line 39 "../src/cell.vala"
	gtk_widget_class_set_accessible_role (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), GTK_ACCESSIBLE_ROLE_BUTTON);
#line 41 "../src/cell.vala"
	sudoku_cell_set_row (self, row);
#line 42 "../src/cell.vala"
	sudoku_cell_set_col (self, col);
#line 43 "../src/cell.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 43 "../src/cell.vala"
	_g_object_unref0 (self->priv->game);
#line 43 "../src/cell.vala"
	self->priv->game = _tmp0_;
#line 44 "../src/cell.vala"
	self->view = view;
#line 46 "../src/cell.vala"
	_tmp1_ = sudoku_cell_get_value (self);
#line 46 "../src/cell.vala"
	_tmp2_ = _tmp1_;
#line 46 "../src/cell.vala"
	_tmp3_ = g_strdup_printf ("%i", _tmp2_);
#line 46 "../src/cell.vala"
	_tmp4_ = _tmp3_;
#line 46 "../src/cell.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
#line 46 "../src/cell.vala"
	g_object_ref_sink (_tmp5_);
#line 46 "../src/cell.vala"
	_g_object_unref0 (self->priv->value_label);
#line 46 "../src/cell.vala"
	self->priv->value_label = _tmp5_;
#line 46 "../src/cell.vala"
	_g_free0 (_tmp4_);
#line 47 "../src/cell.vala"
	_tmp6_ = self->priv->value_label;
#line 47 "../src/cell.vala"
	_tmp7_ = sudoku_cell_get_value (self);
#line 47 "../src/cell.vala"
	_tmp8_ = _tmp7_;
#line 47 "../src/cell.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, _tmp8_ != 0);
#line 48 "../src/cell.vala"
	_tmp9_ = self->priv->value_label;
#line 48 "../src/cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp9_, (GtkWidget*) self);
#line 49 "../src/cell.vala"
	_tmp10_ = self->priv->value_label;
#line 49 "../src/cell.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp10_, "value");
#line 51 "../src/cell.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 52 "../src/cell.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 53 "../src/cell.vala"
	g_signal_connect_object ((GObject*) self, "notify::has-focus", (GCallback) _sudoku_cell_focus_changed_cb_g_object_notify, self, 0);
#line 54 "../src/cell.vala"
	g_signal_connect_object ((GObject*) game, "notify::paused", (GCallback) _sudoku_cell_paused_cb_g_object_notify, self, 0);
#line 56 "../src/cell.vala"
	sudoku_cell_set_fixed_css (self, TRUE);
#line 58 "../src/cell.vala"
	_tmp11_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 58 "../src/cell.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 58 "../src/cell.vala"
	self->priv->button_controller = _tmp11_;
#line 59 "../src/cell.vala"
	_tmp12_ = self->priv->button_controller;
#line 59 "../src/cell.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp12_, (guint) 0);
#line 60 "../src/cell.vala"
	_tmp13_ = self->priv->button_controller;
#line 60 "../src/cell.vala"
	g_signal_connect_object (_tmp13_, "released", (GCallback) _sudoku_cell_button_released_cb_gtk_gesture_click_released, self, 0);
#line 61 "../src/cell.vala"
	_tmp14_ = self->priv->button_controller;
#line 61 "../src/cell.vala"
	_tmp15_ = _g_object_ref0 ((GtkEventController*) _tmp14_);
#line 61 "../src/cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp15_);
#line 63 "../src/cell.vala"
	_tmp16_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
#line 63 "../src/cell.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 63 "../src/cell.vala"
	self->priv->long_press_controller = _tmp16_;
#line 64 "../src/cell.vala"
	_tmp17_ = self->priv->long_press_controller;
#line 64 "../src/cell.vala"
	g_signal_connect_object (_tmp17_, "pressed", (GCallback) _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
#line 65 "../src/cell.vala"
	_tmp18_ = self->priv->long_press_controller;
#line 65 "../src/cell.vala"
	_tmp19_ = _g_object_ref0 ((GtkEventController*) _tmp18_);
#line 65 "../src/cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp19_);
#line 67 "../src/cell.vala"
	_tmp20_ = g_new0 (GtkLabel*, 9 + 1);
#line 67 "../src/cell.vala"
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 67 "../src/cell.vala"
	self->priv->earmark_labels = _tmp20_;
#line 67 "../src/cell.vala"
	self->priv->earmark_labels_length1 = 9;
#line 67 "../src/cell.vala"
	self->priv->_earmark_labels_size_ = self->priv->earmark_labels_length1;
#line 448 "cell.c"
	{
		gint num = 0;
#line 68 "../src/cell.vala"
		num = 1;
#line 453 "cell.c"
		{
			gboolean _tmp21_ = FALSE;
#line 68 "../src/cell.vala"
			_tmp21_ = TRUE;
#line 68 "../src/cell.vala"
			while (TRUE) {
#line 460 "cell.c"
				GtkLabel** _tmp23_;
				gint _tmp23__length1;
				gchar* _tmp24_;
				gchar* _tmp25_;
				GtkLabel* _tmp26_;
				GtkLabel** _tmp27_;
				gint _tmp27__length1;
				GtkLabel* _tmp28_;
				SudokuBoard* _tmp29_;
				SudokuBoard* _tmp30_;
				GtkLabel** _tmp31_;
				gint _tmp31__length1;
				GtkLabel* _tmp32_;
				GtkLabel** _tmp33_;
				gint _tmp33__length1;
				GtkLabel* _tmp34_;
#line 68 "../src/cell.vala"
				if (!_tmp21_) {
#line 479 "cell.c"
					gint _tmp22_;
#line 68 "../src/cell.vala"
					_tmp22_ = num;
#line 68 "../src/cell.vala"
					num = _tmp22_ + 1;
#line 485 "cell.c"
				}
#line 68 "../src/cell.vala"
				_tmp21_ = FALSE;
#line 68 "../src/cell.vala"
				if (!(num < 10)) {
#line 68 "../src/cell.vala"
					break;
#line 493 "cell.c"
				}
#line 70 "../src/cell.vala"
				_tmp23_ = self->priv->earmark_labels;
#line 70 "../src/cell.vala"
				_tmp23__length1 = self->priv->earmark_labels_length1;
#line 70 "../src/cell.vala"
				_tmp24_ = g_strdup_printf ("%i", num);
#line 70 "../src/cell.vala"
				_tmp25_ = _tmp24_;
#line 70 "../src/cell.vala"
				_tmp26_ = (GtkLabel*) gtk_label_new (_tmp25_);
#line 70 "../src/cell.vala"
				g_object_ref_sink (_tmp26_);
#line 70 "../src/cell.vala"
				_g_object_unref0 (_tmp23_[num - 1]);
#line 70 "../src/cell.vala"
				_tmp23_[num - 1] = _tmp26_;
#line 70 "../src/cell.vala"
				_g_free0 (_tmp25_);
#line 71 "../src/cell.vala"
				_tmp27_ = self->priv->earmark_labels;
#line 71 "../src/cell.vala"
				_tmp27__length1 = self->priv->earmark_labels_length1;
#line 71 "../src/cell.vala"
				_tmp28_ = _tmp27_[num - 1];
#line 71 "../src/cell.vala"
				_tmp29_ = sudoku_game_get_board (game);
#line 71 "../src/cell.vala"
				_tmp30_ = _tmp29_;
#line 71 "../src/cell.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp28_, sudoku_board_is_earmark_enabled (_tmp30_, row, col, num));
#line 72 "../src/cell.vala"
				_tmp31_ = self->priv->earmark_labels;
#line 72 "../src/cell.vala"
				_tmp31__length1 = self->priv->earmark_labels_length1;
#line 72 "../src/cell.vala"
				_tmp32_ = _tmp31_[num - 1];
#line 72 "../src/cell.vala"
				gtk_widget_set_parent ((GtkWidget*) _tmp32_, (GtkWidget*) self);
#line 73 "../src/cell.vala"
				_tmp33_ = self->priv->earmark_labels;
#line 73 "../src/cell.vala"
				_tmp33__length1 = self->priv->earmark_labels_length1;
#line 73 "../src/cell.vala"
				_tmp34_ = _tmp33_[num - 1];
#line 73 "../src/cell.vala"
				gtk_widget_add_css_class ((GtkWidget*) _tmp34_, "earmark");
#line 541 "cell.c"
			}
		}
	}
#line 37 "../src/cell.vala"
	return self;
#line 547 "cell.c"
}

SudokuCell*
sudoku_cell_new (gint row,
                 gint col,
                 SudokuGame* game,
                 SudokuView* view)
{
#line 37 "../src/cell.vala"
	return sudoku_cell_construct (TYPE_SUDOKU_CELL, row, col, game, view);
#line 558 "cell.c"
}

static void
sudoku_cell_set_fixed_css (SudokuCell* self,
                           gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 103 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/cell.vala"
	_tmp0_ = sudoku_cell_get_is_fixed (self);
#line 105 "../src/cell.vala"
	_tmp1_ = _tmp0_;
#line 105 "../src/cell.vala"
	if (_tmp1_) {
#line 107 "../src/cell.vala"
		if (enabled) {
#line 108 "../src/cell.vala"
			gtk_widget_add_css_class ((GtkWidget*) self, "fixed");
#line 579 "cell.c"
		} else {
#line 110 "../src/cell.vala"
			gtk_widget_remove_css_class ((GtkWidget*) self, "fixed");
#line 583 "cell.c"
		}
	}
}

void
sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                   gint val,
                                   gboolean enabled)
{
	GtkLabel* earmark = NULL;
	GtkLabel** _tmp0_;
	gint _tmp0__length1;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 160 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/cell.vala"
	_tmp0_ = self->priv->earmark_labels;
#line 162 "../src/cell.vala"
	_tmp0__length1 = self->priv->earmark_labels_length1;
#line 162 "../src/cell.vala"
	_tmp1_ = _tmp0_[val - 1];
#line 162 "../src/cell.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 162 "../src/cell.vala"
	earmark = _tmp2_;
#line 163 "../src/cell.vala"
	if (enabled) {
#line 613 "cell.c"
		GtkLabel* _tmp4_;
#line 163 "../src/cell.vala"
		_tmp4_ = earmark;
#line 163 "../src/cell.vala"
		_tmp3_ = !gtk_widget_has_css_class ((GtkWidget*) _tmp4_, "error");
#line 619 "cell.c"
	} else {
#line 163 "../src/cell.vala"
		_tmp3_ = FALSE;
#line 623 "cell.c"
	}
#line 163 "../src/cell.vala"
	if (_tmp3_) {
#line 627 "cell.c"
		GtkLabel* _tmp5_;
#line 164 "../src/cell.vala"
		_tmp5_ = earmark;
#line 164 "../src/cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp5_, "highlight-number");
#line 633 "cell.c"
	} else {
		GtkLabel* _tmp6_;
#line 166 "../src/cell.vala"
		_tmp6_ = earmark;
#line 166 "../src/cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp6_, "highlight-number");
#line 640 "cell.c"
	}
#line 160 "../src/cell.vala"
	_g_object_unref0 (earmark);
#line 644 "cell.c"
}

void
sudoku_cell_update_content_visibility (SudokuCell* self)
{
	GtkLabel* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 169 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/cell.vala"
	_tmp0_ = self->priv->value_label;
#line 171 "../src/cell.vala"
	_tmp1_ = sudoku_cell_get_value (self);
#line 171 "../src/cell.vala"
	_tmp2_ = _tmp1_;
#line 171 "../src/cell.vala"
	_tmp3_ = g_strdup_printf ("%i", _tmp2_);
#line 171 "../src/cell.vala"
	_tmp4_ = _tmp3_;
#line 171 "../src/cell.vala"
	gtk_label_set_label (_tmp0_, _tmp4_);
#line 171 "../src/cell.vala"
	_g_free0 (_tmp4_);
#line 172 "../src/cell.vala"
	_tmp5_ = self->priv->value_label;
#line 172 "../src/cell.vala"
	_tmp6_ = sudoku_cell_get_value (self);
#line 172 "../src/cell.vala"
	_tmp7_ = _tmp6_;
#line 172 "../src/cell.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, _tmp7_ != 0);
#line 682 "cell.c"
	{
		gint num = 0;
#line 173 "../src/cell.vala"
		num = 1;
#line 687 "cell.c"
		{
			gboolean _tmp8_ = FALSE;
#line 173 "../src/cell.vala"
			_tmp8_ = TRUE;
#line 173 "../src/cell.vala"
			while (TRUE) {
#line 173 "../src/cell.vala"
				if (!_tmp8_) {
#line 696 "cell.c"
					gint _tmp9_;
#line 173 "../src/cell.vala"
					_tmp9_ = num;
#line 173 "../src/cell.vala"
					num = _tmp9_ + 1;
#line 702 "cell.c"
				}
#line 173 "../src/cell.vala"
				_tmp8_ = FALSE;
#line 173 "../src/cell.vala"
				if (!(num <= 9)) {
#line 173 "../src/cell.vala"
					break;
#line 710 "cell.c"
				}
#line 174 "../src/cell.vala"
				sudoku_cell_update_earmark_visibility (self, num);
#line 714 "cell.c"
			}
		}
	}
}

static void
sudoku_cell_button_released_cb (SudokuCell* self,
                                GtkGestureClick* gesture,
                                gint n_press,
                                gdouble x,
                                gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	SudokuView* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GdkModifierType state = 0U;
	gboolean control_pressed = FALSE;
	gboolean wants_value = FALSE;
	SudokuView* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
#line 177 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 177 "../src/cell.vala"
	g_return_if_fail (gesture != NULL);
#line 182 "../src/cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 183 "../src/cell.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
#line 748 "cell.c"
	} else {
#line 182 "../src/cell.vala"
		_tmp0_ = FALSE;
#line 752 "cell.c"
	}
#line 182 "../src/cell.vala"
	if (_tmp0_) {
#line 184 "../src/cell.vala"
		return;
#line 758 "cell.c"
	}
#line 186 "../src/cell.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 188 "../src/cell.vala"
	_tmp4_ = self->view;
#line 188 "../src/cell.vala"
	_tmp5_ = sudoku_view_get_number_picker_second_click (_tmp4_);
#line 188 "../src/cell.vala"
	_tmp6_ = _tmp5_;
#line 188 "../src/cell.vala"
	if (_tmp6_) {
#line 770 "cell.c"
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 188 "../src/cell.vala"
		_tmp7_ = sudoku_cell_get_selected (self);
#line 188 "../src/cell.vala"
		_tmp8_ = _tmp7_;
#line 188 "../src/cell.vala"
		_tmp3_ = !_tmp8_;
#line 779 "cell.c"
	} else {
#line 188 "../src/cell.vala"
		_tmp3_ = FALSE;
#line 783 "cell.c"
	}
#line 188 "../src/cell.vala"
	if (_tmp3_) {
#line 188 "../src/cell.vala"
		_tmp2_ = TRUE;
#line 789 "cell.c"
	} else {
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 189 "../src/cell.vala"
		_tmp9_ = sudoku_cell_get_is_fixed (self);
#line 189 "../src/cell.vala"
		_tmp10_ = _tmp9_;
#line 189 "../src/cell.vala"
		_tmp2_ = _tmp10_;
#line 799 "cell.c"
	}
#line 188 "../src/cell.vala"
	if (_tmp2_) {
#line 188 "../src/cell.vala"
		_tmp1_ = TRUE;
#line 805 "cell.c"
	} else {
		SudokuGame* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
#line 189 "../src/cell.vala"
		_tmp11_ = self->priv->game;
#line 189 "../src/cell.vala"
		_tmp12_ = sudoku_game_get_paused (_tmp11_);
#line 189 "../src/cell.vala"
		_tmp13_ = _tmp12_;
#line 189 "../src/cell.vala"
		_tmp1_ = _tmp13_;
#line 818 "cell.c"
	}
#line 188 "../src/cell.vala"
	if (_tmp1_) {
#line 191 "../src/cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 192 "../src/cell.vala"
		return;
#line 826 "cell.c"
	}
#line 195 "../src/cell.vala"
	gtk_widget_grab_focus ((GtkWidget*) self);
#line 199 "../src/cell.vala"
	state = gtk_event_controller_get_current_event_state ((GtkEventController*) gesture);
#line 200 "../src/cell.vala"
	control_pressed = (gboolean) (state & GDK_CONTROL_MASK);
#line 201 "../src/cell.vala"
	wants_value = !control_pressed;
#line 202 "../src/cell.vala"
	_tmp14_ = self->view;
#line 202 "../src/cell.vala"
	_tmp15_ = sudoku_view_get_earmark_mode (_tmp14_);
#line 202 "../src/cell.vala"
	_tmp16_ = _tmp15_;
#line 202 "../src/cell.vala"
	wants_value = wants_value ^ _tmp16_;
#line 204 "../src/cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_PRIMARY)) {
#line 206 "../src/cell.vala"
		if (wants_value) {
#line 848 "cell.c"
			SudokuView* _tmp17_;
			SudokuNumberPicker* _tmp18_;
#line 207 "../src/cell.vala"
			_tmp17_ = self->view;
#line 207 "../src/cell.vala"
			_tmp18_ = _tmp17_->number_picker;
#line 207 "../src/cell.vala"
			sudoku_number_picker_show_value_picker (_tmp18_, self);
#line 857 "cell.c"
		} else {
			SudokuGame* _tmp19_;
			GameMode _tmp20_;
			GameMode _tmp21_;
#line 208 "../src/cell.vala"
			_tmp19_ = self->priv->game;
#line 208 "../src/cell.vala"
			_tmp20_ = sudoku_game_get_mode (_tmp19_);
#line 208 "../src/cell.vala"
			_tmp21_ = _tmp20_;
#line 208 "../src/cell.vala"
			if (_tmp21_ == GAME_MODE_PLAY) {
#line 870 "cell.c"
				SudokuView* _tmp22_;
				SudokuNumberPicker* _tmp23_;
#line 209 "../src/cell.vala"
				_tmp22_ = self->view;
#line 209 "../src/cell.vala"
				_tmp23_ = _tmp22_->number_picker;
#line 209 "../src/cell.vala"
				sudoku_number_picker_show_earmark_picker (_tmp23_, self);
#line 879 "cell.c"
			}
		}
	} else {
#line 211 "../src/cell.vala"
		if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_SECONDARY)) {
#line 213 "../src/cell.vala"
			if (!wants_value) {
#line 887 "cell.c"
				SudokuView* _tmp24_;
				SudokuNumberPicker* _tmp25_;
#line 214 "../src/cell.vala"
				_tmp24_ = self->view;
#line 214 "../src/cell.vala"
				_tmp25_ = _tmp24_->number_picker;
#line 214 "../src/cell.vala"
				sudoku_number_picker_show_value_picker (_tmp25_, self);
#line 896 "cell.c"
			} else {
				SudokuGame* _tmp26_;
				GameMode _tmp27_;
				GameMode _tmp28_;
#line 215 "../src/cell.vala"
				_tmp26_ = self->priv->game;
#line 215 "../src/cell.vala"
				_tmp27_ = sudoku_game_get_mode (_tmp26_);
#line 215 "../src/cell.vala"
				_tmp28_ = _tmp27_;
#line 215 "../src/cell.vala"
				if (_tmp28_ == GAME_MODE_PLAY) {
#line 909 "cell.c"
					SudokuView* _tmp29_;
					SudokuNumberPicker* _tmp30_;
#line 216 "../src/cell.vala"
					_tmp29_ = self->view;
#line 216 "../src/cell.vala"
					_tmp30_ = _tmp29_->number_picker;
#line 216 "../src/cell.vala"
					sudoku_number_picker_show_earmark_picker (_tmp30_, self);
#line 918 "cell.c"
				}
			}
		}
	}
}

static void
sudoku_cell_long_press_cb (SudokuCell* self,
                           GtkGestureLongPress* gesture,
                           gdouble x,
                           gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp7_ = FALSE;
	SudokuGame* _tmp8_;
	GameMode _tmp9_;
	GameMode _tmp10_;
#line 220 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/cell.vala"
	g_return_if_fail (gesture != NULL);
#line 224 "../src/cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 225 "../src/cell.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
#line 947 "cell.c"
	} else {
#line 224 "../src/cell.vala"
		_tmp0_ = FALSE;
#line 951 "cell.c"
	}
#line 224 "../src/cell.vala"
	if (_tmp0_) {
#line 226 "../src/cell.vala"
		return;
#line 957 "cell.c"
	}
#line 228 "../src/cell.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 229 "../src/cell.vala"
	gtk_widget_grab_focus ((GtkWidget*) self);
#line 231 "../src/cell.vala"
	_tmp2_ = sudoku_cell_get_is_fixed (self);
#line 231 "../src/cell.vala"
	_tmp3_ = _tmp2_;
#line 231 "../src/cell.vala"
	if (_tmp3_) {
#line 231 "../src/cell.vala"
		_tmp1_ = TRUE;
#line 971 "cell.c"
	} else {
		SudokuGame* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 231 "../src/cell.vala"
		_tmp4_ = self->priv->game;
#line 231 "../src/cell.vala"
		_tmp5_ = sudoku_game_get_paused (_tmp4_);
#line 231 "../src/cell.vala"
		_tmp6_ = _tmp5_;
#line 231 "../src/cell.vala"
		_tmp1_ = _tmp6_;
#line 984 "cell.c"
	}
#line 231 "../src/cell.vala"
	if (_tmp1_) {
#line 232 "../src/cell.vala"
		return;
#line 990 "cell.c"
	}
#line 234 "../src/cell.vala"
	_tmp8_ = self->priv->game;
#line 234 "../src/cell.vala"
	_tmp9_ = sudoku_game_get_mode (_tmp8_);
#line 234 "../src/cell.vala"
	_tmp10_ = _tmp9_;
#line 234 "../src/cell.vala"
	if (_tmp10_ == GAME_MODE_CREATE) {
#line 234 "../src/cell.vala"
		_tmp7_ = TRUE;
#line 1002 "cell.c"
	} else {
		SudokuView* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
#line 234 "../src/cell.vala"
		_tmp11_ = self->view;
#line 234 "../src/cell.vala"
		_tmp12_ = sudoku_view_get_earmark_mode (_tmp11_);
#line 234 "../src/cell.vala"
		_tmp13_ = _tmp12_;
#line 234 "../src/cell.vala"
		_tmp7_ = _tmp13_;
#line 1015 "cell.c"
	}
#line 234 "../src/cell.vala"
	if (_tmp7_) {
#line 1019 "cell.c"
		SudokuView* _tmp14_;
		SudokuNumberPicker* _tmp15_;
#line 235 "../src/cell.vala"
		_tmp14_ = self->view;
#line 235 "../src/cell.vala"
		_tmp15_ = _tmp14_->number_picker;
#line 235 "../src/cell.vala"
		sudoku_number_picker_show_value_picker (_tmp15_, self);
#line 1028 "cell.c"
	} else {
		SudokuView* _tmp16_;
		SudokuNumberPicker* _tmp17_;
#line 237 "../src/cell.vala"
		_tmp16_ = self->view;
#line 237 "../src/cell.vala"
		_tmp17_ = _tmp16_->number_picker;
#line 237 "../src/cell.vala"
		sudoku_number_picker_show_earmark_picker (_tmp17_, self);
#line 1038 "cell.c"
	}
}

static void
sudoku_cell_focus_changed_cb (SudokuCell* self)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 240 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/cell.vala"
	_tmp0_ = self->priv->game;
#line 242 "../src/cell.vala"
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
#line 242 "../src/cell.vala"
	_tmp2_ = _tmp1_;
#line 242 "../src/cell.vala"
	if (_tmp2_) {
#line 243 "../src/cell.vala"
		return;
#line 1062 "cell.c"
	}
#line 245 "../src/cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp3_, NULL);
#line 245 "../src/cell.vala"
	_tmp4_ = _tmp3_;
#line 245 "../src/cell.vala"
	if (_tmp4_) {
#line 1070 "cell.c"
		SudokuView* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 246 "../src/cell.vala"
		_tmp5_ = self->view;
#line 246 "../src/cell.vala"
		_tmp6_ = self->priv->_row;
#line 246 "../src/cell.vala"
		_tmp7_ = self->priv->_col;
#line 246 "../src/cell.vala"
		sudoku_view_set_selected (_tmp5_, _tmp6_, _tmp7_);
#line 1082 "cell.c"
	}
}

static void
sudoku_cell_paused_cb (SudokuCell* self)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 249 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 251 "../src/cell.vala"
	_tmp0_ = self->priv->game;
#line 251 "../src/cell.vala"
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
#line 251 "../src/cell.vala"
	_tmp2_ = _tmp1_;
#line 251 "../src/cell.vala"
	if (_tmp2_) {
#line 252 "../src/cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "paused");
#line 1104 "cell.c"
	} else {
#line 254 "../src/cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "paused");
#line 1108 "cell.c"
	}
}

void
sudoku_cell_update_earmark_visibility (SudokuCell* self,
                                       gint num)
{
	GtkLabel** _tmp0_;
	gint _tmp0__length1;
	GtkLabel* _tmp1_;
	SudokuGame* _tmp2_;
	SudokuBoard* _tmp3_;
	SudokuBoard* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
#line 257 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 259 "../src/cell.vala"
	_tmp0_ = self->priv->earmark_labels;
#line 259 "../src/cell.vala"
	_tmp0__length1 = self->priv->earmark_labels_length1;
#line 259 "../src/cell.vala"
	_tmp1_ = _tmp0_[num - 1];
#line 259 "../src/cell.vala"
	_tmp2_ = self->priv->game;
#line 259 "../src/cell.vala"
	_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 259 "../src/cell.vala"
	_tmp4_ = _tmp3_;
#line 259 "../src/cell.vala"
	_tmp5_ = self->priv->_row;
#line 259 "../src/cell.vala"
	_tmp6_ = self->priv->_col;
#line 259 "../src/cell.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, sudoku_board_is_earmark_enabled (_tmp4_, _tmp5_, _tmp6_, num));
#line 1144 "cell.c"
}

void
sudoku_cell_update_value_warnings (SudokuCell* self)
{
	gboolean _error_ = FALSE;
	gint _tmp0_;
	gint _tmp1_;
#line 262 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/cell.vala"
	_error_ = FALSE;
#line 266 "../src/cell.vala"
	_tmp0_ = sudoku_cell_get_value (self);
#line 266 "../src/cell.vala"
	_tmp1_ = _tmp0_;
#line 266 "../src/cell.vala"
	if (_tmp1_ != 0) {
#line 1163 "cell.c"
		SudokuGame* _tmp2_;
		SudokuBoard* _tmp3_;
		SudokuBoard* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		Coord _tmp9_ = {0};
#line 268 "../src/cell.vala"
		_tmp2_ = self->priv->game;
#line 268 "../src/cell.vala"
		_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 268 "../src/cell.vala"
		_tmp4_ = _tmp3_;
#line 268 "../src/cell.vala"
		_tmp5_ = sudoku_board_get_broken_coords (_tmp4_);
#line 268 "../src/cell.vala"
		_tmp6_ = _tmp5_;
#line 268 "../src/cell.vala"
		_tmp7_ = self->priv->_row;
#line 268 "../src/cell.vala"
		_tmp8_ = self->priv->_col;
#line 268 "../src/cell.vala"
		coord_init (&_tmp9_, _tmp7_, _tmp8_);
#line 268 "../src/cell.vala"
		if (gee_collection_contains ((GeeCollection*) _tmp6_, &_tmp9_)) {
#line 269 "../src/cell.vala"
			_error_ = TRUE;
#line 1192 "cell.c"
		} else {
			gboolean _tmp10_ = FALSE;
			SudokuView* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
#line 271 "../src/cell.vala"
			_tmp11_ = self->view;
#line 271 "../src/cell.vala"
			_tmp12_ = sudoku_view_get_solution_warnings (_tmp11_);
#line 271 "../src/cell.vala"
			_tmp13_ = _tmp12_;
#line 271 "../src/cell.vala"
			if (_tmp13_) {
#line 1206 "cell.c"
				SudokuGame* _tmp14_;
				GameMode _tmp15_;
				GameMode _tmp16_;
#line 271 "../src/cell.vala"
				_tmp14_ = self->priv->game;
#line 271 "../src/cell.vala"
				_tmp15_ = sudoku_game_get_mode (_tmp14_);
#line 271 "../src/cell.vala"
				_tmp16_ = _tmp15_;
#line 271 "../src/cell.vala"
				_tmp10_ = _tmp16_ == GAME_MODE_PLAY;
#line 1218 "cell.c"
			} else {
#line 271 "../src/cell.vala"
				_tmp10_ = FALSE;
#line 1222 "cell.c"
			}
#line 271 "../src/cell.vala"
			if (_tmp10_) {
#line 1226 "cell.c"
				gint solution = 0;
				SudokuGame* _tmp17_;
				SudokuBoard* _tmp18_;
				SudokuBoard* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
#line 273 "../src/cell.vala"
				_tmp17_ = self->priv->game;
#line 273 "../src/cell.vala"
				_tmp18_ = sudoku_game_get_board (_tmp17_);
#line 273 "../src/cell.vala"
				_tmp19_ = _tmp18_;
#line 273 "../src/cell.vala"
				_tmp20_ = self->priv->_row;
#line 273 "../src/cell.vala"
				_tmp21_ = self->priv->_col;
#line 273 "../src/cell.vala"
				solution = sudoku_board_get_solution (_tmp19_, _tmp20_, _tmp21_);
#line 274 "../src/cell.vala"
				if (solution != 0) {
#line 1247 "cell.c"
					gint _tmp22_;
					gint _tmp23_;
#line 275 "../src/cell.vala"
					_tmp22_ = sudoku_cell_get_value (self);
#line 275 "../src/cell.vala"
					_tmp23_ = _tmp22_;
#line 275 "../src/cell.vala"
					_error_ = _tmp23_ != solution;
#line 1256 "cell.c"
				}
			}
		}
	}
#line 279 "../src/cell.vala"
	if (_error_) {
#line 1263 "cell.c"
		GtkLabel* _tmp24_;
#line 280 "../src/cell.vala"
		_tmp24_ = self->priv->value_label;
#line 280 "../src/cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp24_, "error");
#line 1269 "cell.c"
	} else {
		GtkLabel* _tmp25_;
#line 282 "../src/cell.vala"
		_tmp25_ = self->priv->value_label;
#line 282 "../src/cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp25_, "error");
#line 1276 "cell.c"
	}
}

void
sudoku_cell_update_all_earmark_warnings (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean* marks = NULL;
	SudokuGame* _tmp6_;
	SudokuBoard* _tmp7_;
	SudokuBoard* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_ = 0;
	gboolean* _tmp12_;
	gint marks_length1;
	gint _marks_size_;
#line 285 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/cell.vala"
	_tmp1_ = sudoku_cell_get_value (self);
#line 287 "../src/cell.vala"
	_tmp2_ = _tmp1_;
#line 287 "../src/cell.vala"
	if (_tmp2_ != 0) {
#line 287 "../src/cell.vala"
		_tmp0_ = TRUE;
#line 1306 "cell.c"
	} else {
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
#line 287 "../src/cell.vala"
		_tmp3_ = self->priv->game;
#line 287 "../src/cell.vala"
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
#line 287 "../src/cell.vala"
		_tmp5_ = _tmp4_;
#line 287 "../src/cell.vala"
		_tmp0_ = _tmp5_ == GAME_MODE_CREATE;
#line 1319 "cell.c"
	}
#line 287 "../src/cell.vala"
	if (_tmp0_) {
#line 288 "../src/cell.vala"
		return;
#line 1325 "cell.c"
	}
#line 290 "../src/cell.vala"
	_tmp6_ = self->priv->game;
#line 290 "../src/cell.vala"
	_tmp7_ = sudoku_game_get_board (_tmp6_);
#line 290 "../src/cell.vala"
	_tmp8_ = _tmp7_;
#line 290 "../src/cell.vala"
	_tmp9_ = self->priv->_row;
#line 290 "../src/cell.vala"
	_tmp10_ = self->priv->_col;
#line 290 "../src/cell.vala"
	_tmp12_ = sudoku_board_get_earmarks (_tmp8_, _tmp9_, _tmp10_, &_tmp11_);
#line 290 "../src/cell.vala"
	marks = _tmp12_;
#line 290 "../src/cell.vala"
	marks_length1 = _tmp11_;
#line 290 "../src/cell.vala"
	_marks_size_ = marks_length1;
#line 1345 "cell.c"
	{
		gint num = 0;
#line 291 "../src/cell.vala"
		num = 1;
#line 1350 "cell.c"
		{
			gboolean _tmp13_ = FALSE;
#line 291 "../src/cell.vala"
			_tmp13_ = TRUE;
#line 291 "../src/cell.vala"
			while (TRUE) {
#line 1357 "cell.c"
				gboolean* _tmp15_;
				gint _tmp15__length1;
				gboolean* _tmp16_;
				gint _tmp16__length1;
				gboolean _tmp17_;
#line 291 "../src/cell.vala"
				if (!_tmp13_) {
#line 1365 "cell.c"
					gint _tmp14_;
#line 291 "../src/cell.vala"
					_tmp14_ = num;
#line 291 "../src/cell.vala"
					num = _tmp14_ + 1;
#line 1371 "cell.c"
				}
#line 291 "../src/cell.vala"
				_tmp13_ = FALSE;
#line 291 "../src/cell.vala"
				_tmp15_ = marks;
#line 291 "../src/cell.vala"
				_tmp15__length1 = marks_length1;
#line 291 "../src/cell.vala"
				if (!(num <= _tmp15__length1)) {
#line 291 "../src/cell.vala"
					break;
#line 1383 "cell.c"
				}
#line 293 "../src/cell.vala"
				_tmp16_ = marks;
#line 293 "../src/cell.vala"
				_tmp16__length1 = marks_length1;
#line 293 "../src/cell.vala"
				_tmp17_ = _tmp16_[num - 1];
#line 293 "../src/cell.vala"
				if (_tmp17_) {
#line 294 "../src/cell.vala"
					sudoku_cell_update_earmark_warnings (self, num);
#line 1395 "cell.c"
				}
			}
		}
	}
#line 285 "../src/cell.vala"
	marks = (g_free (marks), NULL);
#line 1402 "cell.c"
}

void
sudoku_cell_update_earmark_warnings (SudokuCell* self,
                                     gint num)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	SudokuBoard* _tmp2_;
	SudokuBoard* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 298 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 300 "../src/cell.vala"
	_tmp1_ = self->priv->game;
#line 300 "../src/cell.vala"
	_tmp2_ = sudoku_game_get_board (_tmp1_);
#line 300 "../src/cell.vala"
	_tmp3_ = _tmp2_;
#line 300 "../src/cell.vala"
	_tmp4_ = self->priv->_row;
#line 300 "../src/cell.vala"
	_tmp5_ = self->priv->_col;
#line 300 "../src/cell.vala"
	if (!sudoku_board_is_possible (_tmp3_, _tmp4_, _tmp5_, num)) {
#line 1429 "cell.c"
		SudokuView* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 300 "../src/cell.vala"
		_tmp6_ = self->view;
#line 300 "../src/cell.vala"
		_tmp7_ = sudoku_view_get_show_earmark_warnings (_tmp6_);
#line 300 "../src/cell.vala"
		_tmp8_ = _tmp7_;
#line 300 "../src/cell.vala"
		_tmp0_ = _tmp8_;
#line 1441 "cell.c"
	} else {
#line 300 "../src/cell.vala"
		_tmp0_ = FALSE;
#line 1445 "cell.c"
	}
#line 300 "../src/cell.vala"
	if (_tmp0_) {
#line 1449 "cell.c"
		GtkLabel** _tmp9_;
		gint _tmp9__length1;
		GtkLabel* _tmp10_;
#line 301 "../src/cell.vala"
		_tmp9_ = self->priv->earmark_labels;
#line 301 "../src/cell.vala"
		_tmp9__length1 = self->priv->earmark_labels_length1;
#line 301 "../src/cell.vala"
		_tmp10_ = _tmp9_[num - 1];
#line 301 "../src/cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp10_, "error");
#line 1461 "cell.c"
	} else {
		GtkLabel** _tmp11_;
		gint _tmp11__length1;
		GtkLabel* _tmp12_;
#line 303 "../src/cell.vala"
		_tmp11_ = self->priv->earmark_labels;
#line 303 "../src/cell.vala"
		_tmp11__length1 = self->priv->earmark_labels_length1;
#line 303 "../src/cell.vala"
		_tmp12_ = _tmp11_[num - 1];
#line 303 "../src/cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) _tmp12_, "error");
#line 1474 "cell.c"
	}
}

void
sudoku_cell_clear_warnings (SudokuCell* self)
{
	gboolean* marks = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_ = 0;
	gboolean* _tmp6_;
	gint marks_length1;
	gint _marks_size_;
	GtkLabel* _tmp7_;
#line 306 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 308 "../src/cell.vala"
	_tmp0_ = self->priv->game;
#line 308 "../src/cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 308 "../src/cell.vala"
	_tmp2_ = _tmp1_;
#line 308 "../src/cell.vala"
	_tmp3_ = self->priv->_row;
#line 308 "../src/cell.vala"
	_tmp4_ = self->priv->_col;
#line 308 "../src/cell.vala"
	_tmp6_ = sudoku_board_get_earmarks (_tmp2_, _tmp3_, _tmp4_, &_tmp5_);
#line 308 "../src/cell.vala"
	marks = _tmp6_;
#line 308 "../src/cell.vala"
	marks_length1 = _tmp5_;
#line 308 "../src/cell.vala"
	_marks_size_ = marks_length1;
#line 309 "../src/cell.vala"
	_tmp7_ = self->priv->value_label;
#line 309 "../src/cell.vala"
	gtk_widget_remove_css_class ((GtkWidget*) _tmp7_, "error");
#line 1516 "cell.c"
	{
		gint num = 0;
#line 310 "../src/cell.vala"
		num = 1;
#line 1521 "cell.c"
		{
			gboolean _tmp8_ = FALSE;
#line 310 "../src/cell.vala"
			_tmp8_ = TRUE;
#line 310 "../src/cell.vala"
			while (TRUE) {
#line 1528 "cell.c"
				gboolean* _tmp10_;
				gint _tmp10__length1;
				GtkLabel** _tmp11_;
				gint _tmp11__length1;
				GtkLabel* _tmp12_;
#line 310 "../src/cell.vala"
				if (!_tmp8_) {
#line 1536 "cell.c"
					gint _tmp9_;
#line 310 "../src/cell.vala"
					_tmp9_ = num;
#line 310 "../src/cell.vala"
					num = _tmp9_ + 1;
#line 1542 "cell.c"
				}
#line 310 "../src/cell.vala"
				_tmp8_ = FALSE;
#line 310 "../src/cell.vala"
				_tmp10_ = marks;
#line 310 "../src/cell.vala"
				_tmp10__length1 = marks_length1;
#line 310 "../src/cell.vala"
				if (!(num <= _tmp10__length1)) {
#line 310 "../src/cell.vala"
					break;
#line 1554 "cell.c"
				}
#line 311 "../src/cell.vala"
				_tmp11_ = self->priv->earmark_labels;
#line 311 "../src/cell.vala"
				_tmp11__length1 = self->priv->earmark_labels_length1;
#line 311 "../src/cell.vala"
				_tmp12_ = _tmp11_[num - 1];
#line 311 "../src/cell.vala"
				gtk_widget_remove_css_class ((GtkWidget*) _tmp12_, "error");
#line 1564 "cell.c"
			}
		}
	}
#line 306 "../src/cell.vala"
	marks = (g_free (marks), NULL);
#line 1570 "cell.c"
}

static void
sudoku_cell_real_size_allocate (GtkWidget* base,
                                gint width,
                                gint height,
                                gint baseline)
{
	SudokuCell * self;
	gint zoomed_size = 0;
	SudokuView* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GtkLabel* _tmp3_;
	GtkWidget* _tmp4_;
	SudokuView* _tmp5_;
	SudokuNumberPicker* _tmp6_;
	GtkRequisition min_size = {0};
	GtkLabel* _tmp9_;
	GtkRequisition _tmp10_ = {0};
	gint value_width = 0;
	gint value_height = 0;
	GtkRequisition _tmp11_;
	GtkRequisition _tmp12_;
	GtkAllocation value_allocation = {0};
	GtkAllocation _tmp13_ = {0};
	GtkLabel* _tmp14_;
	GtkAllocation _tmp15_;
	gint earmark_width = 0;
	gint earmark_height = 0;
	SudokuGame* _tmp16_;
	SudokuBoard* _tmp17_;
	SudokuBoard* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	SudokuGame* _tmp21_;
	SudokuBoard* _tmp22_;
	SudokuBoard* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	gint num = 0;
#line 314 "../src/cell.vala"
	self = (SudokuCell*) base;
#line 318 "../src/cell.vala"
	_tmp0_ = self->view;
#line 318 "../src/cell.vala"
	_tmp1_ = sudoku_view_get_value_zoom_multiplier (_tmp0_);
#line 318 "../src/cell.vala"
	_tmp2_ = _tmp1_;
#line 318 "../src/cell.vala"
	zoomed_size = (gint) (height * _tmp2_);
#line 319 "../src/cell.vala"
	_tmp3_ = self->priv->value_label;
#line 319 "../src/cell.vala"
	sudoku_cell_set_font_size (self, _tmp3_, zoomed_size);
#line 320 "../src/cell.vala"
	_tmp4_ = gtk_widget_get_last_child ((GtkWidget*) self);
#line 320 "../src/cell.vala"
	_tmp5_ = self->view;
#line 320 "../src/cell.vala"
	_tmp6_ = _tmp5_->number_picker;
#line 320 "../src/cell.vala"
	if (_tmp4_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget)) {
#line 1634 "cell.c"
		SudokuView* _tmp7_;
		SudokuNumberPicker* _tmp8_;
#line 321 "../src/cell.vala"
		_tmp7_ = self->view;
#line 321 "../src/cell.vala"
		_tmp8_ = _tmp7_->number_picker;
#line 321 "../src/cell.vala"
		gtk_popover_present ((GtkPopover*) _tmp8_);
#line 1643 "cell.c"
	}
#line 324 "../src/cell.vala"
	_tmp9_ = self->priv->value_label;
#line 324 "../src/cell.vala"
	gtk_widget_get_preferred_size ((GtkWidget*) _tmp9_, &_tmp10_, NULL);
#line 324 "../src/cell.vala"
	min_size = _tmp10_;
#line 327 "../src/cell.vala"
	_tmp11_ = min_size;
#line 327 "../src/cell.vala"
	value_width = MAX (width, _tmp11_.width);
#line 328 "../src/cell.vala"
	_tmp12_ = min_size;
#line 328 "../src/cell.vala"
	value_height = MAX (height, _tmp12_.height);
#line 330 "../src/cell.vala"
	_tmp13_.x = 0;
#line 330 "../src/cell.vala"
	_tmp13_.y = 0;
#line 330 "../src/cell.vala"
	_tmp13_.width = value_width;
#line 330 "../src/cell.vala"
	_tmp13_.height = value_height;
#line 330 "../src/cell.vala"
	value_allocation = _tmp13_;
#line 331 "../src/cell.vala"
	_tmp14_ = self->priv->value_label;
#line 331 "../src/cell.vala"
	_tmp15_ = value_allocation;
#line 331 "../src/cell.vala"
	gtk_widget_size_allocate ((GtkWidget*) _tmp14_, &_tmp15_, baseline);
#line 334 "../src/cell.vala"
	_tmp16_ = self->priv->game;
#line 334 "../src/cell.vala"
	_tmp17_ = sudoku_game_get_board (_tmp16_);
#line 334 "../src/cell.vala"
	_tmp18_ = _tmp17_;
#line 334 "../src/cell.vala"
	_tmp19_ = sudoku_board_get_block_cols (_tmp18_);
#line 334 "../src/cell.vala"
	_tmp20_ = _tmp19_;
#line 334 "../src/cell.vala"
	earmark_width = width / _tmp20_;
#line 335 "../src/cell.vala"
	_tmp21_ = self->priv->game;
#line 335 "../src/cell.vala"
	_tmp22_ = sudoku_game_get_board (_tmp21_);
#line 335 "../src/cell.vala"
	_tmp23_ = _tmp22_;
#line 335 "../src/cell.vala"
	_tmp24_ = sudoku_board_get_block_rows (_tmp23_);
#line 335 "../src/cell.vala"
	_tmp25_ = _tmp24_;
#line 335 "../src/cell.vala"
	earmark_height = height / _tmp25_;
#line 337 "../src/cell.vala"
	num = 0;
#line 1701 "cell.c"
	{
		gint row_tmp = 0;
#line 338 "../src/cell.vala"
		row_tmp = 0;
#line 1706 "cell.c"
		{
			gboolean _tmp26_ = FALSE;
#line 338 "../src/cell.vala"
			_tmp26_ = TRUE;
#line 338 "../src/cell.vala"
			while (TRUE) {
#line 1713 "cell.c"
				SudokuGame* _tmp28_;
				SudokuBoard* _tmp29_;
				SudokuBoard* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
#line 338 "../src/cell.vala"
				if (!_tmp26_) {
#line 1721 "cell.c"
					gint _tmp27_;
#line 338 "../src/cell.vala"
					_tmp27_ = row_tmp;
#line 338 "../src/cell.vala"
					row_tmp = _tmp27_ + 1;
#line 1727 "cell.c"
				}
#line 338 "../src/cell.vala"
				_tmp26_ = FALSE;
#line 338 "../src/cell.vala"
				_tmp28_ = self->priv->game;
#line 338 "../src/cell.vala"
				_tmp29_ = sudoku_game_get_board (_tmp28_);
#line 338 "../src/cell.vala"
				_tmp30_ = _tmp29_;
#line 338 "../src/cell.vala"
				_tmp31_ = sudoku_board_get_block_rows (_tmp30_);
#line 338 "../src/cell.vala"
				_tmp32_ = _tmp31_;
#line 338 "../src/cell.vala"
				if (!(row_tmp < _tmp32_)) {
#line 338 "../src/cell.vala"
					break;
#line 1745 "cell.c"
				}
				{
					gint col_tmp = 0;
#line 340 "../src/cell.vala"
					col_tmp = 0;
#line 1751 "cell.c"
					{
						gboolean _tmp33_ = FALSE;
#line 340 "../src/cell.vala"
						_tmp33_ = TRUE;
#line 340 "../src/cell.vala"
						while (TRUE) {
#line 1758 "cell.c"
							SudokuGame* _tmp35_;
							SudokuBoard* _tmp36_;
							SudokuBoard* _tmp37_;
							gint _tmp38_;
							gint _tmp39_;
							gint _tmp40_;
							GtkLabel** _tmp41_;
							gint _tmp41__length1;
							GtkLabel* _tmp42_;
							GtkLabel** _tmp43_;
							gint _tmp43__length1;
							GtkLabel* _tmp44_;
							GtkRequisition _tmp45_ = {0};
							GtkRequisition _tmp46_;
							GtkRequisition _tmp47_;
							GtkAllocation earmark_allocation = {0};
							SudokuGame* _tmp48_;
							SudokuBoard* _tmp49_;
							SudokuBoard* _tmp50_;
							gint _tmp51_;
							gint _tmp52_;
							GtkAllocation _tmp53_ = {0};
							GtkLabel** _tmp54_;
							gint _tmp54__length1;
							GtkLabel* _tmp55_;
							GtkAllocation _tmp56_;
#line 340 "../src/cell.vala"
							if (!_tmp33_) {
#line 1787 "cell.c"
								gint _tmp34_;
#line 340 "../src/cell.vala"
								_tmp34_ = col_tmp;
#line 340 "../src/cell.vala"
								col_tmp = _tmp34_ + 1;
#line 1793 "cell.c"
							}
#line 340 "../src/cell.vala"
							_tmp33_ = FALSE;
#line 340 "../src/cell.vala"
							_tmp35_ = self->priv->game;
#line 340 "../src/cell.vala"
							_tmp36_ = sudoku_game_get_board (_tmp35_);
#line 340 "../src/cell.vala"
							_tmp37_ = _tmp36_;
#line 340 "../src/cell.vala"
							_tmp38_ = sudoku_board_get_block_cols (_tmp37_);
#line 340 "../src/cell.vala"
							_tmp39_ = _tmp38_;
#line 340 "../src/cell.vala"
							if (!(col_tmp < _tmp39_)) {
#line 340 "../src/cell.vala"
								break;
#line 1811 "cell.c"
							}
#line 342 "../src/cell.vala"
							_tmp40_ = num;
#line 342 "../src/cell.vala"
							num = _tmp40_ + 1;
#line 344 "../src/cell.vala"
							_tmp41_ = self->priv->earmark_labels;
#line 344 "../src/cell.vala"
							_tmp41__length1 = self->priv->earmark_labels_length1;
#line 344 "../src/cell.vala"
							_tmp42_ = _tmp41_[num - 1];
#line 344 "../src/cell.vala"
							sudoku_cell_set_font_size (self, _tmp42_, height / 4);
#line 345 "../src/cell.vala"
							_tmp43_ = self->priv->earmark_labels;
#line 345 "../src/cell.vala"
							_tmp43__length1 = self->priv->earmark_labels_length1;
#line 345 "../src/cell.vala"
							_tmp44_ = _tmp43_[num - 1];
#line 345 "../src/cell.vala"
							gtk_widget_get_preferred_size ((GtkWidget*) _tmp44_, &_tmp45_, NULL);
#line 345 "../src/cell.vala"
							min_size = _tmp45_;
#line 346 "../src/cell.vala"
							_tmp46_ = min_size;
#line 346 "../src/cell.vala"
							earmark_width = MAX (earmark_width, _tmp46_.width);
#line 347 "../src/cell.vala"
							_tmp47_ = min_size;
#line 347 "../src/cell.vala"
							earmark_height = MAX (earmark_height, _tmp47_.height);
#line 349 "../src/cell.vala"
							_tmp48_ = self->priv->game;
#line 349 "../src/cell.vala"
							_tmp49_ = sudoku_game_get_board (_tmp48_);
#line 349 "../src/cell.vala"
							_tmp50_ = _tmp49_;
#line 349 "../src/cell.vala"
							_tmp51_ = sudoku_board_get_block_rows (_tmp50_);
#line 349 "../src/cell.vala"
							_tmp52_ = _tmp51_;
#line 349 "../src/cell.vala"
							_tmp53_.x = col_tmp * earmark_width;
#line 349 "../src/cell.vala"
							_tmp53_.y = ((_tmp52_ - row_tmp) - 1) * earmark_height;
#line 349 "../src/cell.vala"
							_tmp53_.width = earmark_width;
#line 349 "../src/cell.vala"
							_tmp53_.height = earmark_height;
#line 349 "../src/cell.vala"
							earmark_allocation = _tmp53_;
#line 352 "../src/cell.vala"
							_tmp54_ = self->priv->earmark_labels;
#line 352 "../src/cell.vala"
							_tmp54__length1 = self->priv->earmark_labels_length1;
#line 352 "../src/cell.vala"
							_tmp55_ = _tmp54_[num - 1];
#line 352 "../src/cell.vala"
							_tmp56_ = earmark_allocation;
#line 352 "../src/cell.vala"
							gtk_widget_size_allocate ((GtkWidget*) _tmp55_, &_tmp56_, baseline);
#line 1873 "cell.c"
						}
					}
				}
			}
		}
	}
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 359 "../src/cell.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 1887 "cell.c"
}

static void
sudoku_cell_set_font_size (SudokuCell* self,
                           GtkLabel* label,
                           gint font_size)
{
	PangoAttrList* attr_list = NULL;
	PangoAttrList* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp4_;
	PangoAttribute* _tmp5_;
	PangoAttrList* _tmp6_;
#line 357 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 357 "../src/cell.vala"
	g_return_if_fail (label != NULL);
#line 359 "../src/cell.vala"
	_tmp0_ = gtk_label_get_attributes (label);
#line 359 "../src/cell.vala"
	_tmp1_ = _pango_attr_list_ref0 (_tmp0_);
#line 359 "../src/cell.vala"
	attr_list = _tmp1_;
#line 360 "../src/cell.vala"
	_tmp2_ = attr_list;
#line 360 "../src/cell.vala"
	if (_tmp2_ == NULL) {
#line 1916 "cell.c"
		PangoAttrList* _tmp3_;
#line 361 "../src/cell.vala"
		_tmp3_ = pango_attr_list_new ();
#line 361 "../src/cell.vala"
		_pango_attr_list_unref0 (attr_list);
#line 361 "../src/cell.vala"
		attr_list = _tmp3_;
#line 1924 "cell.c"
	}
#line 363 "../src/cell.vala"
	_tmp4_ = attr_list;
#line 363 "../src/cell.vala"
	_tmp5_ = pango_attr_size_new_absolute (font_size * PANGO_SCALE);
#line 363 "../src/cell.vala"
	pango_attr_list_change (_tmp4_, _tmp5_);
#line 367 "../src/cell.vala"
	_tmp6_ = attr_list;
#line 367 "../src/cell.vala"
	gtk_label_set_attributes (label, _tmp6_);
#line 357 "../src/cell.vala"
	_pango_attr_list_unref0 (attr_list);
#line 1938 "cell.c"
}

static void
sudoku_cell_real_dispose (GObject* base)
{
	SudokuCell * self;
	GtkLabel* _tmp0_;
	GtkLabel** _tmp1_;
	gint _tmp1__length1;
#line 370 "../src/cell.vala"
	self = (SudokuCell*) base;
#line 372 "../src/cell.vala"
	_tmp0_ = self->priv->value_label;
#line 372 "../src/cell.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 373 "../src/cell.vala"
	_tmp1_ = self->priv->earmark_labels;
#line 373 "../src/cell.vala"
	_tmp1__length1 = self->priv->earmark_labels_length1;
#line 1958 "cell.c"
	{
		GtkLabel** earmark_collection = NULL;
		gint earmark_collection_length1 = 0;
		gint _earmark_collection_size_ = 0;
		gint earmark_it = 0;
#line 373 "../src/cell.vala"
		earmark_collection = _tmp1_;
#line 373 "../src/cell.vala"
		earmark_collection_length1 = _tmp1__length1;
#line 373 "../src/cell.vala"
		for (earmark_it = 0; earmark_it < earmark_collection_length1; earmark_it = earmark_it + 1) {
#line 1970 "cell.c"
			GtkLabel* _tmp2_;
			GtkLabel* earmark = NULL;
#line 373 "../src/cell.vala"
			_tmp2_ = _g_object_ref0 (earmark_collection[earmark_it]);
#line 373 "../src/cell.vala"
			earmark = _tmp2_;
#line 1977 "cell.c"
			{
				GtkLabel* _tmp3_;
#line 374 "../src/cell.vala"
				_tmp3_ = earmark;
#line 374 "../src/cell.vala"
				gtk_widget_unparent ((GtkWidget*) _tmp3_);
#line 373 "../src/cell.vala"
				_g_object_unref0 (earmark);
#line 1986 "cell.c"
			}
		}
	}
#line 375 "../src/cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 1992 "cell.c"
}

gint
sudoku_cell_get_row (SudokuCell* self)
{
	gint result;
#line 26 "../src/cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 26 "../src/cell.vala"
	result = self->priv->_row;
#line 26 "../src/cell.vala"
	return result;
#line 2005 "cell.c"
}

static void
sudoku_cell_set_row (SudokuCell* self,
                     gint value)
{
	gint old_value;
#line 26 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/cell.vala"
	old_value = sudoku_cell_get_row (self);
#line 26 "../src/cell.vala"
	if (old_value != value) {
#line 26 "../src/cell.vala"
		self->priv->_row = value;
#line 26 "../src/cell.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_ROW_PROPERTY]);
#line 2023 "cell.c"
	}
}

gint
sudoku_cell_get_col (SudokuCell* self)
{
	gint result;
#line 27 "../src/cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../src/cell.vala"
	result = self->priv->_col;
#line 27 "../src/cell.vala"
	return result;
#line 2037 "cell.c"
}

static void
sudoku_cell_set_col (SudokuCell* self,
                     gint value)
{
	gint old_value;
#line 27 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/cell.vala"
	old_value = sudoku_cell_get_col (self);
#line 27 "../src/cell.vala"
	if (old_value != value) {
#line 27 "../src/cell.vala"
		self->priv->_col = value;
#line 27 "../src/cell.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_COL_PROPERTY]);
#line 2055 "cell.c"
	}
}

gint
sudoku_cell_get_value (SudokuCell* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 84 "../src/cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 84 "../src/cell.vala"
	_tmp0_ = self->priv->game;
#line 84 "../src/cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 84 "../src/cell.vala"
	_tmp2_ = _tmp1_;
#line 84 "../src/cell.vala"
	_tmp3_ = self->priv->_row;
#line 84 "../src/cell.vala"
	_tmp4_ = self->priv->_col;
#line 84 "../src/cell.vala"
	result = sudoku_board_get (_tmp2_, _tmp3_, _tmp4_);
#line 84 "../src/cell.vala"
	return result;
#line 2084 "cell.c"
}

void
sudoku_cell_set_value (SudokuCell* self,
                       gint value)
{
#line 85 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/cell.vala"
	if (value == 0) {
#line 2095 "cell.c"
		SudokuGame* _tmp0_;
		SudokuBoard* _tmp1_;
		SudokuBoard* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 88 "../src/cell.vala"
		_tmp0_ = self->priv->game;
#line 88 "../src/cell.vala"
		_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 88 "../src/cell.vala"
		_tmp2_ = _tmp1_;
#line 88 "../src/cell.vala"
		_tmp3_ = self->priv->_row;
#line 88 "../src/cell.vala"
		_tmp4_ = self->priv->_col;
#line 88 "../src/cell.vala"
		if (sudoku_board_get (_tmp2_, _tmp3_, _tmp4_) != 0) {
#line 2113 "cell.c"
			SudokuGame* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
#line 89 "../src/cell.vala"
			_tmp5_ = self->priv->game;
#line 89 "../src/cell.vala"
			_tmp6_ = self->priv->_row;
#line 89 "../src/cell.vala"
			_tmp7_ = self->priv->_col;
#line 89 "../src/cell.vala"
			sudoku_game_remove (_tmp5_, _tmp6_, _tmp7_);
#line 2125 "cell.c"
		} else {
			SudokuGame* _tmp8_;
			SudokuBoard* _tmp9_;
			SudokuBoard* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
#line 90 "../src/cell.vala"
			_tmp8_ = self->priv->game;
#line 90 "../src/cell.vala"
			_tmp9_ = sudoku_game_get_board (_tmp8_);
#line 90 "../src/cell.vala"
			_tmp10_ = _tmp9_;
#line 90 "../src/cell.vala"
			_tmp11_ = self->priv->_row;
#line 90 "../src/cell.vala"
			_tmp12_ = self->priv->_col;
#line 90 "../src/cell.vala"
			if (sudoku_board_has_earmarks (_tmp10_, _tmp11_, _tmp12_)) {
#line 2144 "cell.c"
				SudokuGame* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 91 "../src/cell.vala"
				_tmp13_ = self->priv->game;
#line 91 "../src/cell.vala"
				_tmp14_ = self->priv->_row;
#line 91 "../src/cell.vala"
				_tmp15_ = self->priv->_col;
#line 91 "../src/cell.vala"
				sudoku_game_disable_all_earmarks (_tmp13_, _tmp14_, _tmp15_);
#line 2156 "cell.c"
			}
		}
	} else {
		SudokuGame* _tmp16_;
		SudokuBoard* _tmp17_;
		SudokuBoard* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
#line 93 "../src/cell.vala"
		_tmp16_ = self->priv->game;
#line 93 "../src/cell.vala"
		_tmp17_ = sudoku_game_get_board (_tmp16_);
#line 93 "../src/cell.vala"
		_tmp18_ = _tmp17_;
#line 93 "../src/cell.vala"
		_tmp19_ = self->priv->_row;
#line 93 "../src/cell.vala"
		_tmp20_ = self->priv->_col;
#line 93 "../src/cell.vala"
		if (value != sudoku_board_get (_tmp18_, _tmp19_, _tmp20_)) {
#line 2177 "cell.c"
			gboolean _tmp21_ = FALSE;
			SudokuView* _tmp22_;
			gboolean _tmp23_;
			gboolean _tmp24_;
#line 95 "../src/cell.vala"
			_tmp22_ = self->view;
#line 95 "../src/cell.vala"
			_tmp23_ = sudoku_view_get_autoclean_earmarks (_tmp22_);
#line 95 "../src/cell.vala"
			_tmp24_ = _tmp23_;
#line 95 "../src/cell.vala"
			if (_tmp24_) {
#line 2190 "cell.c"
				SudokuGame* _tmp25_;
				GameMode _tmp26_;
				GameMode _tmp27_;
#line 95 "../src/cell.vala"
				_tmp25_ = self->priv->game;
#line 95 "../src/cell.vala"
				_tmp26_ = sudoku_game_get_mode (_tmp25_);
#line 95 "../src/cell.vala"
				_tmp27_ = _tmp26_;
#line 95 "../src/cell.vala"
				_tmp21_ = _tmp27_ == GAME_MODE_PLAY;
#line 2202 "cell.c"
			} else {
#line 95 "../src/cell.vala"
				_tmp21_ = FALSE;
#line 2206 "cell.c"
			}
#line 95 "../src/cell.vala"
			if (_tmp21_) {
#line 2210 "cell.c"
				SudokuGame* _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
#line 96 "../src/cell.vala"
				_tmp28_ = self->priv->game;
#line 96 "../src/cell.vala"
				_tmp29_ = self->priv->_row;
#line 96 "../src/cell.vala"
				_tmp30_ = self->priv->_col;
#line 96 "../src/cell.vala"
				sudoku_game_insert_and_disable_related_earmarks (_tmp28_, _tmp29_, _tmp30_, value);
#line 2222 "cell.c"
			} else {
				SudokuGame* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
#line 98 "../src/cell.vala"
				_tmp31_ = self->priv->game;
#line 98 "../src/cell.vala"
				_tmp32_ = self->priv->_row;
#line 98 "../src/cell.vala"
				_tmp33_ = self->priv->_col;
#line 98 "../src/cell.vala"
				sudoku_game_insert (_tmp31_, _tmp32_, _tmp33_, value);
#line 2235 "cell.c"
			}
		}
	}
#line 85 "../src/cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY]);
#line 2241 "cell.c"
}

gboolean
sudoku_cell_get_is_fixed (SudokuCell* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 116 "../src/cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 116 "../src/cell.vala"
	_tmp0_ = self->priv->game;
#line 116 "../src/cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 116 "../src/cell.vala"
	_tmp2_ = _tmp1_;
#line 116 "../src/cell.vala"
	_tmp3_ = self->priv->_row;
#line 116 "../src/cell.vala"
	_tmp4_ = self->priv->_col;
#line 116 "../src/cell.vala"
	result = sudoku_board_get_is_fixed (_tmp2_, _tmp3_, _tmp4_);
#line 116 "../src/cell.vala"
	return result;
#line 2269 "cell.c"
}

gboolean
sudoku_cell_get_selected (SudokuCell* self)
{
	gboolean result;
#line 121 "../src/cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 121 "../src/cell.vala"
	result = self->priv->_selected;
#line 121 "../src/cell.vala"
	return result;
#line 2282 "cell.c"
}

void
sudoku_cell_set_selected (SudokuCell* self,
                          gboolean value)
{
#line 122 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/cell.vala"
	self->priv->_selected = value;
#line 125 "../src/cell.vala"
	sudoku_cell_set_fixed_css (self, !value);
#line 126 "../src/cell.vala"
	if (value) {
#line 127 "../src/cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "selected");
#line 2299 "cell.c"
	} else {
#line 129 "../src/cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "selected");
#line 2303 "cell.c"
	}
#line 122 "../src/cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY]);
#line 2307 "cell.c"
}

gboolean
sudoku_cell_get_highlight_coord (SudokuCell* self)
{
	gboolean result;
#line 135 "../src/cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 135 "../src/cell.vala"
	result = self->priv->_highlight_coord;
#line 135 "../src/cell.vala"
	return result;
#line 2320 "cell.c"
}

void
sudoku_cell_set_highlight_coord (SudokuCell* self,
                                 gboolean value)
{
#line 136 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/cell.vala"
	self->priv->_highlight_coord = value;
#line 139 "../src/cell.vala"
	if (value) {
#line 140 "../src/cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-coord");
#line 2335 "cell.c"
	} else {
#line 142 "../src/cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-coord");
#line 2339 "cell.c"
	}
#line 136 "../src/cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY]);
#line 2343 "cell.c"
}

gboolean
sudoku_cell_get_highlight_number (SudokuCell* self)
{
	gboolean result;
#line 148 "../src/cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 148 "../src/cell.vala"
	result = self->priv->_highlight_number;
#line 148 "../src/cell.vala"
	return result;
#line 2356 "cell.c"
}

void
sudoku_cell_set_highlight_number (SudokuCell* self,
                                  gboolean value)
{
#line 149 "../src/cell.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/cell.vala"
	self->priv->_highlight_number = value;
#line 152 "../src/cell.vala"
	sudoku_cell_set_fixed_css (self, !value);
#line 153 "../src/cell.vala"
	if (value) {
#line 154 "../src/cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-number");
#line 2373 "cell.c"
	} else {
#line 156 "../src/cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-number");
#line 2377 "cell.c"
	}
#line 149 "../src/cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY]);
#line 2381 "cell.c"
}

static void
sudoku_cell_class_init (SudokuCellClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/cell.vala"
	sudoku_cell_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/cell.vala"
	g_type_class_adjust_private_offset (klass, &SudokuCell_private_offset);
#line 24 "../src/cell.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_cell_real_size_allocate;
#line 24 "../src/cell.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_cell_real_dispose;
#line 24 "../src/cell.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_get_property;
#line 24 "../src/cell.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_set_property;
#line 24 "../src/cell.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_finalize;
#line 24 "../src/cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_ROW_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_ROW_PROPERTY] = g_param_spec_int ("row", "row", "row", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_COL_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_COL_PROPERTY] = g_param_spec_int ("col", "col", "col", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_IS_FIXED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SELECTED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY] = g_param_spec_boolean ("highlight-coord", "highlight-coord", "highlight-coord", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY] = g_param_spec_boolean ("highlight-number", "highlight-number", "highlight-number", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 79 "../src/cell.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "sudokucell");
#line 2418 "cell.c"
}

static void
sudoku_cell_instance_init (SudokuCell * self,
                           gpointer klass)
{
#line 24 "../src/cell.vala"
	self->priv = sudoku_cell_get_instance_private (self);
#line 119 "../src/cell.vala"
	self->priv->_selected = FALSE;
#line 133 "../src/cell.vala"
	self->priv->_highlight_coord = FALSE;
#line 146 "../src/cell.vala"
	self->priv->_highlight_number = FALSE;
#line 2433 "cell.c"
}

static void
sudoku_cell_finalize (GObject * obj)
{
	SudokuCell * self;
#line 24 "../src/cell.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL, SudokuCell);
#line 28 "../src/cell.vala"
	_g_object_unref0 (self->priv->game);
#line 31 "../src/cell.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 32 "../src/cell.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 34 "../src/cell.vala"
	_g_object_unref0 (self->priv->value_label);
#line 35 "../src/cell.vala"
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 24 "../src/cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->finalize (obj);
#line 2454 "cell.c"
}

static GType
sudoku_cell_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCell), 0, (GInstanceInitFunc) sudoku_cell_instance_init, NULL };
	GType sudoku_cell_type_id;
	sudoku_cell_type_id = g_type_register_static (gtk_widget_get_type (), "SudokuCell", &g_define_type_info, 0);
	SudokuCell_private_offset = g_type_add_instance_private (sudoku_cell_type_id, sizeof (SudokuCellPrivate));
	return sudoku_cell_type_id;
}

GType
sudoku_cell_get_type (void)
{
	static volatile gsize sudoku_cell_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_type_id__once)) {
		GType sudoku_cell_type_id;
		sudoku_cell_type_id = sudoku_cell_get_type_once ();
		g_once_init_leave (&sudoku_cell_type_id__once, sudoku_cell_type_id);
	}
	return sudoku_cell_type_id__once;
}

static void
_vala_sudoku_cell_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/cell.vala"
	switch (property_id) {
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_ROW_PROPERTY:
#line 24 "../src/cell.vala"
		g_value_set_int (value, sudoku_cell_get_row (self));
#line 24 "../src/cell.vala"
		break;
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_COL_PROPERTY:
#line 24 "../src/cell.vala"
		g_value_set_int (value, sudoku_cell_get_col (self));
#line 24 "../src/cell.vala"
		break;
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/cell.vala"
		g_value_set_int (value, sudoku_cell_get_value (self));
#line 24 "../src/cell.vala"
		break;
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_IS_FIXED_PROPERTY:
#line 24 "../src/cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_is_fixed (self));
#line 24 "../src/cell.vala"
		break;
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_selected (self));
#line 24 "../src/cell.vala"
		break;
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY:
#line 24 "../src/cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlight_coord (self));
#line 24 "../src/cell.vala"
		break;
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY:
#line 24 "../src/cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlight_number (self));
#line 24 "../src/cell.vala"
		break;
#line 2531 "cell.c"
		default:
#line 24 "../src/cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/cell.vala"
		break;
#line 2537 "cell.c"
	}
}

static void
_vala_sudoku_cell_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/cell.vala"
	switch (property_id) {
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_ROW_PROPERTY:
#line 24 "../src/cell.vala"
		sudoku_cell_set_row (self, g_value_get_int (value));
#line 24 "../src/cell.vala"
		break;
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_COL_PROPERTY:
#line 24 "../src/cell.vala"
		sudoku_cell_set_col (self, g_value_get_int (value));
#line 24 "../src/cell.vala"
		break;
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/cell.vala"
		sudoku_cell_set_value (self, g_value_get_int (value));
#line 24 "../src/cell.vala"
		break;
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/cell.vala"
		sudoku_cell_set_selected (self, g_value_get_boolean (value));
#line 24 "../src/cell.vala"
		break;
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY:
#line 24 "../src/cell.vala"
		sudoku_cell_set_highlight_coord (self, g_value_get_boolean (value));
#line 24 "../src/cell.vala"
		break;
#line 24 "../src/cell.vala"
		case SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY:
#line 24 "../src/cell.vala"
		sudoku_cell_set_highlight_number (self, g_value_get_boolean (value));
#line 24 "../src/cell.vala"
		break;
#line 2587 "cell.c"
		default:
#line 24 "../src/cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/cell.vala"
		break;
#line 2593 "cell.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

