/* preferences-dialog.c generated by valac 0.56.18, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2024 Johan Gay
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_PREFERENCES_DIALOG (sudoku_preferences_dialog_get_type ())
#define SUDOKU_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_PREFERENCES_DIALOG, SudokuPreferencesDialog))
#define SUDOKU_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_PREFERENCES_DIALOG, SudokuPreferencesDialogClass))
#define IS_SUDOKU_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_PREFERENCES_DIALOG))
#define IS_SUDOKU_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_PREFERENCES_DIALOG))
#define SUDOKU_PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_PREFERENCES_DIALOG, SudokuPreferencesDialogClass))

typedef struct _SudokuPreferencesDialog SudokuPreferencesDialog;
typedef struct _SudokuPreferencesDialogClass SudokuPreferencesDialogClass;
typedef struct _SudokuPreferencesDialogPrivate SudokuPreferencesDialogPrivate;

#define TYPE_SUDOKU_WINDOW (sudoku_window_get_type ())
#define SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_WINDOW, SudokuWindow))
#define SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_WINDOW, SudokuWindowClass))
#define IS_SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_WINDOW))
#define IS_SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_WINDOW))
#define SUDOKU_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_WINDOW, SudokuWindowClass))

typedef struct _SudokuWindow SudokuWindow;
typedef struct _SudokuWindowClass SudokuWindowClass;
enum  {
	SUDOKU_PREFERENCES_DIALOG_0_PROPERTY,
	SUDOKU_PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* sudoku_preferences_dialog_properties[SUDOKU_PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SudokuPreferencesDialog {
	AdwPreferencesDialog parent_instance;
	SudokuPreferencesDialogPrivate * priv;
	AdwSwitchRow* autoclean_earmarks;
	AdwSwitchRow* show_possibilities;
	AdwSwitchRow* show_timer;
	AdwSwitchRow* number_picker_second_click;
	AdwSwitchRow* show_earmark_warnings;
	AdwSwitchRow* solution_warnings;
	AdwSwitchRow* highlight_numbers;
	AdwSwitchRow* highlight_block;
	AdwSwitchRow* highlight_row_column;
};

struct _SudokuPreferencesDialogClass {
	AdwPreferencesDialogClass parent_class;
};

struct _SudokuPreferencesDialogPrivate {
	SudokuWindow* window;
};

static gint SudokuPreferencesDialog_private_offset;
static gpointer sudoku_preferences_dialog_parent_class = NULL;

VALA_EXTERN GType sudoku_preferences_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuPreferencesDialog, g_object_unref)
VALA_EXTERN GType sudoku_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuWindow, g_object_unref)
VALA_EXTERN SudokuPreferencesDialog* sudoku_preferences_dialog_new (SudokuWindow* window);
VALA_EXTERN SudokuPreferencesDialog* sudoku_preferences_dialog_construct (GType object_type,
                                                              SudokuWindow* window);
VALA_EXTERN GSettings* sudoku_window_get_settings (SudokuWindow* self);
static void sudoku_preferences_dialog_real_dispose (GObject* base);
static void sudoku_preferences_dialog_finalize (GObject * obj);
static GType sudoku_preferences_dialog_get_type_once (void);

static inline gpointer
sudoku_preferences_dialog_get_instance_private (SudokuPreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuPreferencesDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/preferences-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 124 "preferences-dialog.c"
}

SudokuPreferencesDialog*
sudoku_preferences_dialog_construct (GType object_type,
                                     SudokuWindow* window)
{
	SudokuPreferencesDialog * self = NULL;
	SudokuWindow* _tmp0_;
	SudokuWindow* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	AdwSwitchRow* _tmp4_;
	SudokuWindow* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	AdwSwitchRow* _tmp8_;
	SudokuWindow* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	AdwSwitchRow* _tmp12_;
	SudokuWindow* _tmp13_;
	GSettings* _tmp14_;
	GSettings* _tmp15_;
	AdwSwitchRow* _tmp16_;
	SudokuWindow* _tmp17_;
	GSettings* _tmp18_;
	GSettings* _tmp19_;
	AdwSwitchRow* _tmp20_;
	SudokuWindow* _tmp21_;
	GSettings* _tmp22_;
	GSettings* _tmp23_;
	AdwSwitchRow* _tmp24_;
	SudokuWindow* _tmp25_;
	GSettings* _tmp26_;
	GSettings* _tmp27_;
	AdwSwitchRow* _tmp28_;
	SudokuWindow* _tmp29_;
	GSettings* _tmp30_;
	GSettings* _tmp31_;
	AdwSwitchRow* _tmp32_;
	SudokuWindow* _tmp33_;
	GSettings* _tmp34_;
	GSettings* _tmp35_;
	AdwSwitchRow* _tmp36_;
#line 39 "../src/preferences-dialog.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 39 "../src/preferences-dialog.vala"
	self = (SudokuPreferencesDialog*) g_object_new (object_type, NULL);
#line 41 "../src/preferences-dialog.vala"
	_tmp0_ = _g_object_ref0 (window);
#line 41 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->window);
#line 41 "../src/preferences-dialog.vala"
	self->priv->window = _tmp0_;
#line 43 "../src/preferences-dialog.vala"
	_tmp1_ = self->priv->window;
#line 43 "../src/preferences-dialog.vala"
	_tmp2_ = sudoku_window_get_settings (_tmp1_);
#line 43 "../src/preferences-dialog.vala"
	_tmp3_ = _tmp2_;
#line 43 "../src/preferences-dialog.vala"
	_tmp4_ = self->show_timer;
#line 43 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp3_, "show-timer", (GObject*) _tmp4_, "active", G_SETTINGS_BIND_DEFAULT);
#line 44 "../src/preferences-dialog.vala"
	_tmp5_ = self->priv->window;
#line 44 "../src/preferences-dialog.vala"
	_tmp6_ = sudoku_window_get_settings (_tmp5_);
#line 44 "../src/preferences-dialog.vala"
	_tmp7_ = _tmp6_;
#line 44 "../src/preferences-dialog.vala"
	_tmp8_ = self->show_earmark_warnings;
#line 44 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp7_, "show-earmark-warnings", (GObject*) _tmp8_, "active", G_SETTINGS_BIND_DEFAULT);
#line 45 "../src/preferences-dialog.vala"
	_tmp9_ = self->priv->window;
#line 45 "../src/preferences-dialog.vala"
	_tmp10_ = sudoku_window_get_settings (_tmp9_);
#line 45 "../src/preferences-dialog.vala"
	_tmp11_ = _tmp10_;
#line 45 "../src/preferences-dialog.vala"
	_tmp12_ = self->show_possibilities;
#line 45 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp11_, "show-possibilities", (GObject*) _tmp12_, "active", G_SETTINGS_BIND_DEFAULT);
#line 46 "../src/preferences-dialog.vala"
	_tmp13_ = self->priv->window;
#line 46 "../src/preferences-dialog.vala"
	_tmp14_ = sudoku_window_get_settings (_tmp13_);
#line 46 "../src/preferences-dialog.vala"
	_tmp15_ = _tmp14_;
#line 46 "../src/preferences-dialog.vala"
	_tmp16_ = self->number_picker_second_click;
#line 46 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp15_, "number-picker-second-click", (GObject*) _tmp16_, "active", G_SETTINGS_BIND_DEFAULT);
#line 47 "../src/preferences-dialog.vala"
	_tmp17_ = self->priv->window;
#line 47 "../src/preferences-dialog.vala"
	_tmp18_ = sudoku_window_get_settings (_tmp17_);
#line 47 "../src/preferences-dialog.vala"
	_tmp19_ = _tmp18_;
#line 47 "../src/preferences-dialog.vala"
	_tmp20_ = self->solution_warnings;
#line 47 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp19_, "solution-warnings", (GObject*) _tmp20_, "active", G_SETTINGS_BIND_DEFAULT);
#line 48 "../src/preferences-dialog.vala"
	_tmp21_ = self->priv->window;
#line 48 "../src/preferences-dialog.vala"
	_tmp22_ = sudoku_window_get_settings (_tmp21_);
#line 48 "../src/preferences-dialog.vala"
	_tmp23_ = _tmp22_;
#line 48 "../src/preferences-dialog.vala"
	_tmp24_ = self->autoclean_earmarks;
#line 48 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp23_, "autoclean-earmarks", (GObject*) _tmp24_, "active", G_SETTINGS_BIND_DEFAULT);
#line 49 "../src/preferences-dialog.vala"
	_tmp25_ = self->priv->window;
#line 49 "../src/preferences-dialog.vala"
	_tmp26_ = sudoku_window_get_settings (_tmp25_);
#line 49 "../src/preferences-dialog.vala"
	_tmp27_ = _tmp26_;
#line 49 "../src/preferences-dialog.vala"
	_tmp28_ = self->highlight_row_column;
#line 49 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp27_, "highlight-row-column", (GObject*) _tmp28_, "active", G_SETTINGS_BIND_DEFAULT);
#line 50 "../src/preferences-dialog.vala"
	_tmp29_ = self->priv->window;
#line 50 "../src/preferences-dialog.vala"
	_tmp30_ = sudoku_window_get_settings (_tmp29_);
#line 50 "../src/preferences-dialog.vala"
	_tmp31_ = _tmp30_;
#line 50 "../src/preferences-dialog.vala"
	_tmp32_ = self->highlight_block;
#line 50 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp31_, "highlight-block", (GObject*) _tmp32_, "active", G_SETTINGS_BIND_DEFAULT);
#line 51 "../src/preferences-dialog.vala"
	_tmp33_ = self->priv->window;
#line 51 "../src/preferences-dialog.vala"
	_tmp34_ = sudoku_window_get_settings (_tmp33_);
#line 51 "../src/preferences-dialog.vala"
	_tmp35_ = _tmp34_;
#line 51 "../src/preferences-dialog.vala"
	_tmp36_ = self->highlight_numbers;
#line 51 "../src/preferences-dialog.vala"
	g_settings_bind (_tmp35_, "highlight-numbers", (GObject*) _tmp36_, "active", G_SETTINGS_BIND_DEFAULT);
#line 39 "../src/preferences-dialog.vala"
	return self;
#line 271 "preferences-dialog.c"
}

SudokuPreferencesDialog*
sudoku_preferences_dialog_new (SudokuWindow* window)
{
#line 39 "../src/preferences-dialog.vala"
	return sudoku_preferences_dialog_construct (TYPE_SUDOKU_PREFERENCES_DIALOG, window);
#line 279 "preferences-dialog.c"
}

static void
sudoku_preferences_dialog_real_dispose (GObject* base)
{
	SudokuPreferencesDialog * self;
#line 54 "../src/preferences-dialog.vala"
	self = (SudokuPreferencesDialog*) base;
#line 56 "../src/preferences-dialog.vala"
	gtk_widget_dispose_template ((GtkWidget*) self, G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 57 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (sudoku_preferences_dialog_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_preferences_dialog_get_type (), AdwPreferencesDialog));
#line 292 "preferences-dialog.c"
}

static void
sudoku_preferences_dialog_class_init (SudokuPreferencesDialogClass * klass,
                                      gpointer klass_data)
{
#line 25 "../src/preferences-dialog.vala"
	sudoku_preferences_dialog_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/preferences-dialog.vala"
	g_type_class_adjust_private_offset (klass, &SudokuPreferencesDialog_private_offset);
#line 25 "../src/preferences-dialog.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_preferences_dialog_real_dispose;
#line 25 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_preferences_dialog_finalize;
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Sudoku/ui/preferences-dialog.ui");
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "autoclean_earmarks", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, autoclean_earmarks));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_possibilities", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, show_possibilities));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_timer", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, show_timer));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "number_picker_second_click", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, number_picker_second_click));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "show_earmark_warnings", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, show_earmark_warnings));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "solution_warnings", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, solution_warnings));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "highlight_numbers", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, highlight_numbers));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "highlight_block", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, highlight_block));
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "highlight_row_column", FALSE, G_STRUCT_OFFSET (SudokuPreferencesDialog, highlight_row_column));
#line 327 "preferences-dialog.c"
}

static void
sudoku_preferences_dialog_instance_init (SudokuPreferencesDialog * self,
                                         gpointer klass)
{
#line 25 "../src/preferences-dialog.vala"
	self->priv = sudoku_preferences_dialog_get_instance_private (self);
#line 25 "../src/preferences-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 338 "preferences-dialog.c"
}

static void
sudoku_preferences_dialog_finalize (GObject * obj)
{
	SudokuPreferencesDialog * self;
#line 25 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_PREFERENCES_DIALOG, SudokuPreferencesDialog);
#line 37 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->window);
#line 25 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (sudoku_preferences_dialog_parent_class)->finalize (obj);
#line 351 "preferences-dialog.c"
}

static GType
sudoku_preferences_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuPreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuPreferencesDialog), 0, (GInstanceInitFunc) sudoku_preferences_dialog_instance_init, NULL };
	GType sudoku_preferences_dialog_type_id;
	sudoku_preferences_dialog_type_id = g_type_register_static (adw_preferences_dialog_get_type (), "SudokuPreferencesDialog", &g_define_type_info, 0);
	SudokuPreferencesDialog_private_offset = g_type_add_instance_private (sudoku_preferences_dialog_type_id, sizeof (SudokuPreferencesDialogPrivate));
	return sudoku_preferences_dialog_type_id;
}

GType
sudoku_preferences_dialog_get_type (void)
{
	static volatile gsize sudoku_preferences_dialog_type_id__once = 0;
	if (g_once_init_enter (&sudoku_preferences_dialog_type_id__once)) {
		GType sudoku_preferences_dialog_type_id;
		sudoku_preferences_dialog_type_id = sudoku_preferences_dialog_get_type_once ();
		g_once_init_leave (&sudoku_preferences_dialog_type_id__once, sudoku_preferences_dialog_type_id);
	}
	return sudoku_preferences_dialog_type_id__once;
}

