/* view.c generated by valac 0.56.18, the Vala compiler
 * generated from view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include "libsudoku.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;

#define TYPE_SUDOKU_NUMBER_PICKER (sudoku_number_picker_get_type ())
#define SUDOKU_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPicker))
#define SUDOKU_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPickerClass))
#define IS_SUDOKU_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_NUMBER_PICKER))
#define IS_SUDOKU_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_NUMBER_PICKER))
#define SUDOKU_NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPickerClass))

typedef struct _SudokuNumberPicker SudokuNumberPicker;
typedef struct _SudokuNumberPickerClass SudokuNumberPickerClass;

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;

#define TYPE_SUDOKU_FRAME (sudoku_frame_get_type ())
#define SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_FRAME, SudokuFrame))
#define SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_FRAME, SudokuFrameClass))
#define IS_SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_FRAME))
#define IS_SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_FRAME))
#define SUDOKU_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_FRAME, SudokuFrameClass))

typedef struct _SudokuFrame SudokuFrame;
typedef struct _SudokuFrameClass SudokuFrameClass;
typedef enum  {
	ZOOM_LEVEL_NONE = 0,
	ZOOM_LEVEL_SMALL = 1,
	ZOOM_LEVEL_MEDIUM = 2,
	ZOOM_LEVEL_LARGE = 3
} ZoomLevel;

#define TYPE_ZOOM_LEVEL (zoom_level_get_type ())
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_EARMARK_MODE_PROPERTY,
	SUDOKU_VIEW_AUTOCLEAN_EARMARKS_PROPERTY,
	SUDOKU_VIEW_NUMBER_PICKER_SECOND_CLICK_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHT_ROW_COLUMN_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHT_BLOCK_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHT_NUMBERS_PROPERTY,
	SUDOKU_VIEW_VALUE_ZOOM_MULTIPLIER_PROPERTY,
	SUDOKU_VIEW_SELECTED_ROW_PROPERTY,
	SUDOKU_VIEW_SELECTED_COL_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_HAS_SELECTION_PROPERTY,
	SUDOKU_VIEW_ZOOM_LEVEL_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL,
	SUDOKU_VIEW_NUM_SIGNALS
};
static guint sudoku_view_signals[SUDOKU_VIEW_NUM_SIGNALS] = {0};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	SudokuNumberPicker* number_picker;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

struct _SudokuViewPrivate {
	GSettings* settings;
	GtkEventControllerKey* key_controller;
	GtkEventControllerFocus* focus_controller;
	SudokuGame* game;
	SudokuCell** cells;
	gint cells_length1;
	gint cells_length2;
	SudokuFrame* frame;
	GtkLabel* paused_label;
	gboolean _earmark_mode;
	gboolean _autoclean_earmarks;
	gboolean _number_picker_second_click;
	gboolean _highlight_row_column;
	gboolean _highlight_block;
	gboolean _highlight_numbers;
	gdouble _value_zoom_multiplier;
	gint _selected_row;
	gint _selected_col;
	gboolean _show_warnings;
	gboolean _show_earmark_warnings;
	gboolean _solution_warnings;
	gboolean _show_possibilities;
	gboolean _highlighter;
	gboolean _has_selection;
	ZoomLevel _zoom_level;
};

static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuNumberPicker, g_object_unref)
VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN GType sudoku_frame_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuFrame, g_object_unref)
VALA_EXTERN GType zoom_level_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game,
                             GSettings* settings);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game,
                                   GSettings* settings);
VALA_EXTERN SudokuFrame* sudoku_frame_new (GtkWidget* child);
VALA_EXTERN SudokuFrame* sudoku_frame_construct (GType object_type,
                                     GtkWidget* child);
VALA_EXTERN SudokuNumberPicker* sudoku_number_picker_new (SudokuGame* game);
VALA_EXTERN SudokuNumberPicker* sudoku_number_picker_construct (GType object_type,
                                                    SudokuGame* game);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame* game,
                             SudokuView* view);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame* game,
                                   SudokuView* view);
static void sudoku_view_value_changed_cb (SudokuView* self,
                                   gint row,
                                   gint col,
                                   gint old_val,
                                   gint new_val);
static void _sudoku_view_value_changed_cb_sudoku_board_value_changed (SudokuBoard* _sender,
                                                               gint row,
                                                               gint col,
                                                               gint old_val,
                                                               gint new_val,
                                                               gpointer self);
static void sudoku_view_earmark_changed_cb (SudokuView* self,
                                     gint row,
                                     gint col,
                                     gint num,
                                     gboolean enabled);
static void _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                                   gint row,
                                                                   gint col,
                                                                   gint num,
                                                                   gboolean enabled,
                                                                   gpointer self);
static void sudoku_view_selection_changed_cb (SudokuView* self,
                                       gint old_row,
                                       gint old_col,
                                       gint new_row,
                                       gint new_col);
static void _sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                      gint old_row,
                                                                      gint old_col,
                                                                      gint new_row,
                                                                      gint new_col,
                                                                      gpointer self);
static void sudoku_view_paused_cb (SudokuView* self);
static void _sudoku_view_paused_cb_g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self);
static gboolean sudoku_view_key_pressed_cb (SudokuView* self,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _sudoku_view_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
static void __lambda5_ (SudokuView* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda5__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                   gpointer self);
static void sudoku_view_update_warnings (SudokuView* self);
VALA_EXTERN gint sudoku_view_get_selected_row (SudokuView* self);
VALA_EXTERN gint sudoku_view_get_selected_col (SudokuView* self);
static SudokuCell* sudoku_view_get_selected_cell (SudokuView* self);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
static void sudoku_view_insert_key (SudokuView* self,
                             gint key,
                             gboolean control_pressed);
VALA_EXTERN gboolean sudoku_view_get_earmark_mode (SudokuView* self);
VALA_EXTERN void sudoku_number_picker_show_value_picker (SudokuNumberPicker* self,
                                             SudokuCell* cell);
VALA_EXTERN void sudoku_number_picker_show_earmark_picker (SudokuNumberPicker* self,
                                               SudokuCell* cell);
static void sudoku_view_set_cell_highlighter (SudokuView* self,
                                       gint row,
                                       gint col,
                                       gboolean enabled);
VALA_EXTERN void sudoku_cell_update_content_visibility (SudokuCell* self);
static void sudoku_view_update_value_highlighter (SudokuView* self,
                                           gint row,
                                           gint col,
                                           gint old_val,
                                           gint new_val);
VALA_EXTERN void sudoku_cell_update_earmark_visibility (SudokuCell* self,
                                            gint num);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_update_earmark_warnings (SudokuCell* self,
                                          gint num);
static void sudoku_view_clear_all_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
static void sudoku_view_set_selected_row (SudokuView* self,
                                   gint value);
static void sudoku_view_set_selected_col (SudokuView* self,
                                   gint value);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN gboolean sudoku_view_get_highlight_numbers (SudokuView* self);
VALA_EXTERN void sudoku_cell_set_highlight_number (SudokuCell* self,
                                       gboolean value);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN gboolean sudoku_view_get_highlight_row_column (SudokuView* self);
VALA_EXTERN gint sudoku_cell_get_row (SudokuCell* self);
VALA_EXTERN gint sudoku_cell_get_col (SudokuCell* self);
VALA_EXTERN gboolean sudoku_view_get_highlight_block (SudokuView* self);
VALA_EXTERN void sudoku_cell_set_highlight_coord (SudokuCell* self,
                                      gboolean value);
VALA_EXTERN void sudoku_cell_update_value_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_all_earmark_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_view_dismiss_picker (SudokuView* self);
static void sudoku_view_real_dispose (GObject* base);
VALA_EXTERN void sudoku_view_set_earmark_mode (SudokuView* self,
                                   gboolean value);
VALA_EXTERN gboolean sudoku_view_get_autoclean_earmarks (SudokuView* self);
VALA_EXTERN void sudoku_view_set_autoclean_earmarks (SudokuView* self,
                                         gboolean value);
VALA_EXTERN gboolean sudoku_view_get_number_picker_second_click (SudokuView* self);
VALA_EXTERN void sudoku_view_set_number_picker_second_click (SudokuView* self,
                                                 gboolean value);
VALA_EXTERN void sudoku_view_set_highlight_row_column (SudokuView* self,
                                           gboolean value);
VALA_EXTERN void sudoku_view_set_highlight_block (SudokuView* self,
                                      gboolean value);
VALA_EXTERN void sudoku_view_set_highlight_numbers (SudokuView* self,
                                        gboolean value);
VALA_EXTERN gdouble sudoku_view_get_value_zoom_multiplier (SudokuView* self);
static void sudoku_view_set_value_zoom_multiplier (SudokuView* self,
                                            gdouble value);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_earmark_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_earmark_warnings (SudokuView* self,
                                            gboolean value);
VALA_EXTERN gboolean sudoku_view_get_solution_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_solution_warnings (SudokuView* self,
                                        gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
VALA_EXTERN gboolean sudoku_view_get_has_selection (SudokuView* self);
VALA_EXTERN ZoomLevel sudoku_view_get_zoom_level (SudokuView* self);
VALA_EXTERN void sudoku_view_set_zoom_level (SudokuView* self,
                                 ZoomLevel value);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
VALA_EXTERN gboolean zoom_level_is_fully_zoomed_out (ZoomLevel self);
VALA_EXTERN gboolean zoom_level_is_fully_zoomed_in (ZoomLevel self);
VALA_EXTERN ZoomLevel zoom_level_zoom_in (ZoomLevel self);
VALA_EXTERN ZoomLevel zoom_level_zoom_out (ZoomLevel self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 58 "../src/view.vala"
	return self ? g_object_ref (self) : NULL;
#line 387 "view.c"
}

static void
_sudoku_view_value_changed_cb_sudoku_board_value_changed (SudokuBoard* _sender,
                                                          gint row,
                                                          gint col,
                                                          gint old_val,
                                                          gint new_val,
                                                          gpointer self)
{
#line 130 "../src/view.vala"
	sudoku_view_value_changed_cb ((SudokuView*) self, row, col, old_val, new_val);
#line 400 "view.c"
}

static void
_sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                              gint row,
                                                              gint col,
                                                              gint num,
                                                              gboolean enabled,
                                                              gpointer self)
{
#line 131 "../src/view.vala"
	sudoku_view_earmark_changed_cb ((SudokuView*) self, row, col, num, enabled);
#line 413 "view.c"
}

static void
_sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                 gint old_row,
                                                                 gint old_col,
                                                                 gint new_row,
                                                                 gint new_col,
                                                                 gpointer self)
{
#line 132 "../src/view.vala"
	sudoku_view_selection_changed_cb ((SudokuView*) self, old_row, old_col, new_row, new_col);
#line 426 "view.c"
}

static void
_sudoku_view_paused_cb_g_object_notify (GObject* _sender,
                                        GParamSpec* pspec,
                                        gpointer self)
{
#line 133 "../src/view.vala"
	sudoku_view_paused_cb ((SudokuView*) self);
#line 436 "view.c"
}

static gboolean
_sudoku_view_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_view_key_pressed_cb ((SudokuView*) self, keyval, keycode, state);
#line 136 "../src/view.vala"
	return result;
#line 450 "view.c"
}

static void
__lambda5_ (SudokuView* self)
{
	GtkWindow* window = NULL;
	GtkRoot* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 141 "../src/view.vala"
	_tmp0_ = gtk_widget_get_root ((GtkWidget*) self);
#line 141 "../src/view.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL);
#line 141 "../src/view.vala"
	window = _tmp1_;
#line 142 "../src/view.vala"
	_tmp2_ = window;
#line 142 "../src/view.vala"
	g_object_get (_tmp2_, "is-active", &_tmp3_, NULL);
#line 142 "../src/view.vala"
	_tmp4_ = _tmp3_;
#line 142 "../src/view.vala"
	if (_tmp4_) {
#line 143 "../src/view.vala"
		sudoku_view_set_has_selection (self, FALSE);
#line 478 "view.c"
	}
#line 140 "../src/view.vala"
	_g_object_unref0 (window);
#line 482 "view.c"
}

static void
___lambda5__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                              gpointer self)
{
#line 140 "../src/view.vala"
	__lambda5_ ((SudokuView*) self);
#line 491 "view.c"
}

SudokuView*
sudoku_view_construct (GType object_type,
                       SudokuGame* game,
                       GSettings* settings)
{
	SudokuView * self = NULL;
	SudokuGame* _tmp0_;
	GSettings* _tmp1_;
	GameMode _tmp2_;
	GameMode _tmp3_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp4_;
	GtkOverlay* _tmp5_;
	SudokuFrame* _tmp6_;
	SudokuFrame* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkOverlay* _tmp10_;
	GtkLabel* _tmp11_;
	GtkOverlay* _tmp12_;
	SudokuNumberPicker* _tmp13_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp14_ = NULL;
	GtkGrid* _tmp15_;
	GtkOverlay* _tmp16_;
	GtkGrid* _tmp17_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp18_;
	SudokuBoard* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	SudokuBoard* _tmp22_;
	SudokuBoard* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GtkGrid** _tmp26_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp50_;
	SudokuBoard* _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	SudokuBoard* _tmp54_;
	SudokuBoard* _tmp55_;
	gint _tmp56_;
	gint _tmp57_;
	SudokuCell** _tmp58_;
	SudokuGame* _tmp94_;
	SudokuBoard* _tmp95_;
	SudokuBoard* _tmp96_;
	SudokuGame* _tmp97_;
	SudokuBoard* _tmp98_;
	SudokuBoard* _tmp99_;
	GtkEventControllerKey* _tmp100_;
	GtkEventControllerKey* _tmp101_;
	GtkEventControllerKey* _tmp102_;
	GtkEventController* _tmp103_;
	GtkEventControllerFocus* _tmp104_;
	GtkEventControllerFocus* _tmp105_;
	GtkEventControllerFocus* _tmp106_;
	GtkEventController* _tmp107_;
#line 56 "../src/view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 56 "../src/view.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 56 "../src/view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 58 "../src/view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 58 "../src/view.vala"
	_g_object_unref0 (self->priv->game);
#line 58 "../src/view.vala"
	self->priv->game = _tmp0_;
#line 59 "../src/view.vala"
	_tmp1_ = _g_object_ref0 (settings);
#line 59 "../src/view.vala"
	_g_object_unref0 (self->priv->settings);
#line 59 "../src/view.vala"
	self->priv->settings = _tmp1_;
#line 61 "../src/view.vala"
	_tmp2_ = sudoku_game_get_mode (game);
#line 61 "../src/view.vala"
	_tmp3_ = _tmp2_;
#line 61 "../src/view.vala"
	if (_tmp3_ == GAME_MODE_CREATE) {
#line 62 "../src/view.vala"
		self->priv->_show_warnings = TRUE;
#line 581 "view.c"
	} else {
#line 64 "../src/view.vala"
		g_settings_bind (settings, "show-warnings", (GObject*) self, "show-warnings", G_SETTINGS_BIND_GET);
#line 585 "view.c"
	}
#line 66 "../src/view.vala"
	g_settings_bind (settings, "solution-warnings", (GObject*) self, "solution-warnings", G_SETTINGS_BIND_GET);
#line 67 "../src/view.vala"
	g_settings_bind (settings, "show-earmark-warnings", (GObject*) self, "show-earmark-warnings", G_SETTINGS_BIND_GET);
#line 68 "../src/view.vala"
	g_settings_bind (settings, "autoclean-earmarks", (GObject*) self, "autoclean-earmarks", G_SETTINGS_BIND_GET);
#line 69 "../src/view.vala"
	g_settings_bind (settings, "number-picker-second-click", (GObject*) self, "number-picker-second-click", G_SETTINGS_BIND_GET);
#line 70 "../src/view.vala"
	g_settings_bind (settings, "highlighter", (GObject*) self, "highlighter", G_SETTINGS_BIND_GET);
#line 71 "../src/view.vala"
	g_settings_bind (settings, "highlight-row-column", (GObject*) self, "highlight-row-column", G_SETTINGS_BIND_GET);
#line 72 "../src/view.vala"
	g_settings_bind (settings, "highlight-block", (GObject*) self, "highlight-block", G_SETTINGS_BIND_GET);
#line 73 "../src/view.vala"
	g_settings_bind (settings, "highlight-numbers", (GObject*) self, "highlight-numbers", G_SETTINGS_BIND_GET);
#line 74 "../src/view.vala"
	g_settings_bind (settings, "zoom-level", (GObject*) self, "zoom-level", G_SETTINGS_BIND_GET);
#line 75 "../src/view.vala"
	g_settings_bind (settings, "show-possibilities", (GObject*) self, "show-possibilities", G_SETTINGS_BIND_GET);
#line 77 "../src/view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 78 "../src/view.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 80 "../src/view.vala"
	_tmp4_ = (GtkOverlay*) gtk_overlay_new ();
#line 80 "../src/view.vala"
	g_object_ref_sink (_tmp4_);
#line 80 "../src/view.vala"
	overlay = _tmp4_;
#line 81 "../src/view.vala"
	_tmp5_ = overlay;
#line 81 "../src/view.vala"
	_tmp6_ = sudoku_frame_new ((GtkWidget*) _tmp5_);
#line 81 "../src/view.vala"
	g_object_ref_sink (_tmp6_);
#line 81 "../src/view.vala"
	_g_object_unref0 (self->priv->frame);
#line 81 "../src/view.vala"
	self->priv->frame = _tmp6_;
#line 82 "../src/view.vala"
	_tmp7_ = self->priv->frame;
#line 82 "../src/view.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp7_);
#line 84 "../src/view.vala"
	_tmp8_ = (GtkLabel*) gtk_label_new (_ ("Paused"));
#line 84 "../src/view.vala"
	g_object_ref_sink (_tmp8_);
#line 84 "../src/view.vala"
	_g_object_unref0 (self->priv->paused_label);
#line 84 "../src/view.vala"
	self->priv->paused_label = _tmp8_;
#line 85 "../src/view.vala"
	_tmp9_ = self->priv->paused_label;
#line 85 "../src/view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 86 "../src/view.vala"
	_tmp10_ = overlay;
#line 86 "../src/view.vala"
	_tmp11_ = self->priv->paused_label;
#line 86 "../src/view.vala"
	gtk_overlay_add_overlay (_tmp10_, (GtkWidget*) _tmp11_);
#line 87 "../src/view.vala"
	_tmp12_ = overlay;
#line 87 "../src/view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp12_, "paused");
#line 89 "../src/view.vala"
	_tmp13_ = sudoku_number_picker_new (game);
#line 89 "../src/view.vala"
	g_object_ref_sink (_tmp13_);
#line 89 "../src/view.vala"
	_g_object_unref0 (self->number_picker);
#line 89 "../src/view.vala"
	self->number_picker = _tmp13_;
#line 91 "../src/view.vala"
	_tmp14_ = (GtkGrid*) gtk_grid_new ();
#line 91 "../src/view.vala"
	gtk_grid_set_row_spacing (_tmp14_, 2);
#line 91 "../src/view.vala"
	gtk_grid_set_column_spacing (_tmp14_, 2);
#line 91 "../src/view.vala"
	gtk_grid_set_column_homogeneous (_tmp14_, TRUE);
#line 91 "../src/view.vala"
	gtk_grid_set_row_homogeneous (_tmp14_, TRUE);
#line 91 "../src/view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp14_, TRUE);
#line 91 "../src/view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp14_, TRUE);
#line 91 "../src/view.vala"
	g_object_ref_sink (_tmp14_);
#line 91 "../src/view.vala"
	grid = _tmp14_;
#line 99 "../src/view.vala"
	_tmp15_ = grid;
#line 99 "../src/view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp15_, "board");
#line 100 "../src/view.vala"
	_tmp16_ = overlay;
#line 100 "../src/view.vala"
	_tmp17_ = grid;
#line 100 "../src/view.vala"
	gtk_overlay_set_child (_tmp16_, (GtkWidget*) _tmp17_);
#line 102 "../src/view.vala"
	_tmp18_ = sudoku_game_get_board (game);
#line 102 "../src/view.vala"
	_tmp19_ = _tmp18_;
#line 102 "../src/view.vala"
	_tmp20_ = sudoku_board_get_block_rows (_tmp19_);
#line 102 "../src/view.vala"
	_tmp21_ = _tmp20_;
#line 102 "../src/view.vala"
	_tmp22_ = sudoku_game_get_board (game);
#line 102 "../src/view.vala"
	_tmp23_ = _tmp22_;
#line 102 "../src/view.vala"
	_tmp24_ = sudoku_board_get_block_cols (_tmp23_);
#line 102 "../src/view.vala"
	_tmp25_ = _tmp24_;
#line 102 "../src/view.vala"
	_tmp26_ = g_new0 (GtkGrid*, (_tmp21_ * _tmp25_) + 1);
#line 102 "../src/view.vala"
	blocks = _tmp26_;
#line 102 "../src/view.vala"
	blocks_length1 = _tmp21_;
#line 102 "../src/view.vala"
	blocks_length2 = _tmp25_;
#line 713 "view.c"
	{
		gint block_row = 0;
#line 103 "../src/view.vala"
		block_row = 0;
#line 718 "view.c"
		{
			gboolean _tmp27_ = FALSE;
#line 103 "../src/view.vala"
			_tmp27_ = TRUE;
#line 103 "../src/view.vala"
			while (TRUE) {
#line 725 "view.c"
				SudokuBoard* _tmp29_;
				SudokuBoard* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
#line 103 "../src/view.vala"
				if (!_tmp27_) {
#line 732 "view.c"
					gint _tmp28_;
#line 103 "../src/view.vala"
					_tmp28_ = block_row;
#line 103 "../src/view.vala"
					block_row = _tmp28_ + 1;
#line 738 "view.c"
				}
#line 103 "../src/view.vala"
				_tmp27_ = FALSE;
#line 103 "../src/view.vala"
				_tmp29_ = sudoku_game_get_board (game);
#line 103 "../src/view.vala"
				_tmp30_ = _tmp29_;
#line 103 "../src/view.vala"
				_tmp31_ = sudoku_board_get_block_rows (_tmp30_);
#line 103 "../src/view.vala"
				_tmp32_ = _tmp31_;
#line 103 "../src/view.vala"
				if (!(block_row < _tmp32_)) {
#line 103 "../src/view.vala"
					break;
#line 754 "view.c"
				}
				{
					gint block_col = 0;
#line 105 "../src/view.vala"
					block_col = 0;
#line 760 "view.c"
					{
						gboolean _tmp33_ = FALSE;
#line 105 "../src/view.vala"
						_tmp33_ = TRUE;
#line 105 "../src/view.vala"
						while (TRUE) {
#line 767 "view.c"
							SudokuBoard* _tmp35_;
							SudokuBoard* _tmp36_;
							gint _tmp37_;
							gint _tmp38_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp39_;
							GtkGrid* _tmp40_;
							GtkGrid* _tmp41_;
							GtkGrid* _tmp42_;
							GtkGrid* _tmp43_;
							GtkGrid* _tmp44_;
							GtkGrid* _tmp45_;
							GtkGrid* _tmp46_;
							GtkGrid** _tmp47_;
							gint _tmp47__length1;
							gint _tmp47__length2;
							GtkGrid* _tmp48_;
							GtkGrid* _tmp49_;
#line 105 "../src/view.vala"
							if (!_tmp33_) {
#line 788 "view.c"
								gint _tmp34_;
#line 105 "../src/view.vala"
								_tmp34_ = block_col;
#line 105 "../src/view.vala"
								block_col = _tmp34_ + 1;
#line 794 "view.c"
							}
#line 105 "../src/view.vala"
							_tmp33_ = FALSE;
#line 105 "../src/view.vala"
							_tmp35_ = sudoku_game_get_board (game);
#line 105 "../src/view.vala"
							_tmp36_ = _tmp35_;
#line 105 "../src/view.vala"
							_tmp37_ = sudoku_board_get_block_cols (_tmp36_);
#line 105 "../src/view.vala"
							_tmp38_ = _tmp37_;
#line 105 "../src/view.vala"
							if (!(block_col < _tmp38_)) {
#line 105 "../src/view.vala"
								break;
#line 810 "view.c"
							}
#line 107 "../src/view.vala"
							_tmp39_ = (GtkGrid*) gtk_grid_new ();
#line 107 "../src/view.vala"
							g_object_ref_sink (_tmp39_);
#line 107 "../src/view.vala"
							block_grid = _tmp39_;
#line 108 "../src/view.vala"
							_tmp40_ = block_grid;
#line 108 "../src/view.vala"
							gtk_grid_set_row_spacing (_tmp40_, 1);
#line 109 "../src/view.vala"
							_tmp41_ = block_grid;
#line 109 "../src/view.vala"
							gtk_grid_set_column_spacing (_tmp41_, 1);
#line 110 "../src/view.vala"
							_tmp42_ = block_grid;
#line 110 "../src/view.vala"
							gtk_grid_set_column_homogeneous (_tmp42_, TRUE);
#line 111 "../src/view.vala"
							_tmp43_ = block_grid;
#line 111 "../src/view.vala"
							gtk_grid_set_row_homogeneous (_tmp43_, TRUE);
#line 112 "../src/view.vala"
							_tmp44_ = block_grid;
#line 112 "../src/view.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp44_, "block");
#line 113 "../src/view.vala"
							_tmp45_ = grid;
#line 113 "../src/view.vala"
							_tmp46_ = block_grid;
#line 113 "../src/view.vala"
							gtk_grid_attach (_tmp45_, (GtkWidget*) _tmp46_, block_col, block_row, 1, 1);
#line 115 "../src/view.vala"
							_tmp47_ = blocks;
#line 115 "../src/view.vala"
							_tmp47__length1 = blocks_length1;
#line 115 "../src/view.vala"
							_tmp47__length2 = blocks_length2;
#line 115 "../src/view.vala"
							_tmp48_ = block_grid;
#line 115 "../src/view.vala"
							_tmp49_ = _g_object_ref0 (_tmp48_);
#line 115 "../src/view.vala"
							_g_object_unref0 (_tmp47_[(block_row * _tmp47__length2) + block_col]);
#line 115 "../src/view.vala"
							_tmp47_[(block_row * _tmp47__length2) + block_col] = _tmp49_;
#line 105 "../src/view.vala"
							_g_object_unref0 (block_grid);
#line 860 "view.c"
						}
					}
				}
			}
		}
	}
#line 119 "../src/view.vala"
	_tmp50_ = sudoku_game_get_board (game);
#line 119 "../src/view.vala"
	_tmp51_ = _tmp50_;
#line 119 "../src/view.vala"
	_tmp52_ = sudoku_board_get_rows (_tmp51_);
#line 119 "../src/view.vala"
	_tmp53_ = _tmp52_;
#line 119 "../src/view.vala"
	_tmp54_ = sudoku_game_get_board (game);
#line 119 "../src/view.vala"
	_tmp55_ = _tmp54_;
#line 119 "../src/view.vala"
	_tmp56_ = sudoku_board_get_cols (_tmp55_);
#line 119 "../src/view.vala"
	_tmp57_ = _tmp56_;
#line 119 "../src/view.vala"
	_tmp58_ = g_new0 (SudokuCell*, (_tmp53_ * _tmp57_) + 1);
#line 119 "../src/view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 119 "../src/view.vala"
	self->priv->cells = _tmp58_;
#line 119 "../src/view.vala"
	self->priv->cells_length1 = _tmp53_;
#line 119 "../src/view.vala"
	self->priv->cells_length2 = _tmp57_;
#line 893 "view.c"
	{
		gint row = 0;
#line 120 "../src/view.vala"
		row = 0;
#line 898 "view.c"
		{
			gboolean _tmp59_ = FALSE;
#line 120 "../src/view.vala"
			_tmp59_ = TRUE;
#line 120 "../src/view.vala"
			while (TRUE) {
#line 905 "view.c"
				SudokuBoard* _tmp61_;
				SudokuBoard* _tmp62_;
				gint _tmp63_;
				gint _tmp64_;
#line 120 "../src/view.vala"
				if (!_tmp59_) {
#line 912 "view.c"
					gint _tmp60_;
#line 120 "../src/view.vala"
					_tmp60_ = row;
#line 120 "../src/view.vala"
					row = _tmp60_ + 1;
#line 918 "view.c"
				}
#line 120 "../src/view.vala"
				_tmp59_ = FALSE;
#line 120 "../src/view.vala"
				_tmp61_ = sudoku_game_get_board (game);
#line 120 "../src/view.vala"
				_tmp62_ = _tmp61_;
#line 120 "../src/view.vala"
				_tmp63_ = sudoku_board_get_rows (_tmp62_);
#line 120 "../src/view.vala"
				_tmp64_ = _tmp63_;
#line 120 "../src/view.vala"
				if (!(row < _tmp64_)) {
#line 120 "../src/view.vala"
					break;
#line 934 "view.c"
				}
				{
					gint col = 0;
#line 122 "../src/view.vala"
					col = 0;
#line 940 "view.c"
					{
						gboolean _tmp65_ = FALSE;
#line 122 "../src/view.vala"
						_tmp65_ = TRUE;
#line 122 "../src/view.vala"
						while (TRUE) {
#line 947 "view.c"
							SudokuBoard* _tmp67_;
							SudokuBoard* _tmp68_;
							gint _tmp69_;
							gint _tmp70_;
							SudokuCell* cell = NULL;
							SudokuCell* _tmp71_;
							GtkGrid** _tmp72_;
							gint _tmp72__length1;
							gint _tmp72__length2;
							SudokuBoard* _tmp73_;
							SudokuBoard* _tmp74_;
							gint _tmp75_;
							gint _tmp76_;
							SudokuBoard* _tmp77_;
							SudokuBoard* _tmp78_;
							gint _tmp79_;
							gint _tmp80_;
							GtkGrid* _tmp81_;
							SudokuCell* _tmp82_;
							SudokuBoard* _tmp83_;
							SudokuBoard* _tmp84_;
							gint _tmp85_;
							gint _tmp86_;
							SudokuBoard* _tmp87_;
							SudokuBoard* _tmp88_;
							gint _tmp89_;
							gint _tmp90_;
							SudokuCell** _tmp91_;
							gint _tmp91__length1;
							gint _tmp91__length2;
							SudokuCell* _tmp92_;
							SudokuCell* _tmp93_;
#line 122 "../src/view.vala"
							if (!_tmp65_) {
#line 982 "view.c"
								gint _tmp66_;
#line 122 "../src/view.vala"
								_tmp66_ = col;
#line 122 "../src/view.vala"
								col = _tmp66_ + 1;
#line 988 "view.c"
							}
#line 122 "../src/view.vala"
							_tmp65_ = FALSE;
#line 122 "../src/view.vala"
							_tmp67_ = sudoku_game_get_board (game);
#line 122 "../src/view.vala"
							_tmp68_ = _tmp67_;
#line 122 "../src/view.vala"
							_tmp69_ = sudoku_board_get_cols (_tmp68_);
#line 122 "../src/view.vala"
							_tmp70_ = _tmp69_;
#line 122 "../src/view.vala"
							if (!(col < _tmp70_)) {
#line 122 "../src/view.vala"
								break;
#line 1004 "view.c"
							}
#line 124 "../src/view.vala"
							_tmp71_ = sudoku_cell_new (row, col, game, self);
#line 124 "../src/view.vala"
							g_object_ref_sink (_tmp71_);
#line 124 "../src/view.vala"
							cell = _tmp71_;
#line 125 "../src/view.vala"
							_tmp72_ = blocks;
#line 125 "../src/view.vala"
							_tmp72__length1 = blocks_length1;
#line 125 "../src/view.vala"
							_tmp72__length2 = blocks_length2;
#line 125 "../src/view.vala"
							_tmp73_ = sudoku_game_get_board (game);
#line 125 "../src/view.vala"
							_tmp74_ = _tmp73_;
#line 125 "../src/view.vala"
							_tmp75_ = sudoku_board_get_block_rows (_tmp74_);
#line 125 "../src/view.vala"
							_tmp76_ = _tmp75_;
#line 125 "../src/view.vala"
							_tmp77_ = sudoku_game_get_board (game);
#line 125 "../src/view.vala"
							_tmp78_ = _tmp77_;
#line 125 "../src/view.vala"
							_tmp79_ = sudoku_board_get_block_cols (_tmp78_);
#line 125 "../src/view.vala"
							_tmp80_ = _tmp79_;
#line 125 "../src/view.vala"
							_tmp81_ = _tmp72_[((row / _tmp76_) * _tmp72__length2) + (col / _tmp80_)];
#line 125 "../src/view.vala"
							_tmp82_ = cell;
#line 125 "../src/view.vala"
							_tmp83_ = sudoku_game_get_board (game);
#line 125 "../src/view.vala"
							_tmp84_ = _tmp83_;
#line 125 "../src/view.vala"
							_tmp85_ = sudoku_board_get_block_cols (_tmp84_);
#line 125 "../src/view.vala"
							_tmp86_ = _tmp85_;
#line 125 "../src/view.vala"
							_tmp87_ = sudoku_game_get_board (game);
#line 125 "../src/view.vala"
							_tmp88_ = _tmp87_;
#line 125 "../src/view.vala"
							_tmp89_ = sudoku_board_get_block_rows (_tmp88_);
#line 125 "../src/view.vala"
							_tmp90_ = _tmp89_;
#line 125 "../src/view.vala"
							gtk_grid_attach (_tmp81_, (GtkWidget*) _tmp82_, col % _tmp86_, row % _tmp90_, 1, 1);
#line 126 "../src/view.vala"
							_tmp91_ = self->priv->cells;
#line 126 "../src/view.vala"
							_tmp91__length1 = self->priv->cells_length1;
#line 126 "../src/view.vala"
							_tmp91__length2 = self->priv->cells_length2;
#line 126 "../src/view.vala"
							_tmp92_ = cell;
#line 126 "../src/view.vala"
							_tmp93_ = _g_object_ref0 (_tmp92_);
#line 126 "../src/view.vala"
							_g_object_unref0 (_tmp91_[(row * _tmp91__length2) + col]);
#line 126 "../src/view.vala"
							_tmp91_[(row * _tmp91__length2) + col] = _tmp93_;
#line 122 "../src/view.vala"
							_g_object_unref0 (cell);
#line 1072 "view.c"
						}
					}
				}
			}
		}
	}
#line 130 "../src/view.vala"
	_tmp94_ = self->priv->game;
#line 130 "../src/view.vala"
	_tmp95_ = sudoku_game_get_board (_tmp94_);
#line 130 "../src/view.vala"
	_tmp96_ = _tmp95_;
#line 130 "../src/view.vala"
	g_signal_connect_object (_tmp96_, "value-changed", (GCallback) _sudoku_view_value_changed_cb_sudoku_board_value_changed, self, 0);
#line 131 "../src/view.vala"
	_tmp97_ = self->priv->game;
#line 131 "../src/view.vala"
	_tmp98_ = sudoku_game_get_board (_tmp97_);
#line 131 "../src/view.vala"
	_tmp99_ = _tmp98_;
#line 131 "../src/view.vala"
	g_signal_connect_object (_tmp99_, "earmark-changed", (GCallback) _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed, self, 0);
#line 132 "../src/view.vala"
	g_signal_connect_object (self, "selection-changed", (GCallback) _sudoku_view_selection_changed_cb_sudoku_view_selection_changed, self, 0);
#line 133 "../src/view.vala"
	g_signal_connect_object ((GObject*) game, "notify::paused", (GCallback) _sudoku_view_paused_cb_g_object_notify, self, 0);
#line 135 "../src/view.vala"
	_tmp100_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 135 "../src/view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 135 "../src/view.vala"
	self->priv->key_controller = _tmp100_;
#line 136 "../src/view.vala"
	_tmp101_ = self->priv->key_controller;
#line 136 "../src/view.vala"
	g_signal_connect_object (_tmp101_, "key-pressed", (GCallback) _sudoku_view_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 137 "../src/view.vala"
	_tmp102_ = self->priv->key_controller;
#line 137 "../src/view.vala"
	_tmp103_ = _g_object_ref0 ((GtkEventController*) _tmp102_);
#line 137 "../src/view.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp103_);
#line 139 "../src/view.vala"
	_tmp104_ = (GtkEventControllerFocus*) gtk_event_controller_focus_new ();
#line 139 "../src/view.vala"
	_g_object_unref0 (self->priv->focus_controller);
#line 139 "../src/view.vala"
	self->priv->focus_controller = _tmp104_;
#line 140 "../src/view.vala"
	_tmp105_ = self->priv->focus_controller;
#line 140 "../src/view.vala"
	g_signal_connect_object (_tmp105_, "leave", (GCallback) ___lambda5__gtk_event_controller_focus_leave, self, 0);
#line 145 "../src/view.vala"
	_tmp106_ = self->priv->focus_controller;
#line 145 "../src/view.vala"
	_tmp107_ = _g_object_ref0 ((GtkEventController*) _tmp106_);
#line 145 "../src/view.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp107_);
#line 147 "../src/view.vala"
	sudoku_view_update_warnings (self);
#line 56 "../src/view.vala"
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 56 "../src/view.vala"
	_g_object_unref0 (grid);
#line 56 "../src/view.vala"
	_g_object_unref0 (overlay);
#line 56 "../src/view.vala"
	return self;
#line 1141 "view.c"
}

SudokuView*
sudoku_view_new (SudokuGame* game,
                 GSettings* settings)
{
#line 56 "../src/view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, game, settings);
#line 1150 "view.c"
}

static gboolean
sudoku_view_key_pressed_cb (SudokuView* self,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean control_pressed = FALSE;
	SudokuCell* _tmp35_;
	SudokuCell* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	gboolean result;
#line 150 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "../src/view.vala"
	_tmp0_ = self->priv->game;
#line 154 "../src/view.vala"
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
#line 154 "../src/view.vala"
	_tmp2_ = _tmp1_;
#line 154 "../src/view.vala"
	if (_tmp2_) {
#line 155 "../src/view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 155 "../src/view.vala"
		return result;
#line 1182 "view.c"
	}
#line 157 "../src/view.vala"
	control_pressed = (gboolean) (state & GDK_CONTROL_MASK);
#line 159 "../src/view.vala"
	if (!control_pressed) {
#line 160 "../src/view.vala"
		switch (keyval) {
#line 160 "../src/view.vala"
			case GDK_KEY_Up:
#line 160 "../src/view.vala"
			case GDK_KEY_w:
#line 160 "../src/view.vala"
			case GDK_KEY_KP_Up:
#line 1196 "view.c"
			{
				gint _tmp3_;
#line 163 "../src/view.vala"
				_tmp3_ = self->priv->_selected_row;
#line 163 "../src/view.vala"
				if (_tmp3_ == 0) {
#line 1203 "view.c"
					SudokuCell** _tmp4_;
					gint _tmp4__length1;
					gint _tmp4__length2;
					gint _tmp5_;
					SudokuCell* _tmp6_;
#line 164 "../src/view.vala"
					_tmp4_ = self->priv->cells;
#line 164 "../src/view.vala"
					_tmp4__length1 = self->priv->cells_length1;
#line 164 "../src/view.vala"
					_tmp4__length2 = self->priv->cells_length2;
#line 164 "../src/view.vala"
					_tmp5_ = self->priv->_selected_col;
#line 164 "../src/view.vala"
					_tmp6_ = _tmp4_[(8 * _tmp4__length2) + _tmp5_];
#line 164 "../src/view.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 1221 "view.c"
				} else {
					SudokuCell** _tmp7_;
					gint _tmp7__length1;
					gint _tmp7__length2;
					gint _tmp8_;
					gint _tmp9_;
					SudokuCell* _tmp10_;
#line 166 "../src/view.vala"
					_tmp7_ = self->priv->cells;
#line 166 "../src/view.vala"
					_tmp7__length1 = self->priv->cells_length1;
#line 166 "../src/view.vala"
					_tmp7__length2 = self->priv->cells_length2;
#line 166 "../src/view.vala"
					_tmp8_ = self->priv->_selected_row;
#line 166 "../src/view.vala"
					_tmp9_ = self->priv->_selected_col;
#line 166 "../src/view.vala"
					_tmp10_ = _tmp7_[((_tmp8_ - 1) * _tmp7__length2) + _tmp9_];
#line 166 "../src/view.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 1243 "view.c"
				}
#line 167 "../src/view.vala"
				result = GDK_EVENT_STOP;
#line 167 "../src/view.vala"
				return result;
#line 1249 "view.c"
			}
#line 160 "../src/view.vala"
			case GDK_KEY_Down:
#line 160 "../src/view.vala"
			case GDK_KEY_s:
#line 160 "../src/view.vala"
			case GDK_KEY_KP_Down:
#line 1257 "view.c"
			{
				gint _tmp11_;
#line 170 "../src/view.vala"
				_tmp11_ = self->priv->_selected_row;
#line 170 "../src/view.vala"
				if (_tmp11_ == 8) {
#line 1264 "view.c"
					SudokuCell** _tmp12_;
					gint _tmp12__length1;
					gint _tmp12__length2;
					gint _tmp13_;
					SudokuCell* _tmp14_;
#line 171 "../src/view.vala"
					_tmp12_ = self->priv->cells;
#line 171 "../src/view.vala"
					_tmp12__length1 = self->priv->cells_length1;
#line 171 "../src/view.vala"
					_tmp12__length2 = self->priv->cells_length2;
#line 171 "../src/view.vala"
					_tmp13_ = self->priv->_selected_col;
#line 171 "../src/view.vala"
					_tmp14_ = _tmp12_[(0 * _tmp12__length2) + _tmp13_];
#line 171 "../src/view.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp14_);
#line 1282 "view.c"
				} else {
					SudokuCell** _tmp15_;
					gint _tmp15__length1;
					gint _tmp15__length2;
					gint _tmp16_;
					gint _tmp17_;
					SudokuCell* _tmp18_;
#line 173 "../src/view.vala"
					_tmp15_ = self->priv->cells;
#line 173 "../src/view.vala"
					_tmp15__length1 = self->priv->cells_length1;
#line 173 "../src/view.vala"
					_tmp15__length2 = self->priv->cells_length2;
#line 173 "../src/view.vala"
					_tmp16_ = self->priv->_selected_row;
#line 173 "../src/view.vala"
					_tmp17_ = self->priv->_selected_col;
#line 173 "../src/view.vala"
					_tmp18_ = _tmp15_[((_tmp16_ + 1) * _tmp15__length2) + _tmp17_];
#line 173 "../src/view.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp18_);
#line 1304 "view.c"
				}
#line 174 "../src/view.vala"
				result = GDK_EVENT_STOP;
#line 174 "../src/view.vala"
				return result;
#line 1310 "view.c"
			}
#line 160 "../src/view.vala"
			case GDK_KEY_Left:
#line 160 "../src/view.vala"
			case GDK_KEY_a:
#line 160 "../src/view.vala"
			case GDK_KEY_KP_Left:
#line 1318 "view.c"
			{
				gint _tmp19_;
#line 177 "../src/view.vala"
				_tmp19_ = self->priv->_selected_col;
#line 177 "../src/view.vala"
				if (_tmp19_ == 0) {
#line 1325 "view.c"
					SudokuCell** _tmp20_;
					gint _tmp20__length1;
					gint _tmp20__length2;
					gint _tmp21_;
					SudokuCell* _tmp22_;
#line 178 "../src/view.vala"
					_tmp20_ = self->priv->cells;
#line 178 "../src/view.vala"
					_tmp20__length1 = self->priv->cells_length1;
#line 178 "../src/view.vala"
					_tmp20__length2 = self->priv->cells_length2;
#line 178 "../src/view.vala"
					_tmp21_ = self->priv->_selected_row;
#line 178 "../src/view.vala"
					_tmp22_ = _tmp20_[(_tmp21_ * _tmp20__length2) + 8];
#line 178 "../src/view.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp22_);
#line 1343 "view.c"
				} else {
					SudokuCell** _tmp23_;
					gint _tmp23__length1;
					gint _tmp23__length2;
					gint _tmp24_;
					gint _tmp25_;
					SudokuCell* _tmp26_;
#line 180 "../src/view.vala"
					_tmp23_ = self->priv->cells;
#line 180 "../src/view.vala"
					_tmp23__length1 = self->priv->cells_length1;
#line 180 "../src/view.vala"
					_tmp23__length2 = self->priv->cells_length2;
#line 180 "../src/view.vala"
					_tmp24_ = self->priv->_selected_row;
#line 180 "../src/view.vala"
					_tmp25_ = self->priv->_selected_col;
#line 180 "../src/view.vala"
					_tmp26_ = _tmp23_[(_tmp24_ * _tmp23__length2) + (_tmp25_ - 1)];
#line 180 "../src/view.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp26_);
#line 1365 "view.c"
				}
#line 181 "../src/view.vala"
				result = GDK_EVENT_STOP;
#line 181 "../src/view.vala"
				return result;
#line 1371 "view.c"
			}
#line 160 "../src/view.vala"
			case GDK_KEY_Right:
#line 160 "../src/view.vala"
			case GDK_KEY_d:
#line 160 "../src/view.vala"
			case GDK_KEY_KP_Right:
#line 1379 "view.c"
			{
				gint _tmp27_;
#line 184 "../src/view.vala"
				_tmp27_ = self->priv->_selected_col;
#line 184 "../src/view.vala"
				if (_tmp27_ == 8) {
#line 1386 "view.c"
					SudokuCell** _tmp28_;
					gint _tmp28__length1;
					gint _tmp28__length2;
					gint _tmp29_;
					SudokuCell* _tmp30_;
#line 185 "../src/view.vala"
					_tmp28_ = self->priv->cells;
#line 185 "../src/view.vala"
					_tmp28__length1 = self->priv->cells_length1;
#line 185 "../src/view.vala"
					_tmp28__length2 = self->priv->cells_length2;
#line 185 "../src/view.vala"
					_tmp29_ = self->priv->_selected_row;
#line 185 "../src/view.vala"
					_tmp30_ = _tmp28_[(_tmp29_ * _tmp28__length2) + 0];
#line 185 "../src/view.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp30_);
#line 1404 "view.c"
				} else {
					SudokuCell** _tmp31_;
					gint _tmp31__length1;
					gint _tmp31__length2;
					gint _tmp32_;
					gint _tmp33_;
					SudokuCell* _tmp34_;
#line 187 "../src/view.vala"
					_tmp31_ = self->priv->cells;
#line 187 "../src/view.vala"
					_tmp31__length1 = self->priv->cells_length1;
#line 187 "../src/view.vala"
					_tmp31__length2 = self->priv->cells_length2;
#line 187 "../src/view.vala"
					_tmp32_ = self->priv->_selected_row;
#line 187 "../src/view.vala"
					_tmp33_ = self->priv->_selected_col;
#line 187 "../src/view.vala"
					_tmp34_ = _tmp31_[(_tmp32_ * _tmp31__length2) + (_tmp33_ + 1)];
#line 187 "../src/view.vala"
					gtk_widget_grab_focus ((GtkWidget*) _tmp34_);
#line 1426 "view.c"
				}
#line 188 "../src/view.vala"
				result = GDK_EVENT_STOP;
#line 188 "../src/view.vala"
				return result;
#line 1432 "view.c"
			}
			default:
			{
#line 191 "../src/view.vala"
				break;
#line 1438 "view.c"
			}
		}
	}
#line 194 "../src/view.vala"
	_tmp35_ = sudoku_view_get_selected_cell (self);
#line 194 "../src/view.vala"
	_tmp36_ = _tmp35_;
#line 194 "../src/view.vala"
	_tmp37_ = sudoku_cell_get_is_fixed (_tmp36_);
#line 194 "../src/view.vala"
	_tmp38_ = _tmp37_;
#line 194 "../src/view.vala"
	if (_tmp38_) {
#line 195 "../src/view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 195 "../src/view.vala"
		return result;
#line 1456 "view.c"
	}
#line 197 "../src/view.vala"
	switch (keyval) {
#line 197 "../src/view.vala"
		case GDK_KEY_0:
#line 197 "../src/view.vala"
		case GDK_KEY_KP_0:
#line 197 "../src/view.vala"
		case GDK_KEY_BackSpace:
#line 197 "../src/view.vala"
		case GDK_KEY_Delete:
#line 1468 "view.c"
		{
#line 200 "../src/view.vala"
			if (control_pressed) {
#line 201 "../src/view.vala"
				result = GDK_EVENT_PROPAGATE;
#line 201 "../src/view.vala"
				return result;
#line 1476 "view.c"
			} else {
				SudokuCell* _tmp39_;
				SudokuCell* _tmp40_;
#line 204 "../src/view.vala"
				_tmp39_ = sudoku_view_get_selected_cell (self);
#line 204 "../src/view.vala"
				_tmp40_ = _tmp39_;
#line 204 "../src/view.vala"
				sudoku_cell_set_value (_tmp40_, 0);
#line 205 "../src/view.vala"
				result = GDK_EVENT_STOP;
#line 205 "../src/view.vala"
				return result;
#line 1490 "view.c"
			}
		}
#line 197 "../src/view.vala"
		case GDK_KEY_1:
#line 197 "../src/view.vala"
		case GDK_KEY_KP_1:
#line 1497 "view.c"
		{
#line 208 "../src/view.vala"
			sudoku_view_insert_key (self, 1, control_pressed);
#line 209 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 209 "../src/view.vala"
			return result;
#line 1505 "view.c"
		}
#line 197 "../src/view.vala"
		case GDK_KEY_2:
#line 197 "../src/view.vala"
		case GDK_KEY_KP_2:
#line 1511 "view.c"
		{
#line 211 "../src/view.vala"
			sudoku_view_insert_key (self, 2, control_pressed);
#line 212 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 212 "../src/view.vala"
			return result;
#line 1519 "view.c"
		}
#line 197 "../src/view.vala"
		case GDK_KEY_3:
#line 197 "../src/view.vala"
		case GDK_KEY_KP_3:
#line 1525 "view.c"
		{
#line 214 "../src/view.vala"
			sudoku_view_insert_key (self, 3, control_pressed);
#line 215 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 215 "../src/view.vala"
			return result;
#line 1533 "view.c"
		}
#line 197 "../src/view.vala"
		case GDK_KEY_4:
#line 197 "../src/view.vala"
		case GDK_KEY_KP_4:
#line 1539 "view.c"
		{
#line 217 "../src/view.vala"
			sudoku_view_insert_key (self, 4, control_pressed);
#line 218 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 218 "../src/view.vala"
			return result;
#line 1547 "view.c"
		}
#line 197 "../src/view.vala"
		case GDK_KEY_5:
#line 197 "../src/view.vala"
		case GDK_KEY_KP_5:
#line 1553 "view.c"
		{
#line 220 "../src/view.vala"
			sudoku_view_insert_key (self, 5, control_pressed);
#line 221 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 221 "../src/view.vala"
			return result;
#line 1561 "view.c"
		}
#line 197 "../src/view.vala"
		case GDK_KEY_6:
#line 197 "../src/view.vala"
		case GDK_KEY_KP_6:
#line 1567 "view.c"
		{
#line 223 "../src/view.vala"
			sudoku_view_insert_key (self, 6, control_pressed);
#line 224 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 224 "../src/view.vala"
			return result;
#line 1575 "view.c"
		}
#line 197 "../src/view.vala"
		case GDK_KEY_7:
#line 197 "../src/view.vala"
		case GDK_KEY_KP_7:
#line 1581 "view.c"
		{
#line 226 "../src/view.vala"
			sudoku_view_insert_key (self, 7, control_pressed);
#line 227 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 227 "../src/view.vala"
			return result;
#line 1589 "view.c"
		}
#line 197 "../src/view.vala"
		case GDK_KEY_8:
#line 197 "../src/view.vala"
		case GDK_KEY_KP_8:
#line 1595 "view.c"
		{
#line 229 "../src/view.vala"
			sudoku_view_insert_key (self, 8, control_pressed);
#line 230 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 230 "../src/view.vala"
			return result;
#line 1603 "view.c"
		}
#line 197 "../src/view.vala"
		case GDK_KEY_9:
#line 197 "../src/view.vala"
		case GDK_KEY_KP_9:
#line 1609 "view.c"
		{
#line 232 "../src/view.vala"
			sudoku_view_insert_key (self, 9, control_pressed);
#line 233 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 233 "../src/view.vala"
			return result;
#line 1617 "view.c"
		}
#line 197 "../src/view.vala"
		case GDK_KEY_Escape:
#line 1621 "view.c"
		{
			SudokuNumberPicker* _tmp41_;
#line 236 "../src/view.vala"
			_tmp41_ = self->number_picker;
#line 236 "../src/view.vala"
			gtk_popover_popdown ((GtkPopover*) _tmp41_);
#line 237 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 237 "../src/view.vala"
			return result;
#line 1632 "view.c"
		}
#line 197 "../src/view.vala"
		case GDK_KEY_space:
#line 197 "../src/view.vala"
		case GDK_KEY_Return:
#line 197 "../src/view.vala"
		case GDK_KEY_KP_Enter:
#line 1640 "view.c"
		{
			SudokuCell* _tmp42_;
			SudokuCell* _tmp43_;
			gboolean wants_value = FALSE;
			gboolean _tmp44_;
#line 240 "../src/view.vala"
			_tmp42_ = sudoku_view_get_selected_cell (self);
#line 240 "../src/view.vala"
			_tmp43_ = _tmp42_;
#line 240 "../src/view.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp43_);
#line 241 "../src/view.vala"
			wants_value = !control_pressed;
#line 242 "../src/view.vala"
			_tmp44_ = self->priv->_earmark_mode;
#line 242 "../src/view.vala"
			wants_value = wants_value ^ _tmp44_;
#line 244 "../src/view.vala"
			if (wants_value) {
#line 1660 "view.c"
				SudokuNumberPicker* _tmp45_;
				SudokuCell* _tmp46_;
				SudokuCell* _tmp47_;
#line 245 "../src/view.vala"
				_tmp45_ = self->number_picker;
#line 245 "../src/view.vala"
				_tmp46_ = sudoku_view_get_selected_cell (self);
#line 245 "../src/view.vala"
				_tmp47_ = _tmp46_;
#line 245 "../src/view.vala"
				sudoku_number_picker_show_value_picker (_tmp45_, _tmp47_);
#line 1672 "view.c"
			} else {
				SudokuNumberPicker* _tmp48_;
				SudokuCell* _tmp49_;
				SudokuCell* _tmp50_;
#line 247 "../src/view.vala"
				_tmp48_ = self->number_picker;
#line 247 "../src/view.vala"
				_tmp49_ = sudoku_view_get_selected_cell (self);
#line 247 "../src/view.vala"
				_tmp50_ = _tmp49_;
#line 247 "../src/view.vala"
				sudoku_number_picker_show_earmark_picker (_tmp48_, _tmp50_);
#line 1685 "view.c"
			}
#line 249 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 249 "../src/view.vala"
			return result;
#line 1691 "view.c"
		}
		default:
		{
#line 252 "../src/view.vala"
			result = GDK_EVENT_PROPAGATE;
#line 252 "../src/view.vala"
			return result;
#line 1699 "view.c"
		}
	}
}

static void
sudoku_view_selection_changed_cb (SudokuView* self,
                                  gint old_row,
                                  gint old_col,
                                  gint new_row,
                                  gint new_col)
{
	SudokuNumberPicker* _tmp0_;
#line 256 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/view.vala"
	sudoku_view_set_cell_highlighter (self, old_row, old_col, FALSE);
#line 259 "../src/view.vala"
	sudoku_view_set_cell_highlighter (self, new_row, new_col, TRUE);
#line 260 "../src/view.vala"
	_tmp0_ = self->number_picker;
#line 260 "../src/view.vala"
	gtk_popover_popdown ((GtkPopover*) _tmp0_);
#line 1722 "view.c"
}

static void
sudoku_view_value_changed_cb (SudokuView* self,
                              gint row,
                              gint col,
                              gint old_val,
                              gint new_val)
{
	StackAction action = 0;
	SudokuGame* _tmp0_;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	SudokuCell* _tmp4_;
#line 263 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/view.vala"
	_tmp0_ = self->priv->game;
#line 265 "../src/view.vala"
	action = sudoku_game_get_current_stack_action (_tmp0_);
#line 266 "../src/view.vala"
	if (stack_action_is_single_value_change (action)) {
#line 1746 "view.c"
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
#line 267 "../src/view.vala"
		_tmp1_ = self->priv->cells;
#line 267 "../src/view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 267 "../src/view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 267 "../src/view.vala"
		_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
#line 267 "../src/view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
#line 1761 "view.c"
	}
#line 269 "../src/view.vala"
	_tmp3_ = self->priv->cells;
#line 269 "../src/view.vala"
	_tmp3__length1 = self->priv->cells_length1;
#line 269 "../src/view.vala"
	_tmp3__length2 = self->priv->cells_length2;
#line 269 "../src/view.vala"
	_tmp4_ = _tmp3_[(row * _tmp3__length2) + col];
#line 269 "../src/view.vala"
	sudoku_cell_update_content_visibility (_tmp4_);
#line 271 "../src/view.vala"
	sudoku_view_update_warnings (self);
#line 272 "../src/view.vala"
	sudoku_view_update_value_highlighter (self, row, col, old_val, new_val);
#line 1777 "view.c"
}

static void
sudoku_view_earmark_changed_cb (SudokuView* self,
                                gint row,
                                gint col,
                                gint num,
                                gboolean enabled)
{
	StackAction action = 0;
	SudokuGame* _tmp0_;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	SudokuCell* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 275 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 277 "../src/view.vala"
	_tmp0_ = self->priv->game;
#line 277 "../src/view.vala"
	action = sudoku_game_get_current_stack_action (_tmp0_);
#line 278 "../src/view.vala"
	if (stack_action_is_single_earmarks_change (action)) {
#line 1803 "view.c"
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
#line 279 "../src/view.vala"
		_tmp1_ = self->priv->cells;
#line 279 "../src/view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 279 "../src/view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 279 "../src/view.vala"
		_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
#line 279 "../src/view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
#line 1818 "view.c"
	}
#line 281 "../src/view.vala"
	_tmp3_ = self->priv->cells;
#line 281 "../src/view.vala"
	_tmp3__length1 = self->priv->cells_length1;
#line 281 "../src/view.vala"
	_tmp3__length2 = self->priv->cells_length2;
#line 281 "../src/view.vala"
	_tmp4_ = _tmp3_[(row * _tmp3__length2) + col];
#line 281 "../src/view.vala"
	sudoku_cell_update_earmark_visibility (_tmp4_, num);
#line 282 "../src/view.vala"
	_tmp5_ = sudoku_view_get_show_warnings (self);
#line 282 "../src/view.vala"
	_tmp6_ = _tmp5_;
#line 282 "../src/view.vala"
	if (_tmp6_) {
#line 1836 "view.c"
		SudokuCell** _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		SudokuCell* _tmp8_;
#line 283 "../src/view.vala"
		_tmp7_ = self->priv->cells;
#line 283 "../src/view.vala"
		_tmp7__length1 = self->priv->cells_length1;
#line 283 "../src/view.vala"
		_tmp7__length2 = self->priv->cells_length2;
#line 283 "../src/view.vala"
		_tmp8_ = _tmp7_[(row * _tmp7__length2) + col];
#line 283 "../src/view.vala"
		sudoku_cell_update_earmark_warnings (_tmp8_, num);
#line 1851 "view.c"
	}
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 289 "../src/view.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 1860 "view.c"
}

static void
sudoku_view_paused_cb (SudokuView* self)
{
	PangoAttrList* attr_list = NULL;
	GtkLabel* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp3_;
	PangoAttrList* _tmp5_;
	PangoAttribute* _tmp6_;
	GtkLabel* _tmp7_;
	PangoAttrList* _tmp8_;
	GtkLabel* _tmp9_;
	SudokuGame* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	SudokuGame* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	SudokuGame* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	SudokuGame* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
#line 286 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 289 "../src/view.vala"
	_tmp0_ = self->priv->paused_label;
#line 289 "../src/view.vala"
	_tmp1_ = gtk_label_get_attributes (_tmp0_);
#line 289 "../src/view.vala"
	_tmp2_ = _pango_attr_list_ref0 (_tmp1_);
#line 289 "../src/view.vala"
	attr_list = _tmp2_;
#line 290 "../src/view.vala"
	_tmp3_ = attr_list;
#line 290 "../src/view.vala"
	if (_tmp3_ == NULL) {
#line 1902 "view.c"
		PangoAttrList* _tmp4_;
#line 291 "../src/view.vala"
		_tmp4_ = pango_attr_list_new ();
#line 291 "../src/view.vala"
		_pango_attr_list_unref0 (attr_list);
#line 291 "../src/view.vala"
		attr_list = _tmp4_;
#line 1910 "view.c"
	}
#line 293 "../src/view.vala"
	_tmp5_ = attr_list;
#line 293 "../src/view.vala"
	_tmp6_ = pango_attr_size_new_absolute (((gint) (gtk_widget_get_width ((GtkWidget*) self) * 0.125)) * PANGO_SCALE);
#line 293 "../src/view.vala"
	pango_attr_list_change (_tmp5_, _tmp6_);
#line 297 "../src/view.vala"
	_tmp7_ = self->priv->paused_label;
#line 297 "../src/view.vala"
	_tmp8_ = attr_list;
#line 297 "../src/view.vala"
	gtk_label_set_attributes (_tmp7_, _tmp8_);
#line 298 "../src/view.vala"
	_tmp9_ = self->priv->paused_label;
#line 298 "../src/view.vala"
	_tmp10_ = self->priv->game;
#line 298 "../src/view.vala"
	_tmp11_ = sudoku_game_get_paused (_tmp10_);
#line 298 "../src/view.vala"
	_tmp12_ = _tmp11_;
#line 298 "../src/view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, _tmp12_);
#line 300 "../src/view.vala"
	_tmp13_ = self->priv->game;
#line 300 "../src/view.vala"
	_tmp14_ = sudoku_game_get_paused (_tmp13_);
#line 300 "../src/view.vala"
	_tmp15_ = _tmp14_;
#line 300 "../src/view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, !_tmp15_);
#line 301 "../src/view.vala"
	_tmp16_ = self->priv->game;
#line 301 "../src/view.vala"
	_tmp17_ = sudoku_game_get_paused (_tmp16_);
#line 301 "../src/view.vala"
	_tmp18_ = _tmp17_;
#line 301 "../src/view.vala"
	sudoku_view_set_has_selection (self, !_tmp18_);
#line 303 "../src/view.vala"
	_tmp19_ = self->priv->game;
#line 303 "../src/view.vala"
	_tmp20_ = sudoku_game_get_paused (_tmp19_);
#line 303 "../src/view.vala"
	_tmp21_ = _tmp20_;
#line 303 "../src/view.vala"
	if (_tmp21_) {
#line 304 "../src/view.vala"
		sudoku_view_clear_all_warnings (self);
#line 1960 "view.c"
	} else {
#line 306 "../src/view.vala"
		sudoku_view_update_warnings (self);
#line 1964 "view.c"
	}
#line 286 "../src/view.vala"
	_pango_attr_list_unref0 (attr_list);
#line 1968 "view.c"
}

void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuCell* _tmp4_;
	SudokuCell* _tmp5_;
	gint old_row = 0;
	gint _tmp6_;
	gint old_col = 0;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	SudokuCell* _tmp10_;
	SudokuCell* _tmp11_;
#line 309 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/view.vala"
	_tmp0_ = self->priv->cells;
#line 311 "../src/view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 311 "../src/view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 311 "../src/view.vala"
	_tmp1_ = _tmp0_[(cell_row * _tmp0__length2) + cell_col];
#line 311 "../src/view.vala"
	_tmp2_ = sudoku_cell_get_selected (_tmp1_);
#line 311 "../src/view.vala"
	_tmp3_ = _tmp2_;
#line 311 "../src/view.vala"
	if (_tmp3_ == TRUE) {
#line 312 "../src/view.vala"
		return;
#line 2010 "view.c"
	}
#line 314 "../src/view.vala"
	_tmp4_ = sudoku_view_get_selected_cell (self);
#line 314 "../src/view.vala"
	_tmp5_ = _tmp4_;
#line 314 "../src/view.vala"
	sudoku_cell_set_selected (_tmp5_, FALSE);
#line 316 "../src/view.vala"
	_tmp6_ = self->priv->_selected_row;
#line 316 "../src/view.vala"
	old_row = _tmp6_;
#line 317 "../src/view.vala"
	_tmp7_ = self->priv->_selected_col;
#line 317 "../src/view.vala"
	old_col = _tmp7_;
#line 319 "../src/view.vala"
	sudoku_view_set_selected_row (self, cell_row);
#line 320 "../src/view.vala"
	sudoku_view_set_selected_col (self, cell_col);
#line 322 "../src/view.vala"
	_tmp8_ = self->priv->_selected_row;
#line 322 "../src/view.vala"
	_tmp9_ = self->priv->_selected_col;
#line 322 "../src/view.vala"
	g_signal_emit (self, sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL], 0, old_row, old_col, _tmp8_, _tmp9_);
#line 324 "../src/view.vala"
	_tmp10_ = sudoku_view_get_selected_cell (self);
#line 324 "../src/view.vala"
	_tmp11_ = _tmp10_;
#line 324 "../src/view.vala"
	sudoku_cell_set_selected (_tmp11_, TRUE);
#line 2042 "view.c"
}

static void
sudoku_view_set_cell_highlighter (SudokuView* self,
                                  gint row,
                                  gint col,
                                  gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCell** _tmp2_ = NULL;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gint _tmp2__length1;
	gint _tmp2__length2;
	SudokuCell* _tmp4_ = NULL;
	SudokuCell* target_cell = NULL;
	SudokuCell* _tmp6_;
	SudokuCell** _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
#line 327 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 329 "../src/view.vala"
	_tmp0_ = sudoku_view_get_highlighter (self);
#line 329 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 329 "../src/view.vala"
	if (!_tmp1_) {
#line 330 "../src/view.vala"
		return;
#line 2075 "view.c"
	}
#line 332 "../src/view.vala"
	_tmp3_ = self->priv->cells;
#line 332 "../src/view.vala"
	_tmp3__length1 = self->priv->cells_length1;
#line 332 "../src/view.vala"
	_tmp3__length2 = self->priv->cells_length2;
#line 332 "../src/view.vala"
	_tmp2_ = _tmp3_;
#line 332 "../src/view.vala"
	_tmp2__length1 = _tmp3__length1;
#line 332 "../src/view.vala"
	_tmp2__length2 = _tmp3__length2;
#line 332 "../src/view.vala"
	_tmp4_ = NULL;
#line 332 "../src/view.vala"
	if (_tmp2_ != NULL) {
#line 2093 "view.c"
		SudokuCell* _tmp5_;
#line 332 "../src/view.vala"
		_tmp5_ = _tmp2_[(row * _tmp2__length2) + col];
#line 332 "../src/view.vala"
		_tmp4_ = _tmp5_;
#line 2099 "view.c"
	}
#line 332 "../src/view.vala"
	_tmp6_ = _g_object_ref0 (_tmp4_);
#line 332 "../src/view.vala"
	target_cell = _tmp6_;
#line 334 "../src/view.vala"
	_tmp7_ = self->priv->cells;
#line 334 "../src/view.vala"
	_tmp7__length1 = self->priv->cells_length1;
#line 334 "../src/view.vala"
	_tmp7__length2 = self->priv->cells_length2;
#line 2111 "view.c"
	{
		SudokuCell** cell_collection = NULL;
		gint cell_collection_length1 = 0;
		gint cell_collection_length2 = 0;
		gint cell_it = 0;
#line 334 "../src/view.vala"
		cell_collection = _tmp7_;
#line 334 "../src/view.vala"
		cell_collection_length1 = _tmp7__length1 * _tmp7__length2;
#line 334 "../src/view.vala"
		for (cell_it = 0; cell_it < cell_collection_length1; cell_it = cell_it + 1) {
#line 2123 "view.c"
			SudokuCell* _tmp8_;
			SudokuCell* cell = NULL;
#line 334 "../src/view.vala"
			_tmp8_ = _g_object_ref0 (cell_collection[cell_it]);
#line 334 "../src/view.vala"
			cell = _tmp8_;
#line 2130 "view.c"
			{
				SudokuCell* _tmp9_;
				SudokuCell* _tmp10_;
				gboolean _tmp11_ = FALSE;
				SudokuCell* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gboolean _tmp30_ = FALSE;
				SudokuCell* _tmp31_;
				gboolean _tmp32_;
				gboolean _tmp33_;
#line 336 "../src/view.vala"
				_tmp9_ = cell;
#line 336 "../src/view.vala"
				_tmp10_ = target_cell;
#line 336 "../src/view.vala"
				if (_tmp9_ == _tmp10_) {
#line 337 "../src/view.vala"
					_g_object_unref0 (cell);
#line 337 "../src/view.vala"
					continue;
#line 2152 "view.c"
				}
#line 339 "../src/view.vala"
				_tmp12_ = target_cell;
#line 339 "../src/view.vala"
				_tmp13_ = sudoku_cell_get_value (_tmp12_);
#line 339 "../src/view.vala"
				_tmp14_ = _tmp13_;
#line 339 "../src/view.vala"
				if (_tmp14_ > 0) {
#line 2162 "view.c"
					gboolean _tmp15_;
#line 339 "../src/view.vala"
					_tmp15_ = self->priv->_highlight_numbers;
#line 339 "../src/view.vala"
					_tmp11_ = _tmp15_;
#line 2168 "view.c"
				} else {
#line 339 "../src/view.vala"
					_tmp11_ = FALSE;
#line 2172 "view.c"
				}
#line 339 "../src/view.vala"
				if (_tmp11_) {
#line 2176 "view.c"
					SudokuCell* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					SudokuCell* _tmp19_;
					gint _tmp20_;
					gint _tmp21_;
#line 341 "../src/view.vala"
					_tmp16_ = target_cell;
#line 341 "../src/view.vala"
					_tmp17_ = sudoku_cell_get_value (_tmp16_);
#line 341 "../src/view.vala"
					_tmp18_ = _tmp17_;
#line 341 "../src/view.vala"
					_tmp19_ = cell;
#line 341 "../src/view.vala"
					_tmp20_ = sudoku_cell_get_value (_tmp19_);
#line 341 "../src/view.vala"
					_tmp21_ = _tmp20_;
#line 341 "../src/view.vala"
					if (_tmp18_ == _tmp21_) {
#line 2197 "view.c"
						SudokuCell* _tmp22_;
#line 342 "../src/view.vala"
						_tmp22_ = cell;
#line 342 "../src/view.vala"
						sudoku_cell_set_highlight_number (_tmp22_, enabled);
#line 2203 "view.c"
					} else {
						SudokuCell* _tmp23_;
						gint _tmp24_;
						gint _tmp25_;
#line 343 "../src/view.vala"
						_tmp23_ = cell;
#line 343 "../src/view.vala"
						_tmp24_ = sudoku_cell_get_value (_tmp23_);
#line 343 "../src/view.vala"
						_tmp25_ = _tmp24_;
#line 343 "../src/view.vala"
						if (_tmp25_ == 0) {
#line 2216 "view.c"
							SudokuCell* _tmp26_;
							SudokuCell* _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
#line 344 "../src/view.vala"
							_tmp26_ = cell;
#line 344 "../src/view.vala"
							_tmp27_ = target_cell;
#line 344 "../src/view.vala"
							_tmp28_ = sudoku_cell_get_value (_tmp27_);
#line 344 "../src/view.vala"
							_tmp29_ = _tmp28_;
#line 344 "../src/view.vala"
							sudoku_cell_set_earmark_highlight (_tmp26_, _tmp29_, enabled);
#line 2231 "view.c"
						}
					}
				}
#line 347 "../src/view.vala"
				_tmp31_ = cell;
#line 347 "../src/view.vala"
				_tmp32_ = sudoku_cell_get_is_fixed (_tmp31_);
#line 347 "../src/view.vala"
				_tmp33_ = _tmp32_;
#line 347 "../src/view.vala"
				if (!_tmp33_) {
#line 2243 "view.c"
					gboolean _tmp34_ = FALSE;
					gboolean _tmp35_ = FALSE;
					gboolean _tmp36_;
#line 348 "../src/view.vala"
					_tmp36_ = self->priv->_highlight_row_column;
#line 348 "../src/view.vala"
					if (_tmp36_) {
#line 2251 "view.c"
						gboolean _tmp37_ = FALSE;
						SudokuCell* _tmp38_;
						gint _tmp39_;
						gint _tmp40_;
#line 348 "../src/view.vala"
						_tmp38_ = cell;
#line 348 "../src/view.vala"
						_tmp39_ = sudoku_cell_get_row (_tmp38_);
#line 348 "../src/view.vala"
						_tmp40_ = _tmp39_;
#line 348 "../src/view.vala"
						if (_tmp40_ == row) {
#line 348 "../src/view.vala"
							_tmp37_ = TRUE;
#line 2266 "view.c"
						} else {
							SudokuCell* _tmp41_;
							gint _tmp42_;
							gint _tmp43_;
#line 348 "../src/view.vala"
							_tmp41_ = cell;
#line 348 "../src/view.vala"
							_tmp42_ = sudoku_cell_get_col (_tmp41_);
#line 348 "../src/view.vala"
							_tmp43_ = _tmp42_;
#line 348 "../src/view.vala"
							_tmp37_ = _tmp43_ == col;
#line 2279 "view.c"
						}
#line 348 "../src/view.vala"
						_tmp35_ = _tmp37_;
#line 2283 "view.c"
					} else {
#line 348 "../src/view.vala"
						_tmp35_ = FALSE;
#line 2287 "view.c"
					}
#line 348 "../src/view.vala"
					if (_tmp35_) {
#line 348 "../src/view.vala"
						_tmp34_ = TRUE;
#line 2293 "view.c"
					} else {
						gboolean _tmp44_ = FALSE;
						gboolean _tmp45_ = FALSE;
						gboolean _tmp46_;
#line 349 "../src/view.vala"
						_tmp46_ = self->priv->_highlight_block;
#line 349 "../src/view.vala"
						if (_tmp46_) {
#line 2302 "view.c"
							SudokuCell* _tmp47_;
							gint _tmp48_;
							gint _tmp49_;
							SudokuGame* _tmp50_;
							SudokuBoard* _tmp51_;
							SudokuBoard* _tmp52_;
							gint _tmp53_;
							gint _tmp54_;
							SudokuGame* _tmp55_;
							SudokuBoard* _tmp56_;
							SudokuBoard* _tmp57_;
							gint _tmp58_;
							gint _tmp59_;
#line 350 "../src/view.vala"
							_tmp47_ = cell;
#line 350 "../src/view.vala"
							_tmp48_ = sudoku_cell_get_row (_tmp47_);
#line 350 "../src/view.vala"
							_tmp49_ = _tmp48_;
#line 350 "../src/view.vala"
							_tmp50_ = self->priv->game;
#line 350 "../src/view.vala"
							_tmp51_ = sudoku_game_get_board (_tmp50_);
#line 350 "../src/view.vala"
							_tmp52_ = _tmp51_;
#line 350 "../src/view.vala"
							_tmp53_ = sudoku_board_get_block_cols (_tmp52_);
#line 350 "../src/view.vala"
							_tmp54_ = _tmp53_;
#line 350 "../src/view.vala"
							_tmp55_ = self->priv->game;
#line 350 "../src/view.vala"
							_tmp56_ = sudoku_game_get_board (_tmp55_);
#line 350 "../src/view.vala"
							_tmp57_ = _tmp56_;
#line 350 "../src/view.vala"
							_tmp58_ = sudoku_board_get_block_cols (_tmp57_);
#line 350 "../src/view.vala"
							_tmp59_ = _tmp58_;
#line 350 "../src/view.vala"
							_tmp45_ = (_tmp49_ / _tmp54_) == (row / _tmp59_);
#line 2344 "view.c"
						} else {
#line 349 "../src/view.vala"
							_tmp45_ = FALSE;
#line 2348 "view.c"
						}
#line 349 "../src/view.vala"
						if (_tmp45_) {
#line 2352 "view.c"
							SudokuCell* _tmp60_;
							gint _tmp61_;
							gint _tmp62_;
							SudokuGame* _tmp63_;
							SudokuBoard* _tmp64_;
							SudokuBoard* _tmp65_;
							gint _tmp66_;
							gint _tmp67_;
							SudokuGame* _tmp68_;
							SudokuBoard* _tmp69_;
							SudokuBoard* _tmp70_;
							gint _tmp71_;
							gint _tmp72_;
#line 351 "../src/view.vala"
							_tmp60_ = cell;
#line 351 "../src/view.vala"
							_tmp61_ = sudoku_cell_get_col (_tmp60_);
#line 351 "../src/view.vala"
							_tmp62_ = _tmp61_;
#line 351 "../src/view.vala"
							_tmp63_ = self->priv->game;
#line 351 "../src/view.vala"
							_tmp64_ = sudoku_game_get_board (_tmp63_);
#line 351 "../src/view.vala"
							_tmp65_ = _tmp64_;
#line 351 "../src/view.vala"
							_tmp66_ = sudoku_board_get_block_rows (_tmp65_);
#line 351 "../src/view.vala"
							_tmp67_ = _tmp66_;
#line 351 "../src/view.vala"
							_tmp68_ = self->priv->game;
#line 351 "../src/view.vala"
							_tmp69_ = sudoku_game_get_board (_tmp68_);
#line 351 "../src/view.vala"
							_tmp70_ = _tmp69_;
#line 351 "../src/view.vala"
							_tmp71_ = sudoku_board_get_block_rows (_tmp70_);
#line 351 "../src/view.vala"
							_tmp72_ = _tmp71_;
#line 351 "../src/view.vala"
							_tmp44_ = (_tmp62_ / _tmp67_) == (col / _tmp72_);
#line 2394 "view.c"
						} else {
#line 349 "../src/view.vala"
							_tmp44_ = FALSE;
#line 2398 "view.c"
						}
#line 349 "../src/view.vala"
						_tmp34_ = _tmp44_;
#line 2402 "view.c"
					}
#line 348 "../src/view.vala"
					_tmp30_ = _tmp34_;
#line 2406 "view.c"
				} else {
#line 347 "../src/view.vala"
					_tmp30_ = FALSE;
#line 2410 "view.c"
				}
#line 347 "../src/view.vala"
				if (_tmp30_) {
#line 2414 "view.c"
					SudokuCell* _tmp73_;
#line 353 "../src/view.vala"
					_tmp73_ = cell;
#line 353 "../src/view.vala"
					sudoku_cell_set_highlight_coord (_tmp73_, enabled);
#line 2420 "view.c"
				}
#line 334 "../src/view.vala"
				_g_object_unref0 (cell);
#line 2424 "view.c"
			}
		}
	}
#line 327 "../src/view.vala"
	_g_object_unref0 (target_cell);
#line 2430 "view.c"
}

static void
sudoku_view_update_value_highlighter (SudokuView* self,
                                      gint row,
                                      gint col,
                                      gint old_val,
                                      gint new_val)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_;
#line 358 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/view.vala"
	_tmp1_ = sudoku_view_get_highlighter (self);
#line 360 "../src/view.vala"
	_tmp2_ = _tmp1_;
#line 360 "../src/view.vala"
	if (!_tmp2_) {
#line 360 "../src/view.vala"
		_tmp0_ = TRUE;
#line 2455 "view.c"
	} else {
		gboolean _tmp3_;
#line 360 "../src/view.vala"
		_tmp3_ = self->priv->_highlight_numbers;
#line 360 "../src/view.vala"
		_tmp0_ = !_tmp3_;
#line 2462 "view.c"
	}
#line 360 "../src/view.vala"
	if (_tmp0_) {
#line 361 "../src/view.vala"
		return;
#line 2468 "view.c"
	}
#line 363 "../src/view.vala"
	_tmp5_ = self->priv->_selected_row;
#line 363 "../src/view.vala"
	if (row != _tmp5_) {
#line 363 "../src/view.vala"
		_tmp4_ = TRUE;
#line 2476 "view.c"
	} else {
		gint _tmp6_;
#line 363 "../src/view.vala"
		_tmp6_ = self->priv->_selected_col;
#line 363 "../src/view.vala"
		_tmp4_ = col != _tmp6_;
#line 2483 "view.c"
	}
#line 363 "../src/view.vala"
	if (_tmp4_) {
#line 2487 "view.c"
		SudokuCell* _tmp7_;
		SudokuCell* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 365 "../src/view.vala"
		_tmp7_ = sudoku_view_get_selected_cell (self);
#line 365 "../src/view.vala"
		_tmp8_ = _tmp7_;
#line 365 "../src/view.vala"
		_tmp9_ = sudoku_cell_get_value (_tmp8_);
#line 365 "../src/view.vala"
		_tmp10_ = _tmp9_;
#line 365 "../src/view.vala"
		if (old_val == _tmp10_) {
#line 2502 "view.c"
			SudokuCell** _tmp11_;
			gint _tmp11__length1;
			gint _tmp11__length2;
			SudokuCell* _tmp12_;
#line 366 "../src/view.vala"
			_tmp11_ = self->priv->cells;
#line 366 "../src/view.vala"
			_tmp11__length1 = self->priv->cells_length1;
#line 366 "../src/view.vala"
			_tmp11__length2 = self->priv->cells_length2;
#line 366 "../src/view.vala"
			_tmp12_ = _tmp11_[(row * _tmp11__length2) + col];
#line 366 "../src/view.vala"
			sudoku_cell_set_highlight_number (_tmp12_, FALSE);
#line 2517 "view.c"
		} else {
			gboolean _tmp13_ = FALSE;
			SudokuCell* _tmp14_;
			SudokuCell* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
#line 367 "../src/view.vala"
			_tmp14_ = sudoku_view_get_selected_cell (self);
#line 367 "../src/view.vala"
			_tmp15_ = _tmp14_;
#line 367 "../src/view.vala"
			_tmp16_ = sudoku_cell_get_value (_tmp15_);
#line 367 "../src/view.vala"
			_tmp17_ = _tmp16_;
#line 367 "../src/view.vala"
			if (new_val == _tmp17_) {
#line 367 "../src/view.vala"
				_tmp13_ = new_val != 0;
#line 2536 "view.c"
			} else {
#line 367 "../src/view.vala"
				_tmp13_ = FALSE;
#line 2540 "view.c"
			}
#line 367 "../src/view.vala"
			if (_tmp13_) {
#line 2544 "view.c"
				SudokuCell** _tmp18_;
				gint _tmp18__length1;
				gint _tmp18__length2;
				SudokuCell* _tmp19_;
#line 368 "../src/view.vala"
				_tmp18_ = self->priv->cells;
#line 368 "../src/view.vala"
				_tmp18__length1 = self->priv->cells_length1;
#line 368 "../src/view.vala"
				_tmp18__length2 = self->priv->cells_length2;
#line 368 "../src/view.vala"
				_tmp19_ = _tmp18_[(row * _tmp18__length2) + col];
#line 368 "../src/view.vala"
				sudoku_cell_set_highlight_number (_tmp19_, TRUE);
#line 2559 "view.c"
			}
		}
#line 369 "../src/view.vala"
		return;
#line 2564 "view.c"
	}
	{
		gint col_tmp = 0;
#line 372 "../src/view.vala"
		col_tmp = 0;
#line 2570 "view.c"
		{
			gboolean _tmp20_ = FALSE;
#line 372 "../src/view.vala"
			_tmp20_ = TRUE;
#line 372 "../src/view.vala"
			while (TRUE) {
#line 2577 "view.c"
				SudokuGame* _tmp22_;
				SudokuBoard* _tmp23_;
				SudokuBoard* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
#line 372 "../src/view.vala"
				if (!_tmp20_) {
#line 2585 "view.c"
					gint _tmp21_;
#line 372 "../src/view.vala"
					_tmp21_ = col_tmp;
#line 372 "../src/view.vala"
					col_tmp = _tmp21_ + 1;
#line 2591 "view.c"
				}
#line 372 "../src/view.vala"
				_tmp20_ = FALSE;
#line 372 "../src/view.vala"
				_tmp22_ = self->priv->game;
#line 372 "../src/view.vala"
				_tmp23_ = sudoku_game_get_board (_tmp22_);
#line 372 "../src/view.vala"
				_tmp24_ = _tmp23_;
#line 372 "../src/view.vala"
				_tmp25_ = sudoku_board_get_cols (_tmp24_);
#line 372 "../src/view.vala"
				_tmp26_ = _tmp25_;
#line 372 "../src/view.vala"
				if (!(col_tmp < _tmp26_)) {
#line 372 "../src/view.vala"
					break;
#line 2609 "view.c"
				}
				{
					gint row_tmp = 0;
#line 374 "../src/view.vala"
					row_tmp = 0;
#line 2615 "view.c"
					{
						gboolean _tmp27_ = FALSE;
#line 374 "../src/view.vala"
						_tmp27_ = TRUE;
#line 374 "../src/view.vala"
						while (TRUE) {
#line 2622 "view.c"
							SudokuGame* _tmp29_;
							SudokuBoard* _tmp30_;
							SudokuBoard* _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp34_;
							gint _tmp34__length1;
							gint _tmp34__length2;
							SudokuCell* _tmp35_;
							SudokuCell* _tmp36_;
							SudokuCell* _tmp37_;
							SudokuCell* _tmp38_;
							SudokuCell* _tmp39_;
							SudokuCell* _tmp40_;
							gint _tmp41_;
							gint _tmp42_;
#line 374 "../src/view.vala"
							if (!_tmp27_) {
#line 2642 "view.c"
								gint _tmp28_;
#line 374 "../src/view.vala"
								_tmp28_ = row_tmp;
#line 374 "../src/view.vala"
								row_tmp = _tmp28_ + 1;
#line 2648 "view.c"
							}
#line 374 "../src/view.vala"
							_tmp27_ = FALSE;
#line 374 "../src/view.vala"
							_tmp29_ = self->priv->game;
#line 374 "../src/view.vala"
							_tmp30_ = sudoku_game_get_board (_tmp29_);
#line 374 "../src/view.vala"
							_tmp31_ = _tmp30_;
#line 374 "../src/view.vala"
							_tmp32_ = sudoku_board_get_rows (_tmp31_);
#line 374 "../src/view.vala"
							_tmp33_ = _tmp32_;
#line 374 "../src/view.vala"
							if (!(row_tmp < _tmp33_)) {
#line 374 "../src/view.vala"
								break;
#line 2666 "view.c"
							}
#line 376 "../src/view.vala"
							_tmp34_ = self->priv->cells;
#line 376 "../src/view.vala"
							_tmp34__length1 = self->priv->cells_length1;
#line 376 "../src/view.vala"
							_tmp34__length2 = self->priv->cells_length2;
#line 376 "../src/view.vala"
							_tmp35_ = _tmp34_[(row_tmp * _tmp34__length2) + col_tmp];
#line 376 "../src/view.vala"
							_tmp36_ = _g_object_ref0 (_tmp35_);
#line 376 "../src/view.vala"
							cell_tmp = _tmp36_;
#line 378 "../src/view.vala"
							_tmp37_ = sudoku_view_get_selected_cell (self);
#line 378 "../src/view.vala"
							_tmp38_ = _tmp37_;
#line 378 "../src/view.vala"
							_tmp39_ = cell_tmp;
#line 378 "../src/view.vala"
							if (_tmp38_ == _tmp39_) {
#line 379 "../src/view.vala"
								_g_object_unref0 (cell_tmp);
#line 379 "../src/view.vala"
								continue;
#line 2692 "view.c"
							}
#line 381 "../src/view.vala"
							_tmp40_ = cell_tmp;
#line 381 "../src/view.vala"
							_tmp41_ = sudoku_cell_get_value (_tmp40_);
#line 381 "../src/view.vala"
							_tmp42_ = _tmp41_;
#line 381 "../src/view.vala"
							if (_tmp42_ == 0) {
#line 383 "../src/view.vala"
								if (old_val > 0) {
#line 2704 "view.c"
									SudokuCell* _tmp43_;
#line 384 "../src/view.vala"
									_tmp43_ = cell_tmp;
#line 384 "../src/view.vala"
									sudoku_cell_set_earmark_highlight (_tmp43_, old_val, FALSE);
#line 2710 "view.c"
								}
#line 385 "../src/view.vala"
								if (new_val > 0) {
#line 2714 "view.c"
									SudokuCell* _tmp44_;
#line 386 "../src/view.vala"
									_tmp44_ = cell_tmp;
#line 386 "../src/view.vala"
									sudoku_cell_set_earmark_highlight (_tmp44_, new_val, TRUE);
#line 2720 "view.c"
								}
							} else {
								SudokuCell* _tmp45_;
								gint _tmp46_;
								gint _tmp47_;
#line 388 "../src/view.vala"
								_tmp45_ = cell_tmp;
#line 388 "../src/view.vala"
								_tmp46_ = sudoku_cell_get_value (_tmp45_);
#line 388 "../src/view.vala"
								_tmp47_ = _tmp46_;
#line 388 "../src/view.vala"
								if (new_val == _tmp47_) {
#line 2734 "view.c"
									SudokuCell* _tmp48_;
#line 389 "../src/view.vala"
									_tmp48_ = cell_tmp;
#line 389 "../src/view.vala"
									sudoku_cell_set_highlight_number (_tmp48_, TRUE);
#line 2740 "view.c"
								} else {
									SudokuCell* _tmp49_;
									gint _tmp50_;
									gint _tmp51_;
#line 390 "../src/view.vala"
									_tmp49_ = cell_tmp;
#line 390 "../src/view.vala"
									_tmp50_ = sudoku_cell_get_value (_tmp49_);
#line 390 "../src/view.vala"
									_tmp51_ = _tmp50_;
#line 390 "../src/view.vala"
									if (old_val == _tmp51_) {
#line 2753 "view.c"
										SudokuCell* _tmp52_;
#line 391 "../src/view.vala"
										_tmp52_ = cell_tmp;
#line 391 "../src/view.vala"
										sudoku_cell_set_highlight_number (_tmp52_, FALSE);
#line 2759 "view.c"
									}
								}
							}
#line 374 "../src/view.vala"
							_g_object_unref0 (cell_tmp);
#line 2765 "view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_update_warnings (SudokuView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCell** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
#line 396 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 398 "../src/view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 398 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 398 "../src/view.vala"
	if (!_tmp1_) {
#line 399 "../src/view.vala"
		return;
#line 2792 "view.c"
	}
#line 401 "../src/view.vala"
	_tmp2_ = self->priv->cells;
#line 401 "../src/view.vala"
	_tmp2__length1 = self->priv->cells_length1;
#line 401 "../src/view.vala"
	_tmp2__length2 = self->priv->cells_length2;
#line 2800 "view.c"
	{
		SudokuCell** cell_collection = NULL;
		gint cell_collection_length1 = 0;
		gint cell_collection_length2 = 0;
		gint cell_it = 0;
#line 401 "../src/view.vala"
		cell_collection = _tmp2_;
#line 401 "../src/view.vala"
		cell_collection_length1 = _tmp2__length1 * _tmp2__length2;
#line 401 "../src/view.vala"
		for (cell_it = 0; cell_it < cell_collection_length1; cell_it = cell_it + 1) {
#line 2812 "view.c"
			SudokuCell* _tmp3_;
			SudokuCell* cell = NULL;
#line 401 "../src/view.vala"
			_tmp3_ = _g_object_ref0 (cell_collection[cell_it]);
#line 401 "../src/view.vala"
			cell = _tmp3_;
#line 2819 "view.c"
			{
				SudokuCell* _tmp4_;
				SudokuCell* _tmp5_;
#line 403 "../src/view.vala"
				_tmp4_ = cell;
#line 403 "../src/view.vala"
				sudoku_cell_update_value_warnings (_tmp4_);
#line 404 "../src/view.vala"
				_tmp5_ = cell;
#line 404 "../src/view.vala"
				sudoku_cell_update_all_earmark_warnings (_tmp5_);
#line 401 "../src/view.vala"
				_g_object_unref0 (cell);
#line 2833 "view.c"
			}
		}
	}
}

static void
sudoku_view_clear_all_warnings (SudokuView* self)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 408 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 410 "../src/view.vala"
	_tmp0_ = self->priv->cells;
#line 410 "../src/view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 410 "../src/view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 2853 "view.c"
	{
		SudokuCell** cell_collection = NULL;
		gint cell_collection_length1 = 0;
		gint cell_collection_length2 = 0;
		gint cell_it = 0;
#line 410 "../src/view.vala"
		cell_collection = _tmp0_;
#line 410 "../src/view.vala"
		cell_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 410 "../src/view.vala"
		for (cell_it = 0; cell_it < cell_collection_length1; cell_it = cell_it + 1) {
#line 2865 "view.c"
			SudokuCell* _tmp1_;
			SudokuCell* cell = NULL;
#line 410 "../src/view.vala"
			_tmp1_ = _g_object_ref0 (cell_collection[cell_it]);
#line 410 "../src/view.vala"
			cell = _tmp1_;
#line 2872 "view.c"
			{
				SudokuCell* _tmp2_;
#line 411 "../src/view.vala"
				_tmp2_ = cell;
#line 411 "../src/view.vala"
				sudoku_cell_clear_warnings (_tmp2_);
#line 410 "../src/view.vala"
				_g_object_unref0 (cell);
#line 2881 "view.c"
			}
		}
	}
}

static void
sudoku_view_insert_key (SudokuView* self,
                        gint key,
                        gboolean control_pressed)
{
	SudokuNumberPicker* _tmp0_;
	gboolean wants_value = FALSE;
	gboolean _tmp1_;
#line 520 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 522 "../src/view.vala"
	_tmp0_ = self->number_picker;
#line 522 "../src/view.vala"
	gtk_popover_popdown ((GtkPopover*) _tmp0_);
#line 523 "../src/view.vala"
	wants_value = !control_pressed;
#line 524 "../src/view.vala"
	_tmp1_ = self->priv->_earmark_mode;
#line 524 "../src/view.vala"
	wants_value = wants_value ^ _tmp1_;
#line 526 "../src/view.vala"
	if (wants_value) {
#line 2909 "view.c"
		SudokuCell* _tmp2_;
		SudokuCell* _tmp3_;
#line 528 "../src/view.vala"
		_tmp2_ = sudoku_view_get_selected_cell (self);
#line 528 "../src/view.vala"
		_tmp3_ = _tmp2_;
#line 528 "../src/view.vala"
		sudoku_cell_set_value (_tmp3_, key);
#line 2918 "view.c"
	} else {
		gboolean _tmp4_ = FALSE;
		SudokuGame* _tmp5_;
		GameMode _tmp6_;
		GameMode _tmp7_;
#line 530 "../src/view.vala"
		_tmp5_ = self->priv->game;
#line 530 "../src/view.vala"
		_tmp6_ = sudoku_game_get_mode (_tmp5_);
#line 530 "../src/view.vala"
		_tmp7_ = _tmp6_;
#line 530 "../src/view.vala"
		if (_tmp7_ == GAME_MODE_PLAY) {
#line 2932 "view.c"
			SudokuCell* _tmp8_;
			SudokuCell* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 530 "../src/view.vala"
			_tmp8_ = sudoku_view_get_selected_cell (self);
#line 530 "../src/view.vala"
			_tmp9_ = _tmp8_;
#line 530 "../src/view.vala"
			_tmp10_ = sudoku_cell_get_value (_tmp9_);
#line 530 "../src/view.vala"
			_tmp11_ = _tmp10_;
#line 530 "../src/view.vala"
			_tmp4_ = _tmp11_ == 0;
#line 2947 "view.c"
		} else {
#line 530 "../src/view.vala"
			_tmp4_ = FALSE;
#line 2951 "view.c"
		}
#line 530 "../src/view.vala"
		if (_tmp4_) {
#line 2955 "view.c"
			gboolean enabled = FALSE;
			SudokuGame* _tmp12_;
			SudokuBoard* _tmp13_;
			SudokuBoard* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
#line 532 "../src/view.vala"
			_tmp12_ = self->priv->game;
#line 532 "../src/view.vala"
			_tmp13_ = sudoku_game_get_board (_tmp12_);
#line 532 "../src/view.vala"
			_tmp14_ = _tmp13_;
#line 532 "../src/view.vala"
			_tmp15_ = self->priv->_selected_row;
#line 532 "../src/view.vala"
			_tmp16_ = self->priv->_selected_col;
#line 532 "../src/view.vala"
			enabled = sudoku_board_is_earmark_enabled (_tmp14_, _tmp15_, _tmp16_, key);
#line 533 "../src/view.vala"
			if (!enabled) {
#line 2976 "view.c"
				SudokuGame* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 534 "../src/view.vala"
				_tmp17_ = self->priv->game;
#line 534 "../src/view.vala"
				_tmp18_ = self->priv->_selected_row;
#line 534 "../src/view.vala"
				_tmp19_ = self->priv->_selected_col;
#line 534 "../src/view.vala"
				sudoku_game_enable_earmark (_tmp17_, _tmp18_, _tmp19_, key);
#line 2988 "view.c"
			} else {
				SudokuGame* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
#line 536 "../src/view.vala"
				_tmp20_ = self->priv->game;
#line 536 "../src/view.vala"
				_tmp21_ = self->priv->_selected_row;
#line 536 "../src/view.vala"
				_tmp22_ = self->priv->_selected_col;
#line 536 "../src/view.vala"
				sudoku_game_disable_earmark (_tmp20_, _tmp21_, _tmp22_, key);
#line 3001 "view.c"
			}
		}
	}
}

void
sudoku_view_dismiss_picker (SudokuView* self)
{
	SudokuNumberPicker* _tmp0_;
#line 540 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 542 "../src/view.vala"
	_tmp0_ = self->number_picker;
#line 542 "../src/view.vala"
	gtk_popover_popdown ((GtkPopover*) _tmp0_);
#line 3017 "view.c"
}

static void
sudoku_view_real_dispose (GObject* base)
{
	SudokuView * self;
	SudokuFrame* _tmp0_;
	SudokuNumberPicker* _tmp1_;
#line 545 "../src/view.vala"
	self = (SudokuView*) base;
#line 547 "../src/view.vala"
	_tmp0_ = self->priv->frame;
#line 547 "../src/view.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 548 "../src/view.vala"
	_tmp1_ = self->number_picker;
#line 548 "../src/view.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp1_);
#line 549 "../src/view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_bin_get_type (), AdwBin));
#line 3038 "view.c"
}

gboolean
sudoku_view_get_earmark_mode (SudokuView* self)
{
	gboolean result;
#line 38 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../src/view.vala"
	result = self->priv->_earmark_mode;
#line 38 "../src/view.vala"
	return result;
#line 3051 "view.c"
}

void
sudoku_view_set_earmark_mode (SudokuView* self,
                              gboolean value)
{
	gboolean old_value;
#line 38 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/view.vala"
	old_value = sudoku_view_get_earmark_mode (self);
#line 38 "../src/view.vala"
	if (old_value != value) {
#line 38 "../src/view.vala"
		self->priv->_earmark_mode = value;
#line 38 "../src/view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_EARMARK_MODE_PROPERTY]);
#line 3069 "view.c"
	}
}

gboolean
sudoku_view_get_autoclean_earmarks (SudokuView* self)
{
	gboolean result;
#line 39 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 39 "../src/view.vala"
	result = self->priv->_autoclean_earmarks;
#line 39 "../src/view.vala"
	return result;
#line 3083 "view.c"
}

void
sudoku_view_set_autoclean_earmarks (SudokuView* self,
                                    gboolean value)
{
	gboolean old_value;
#line 39 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/view.vala"
	old_value = sudoku_view_get_autoclean_earmarks (self);
#line 39 "../src/view.vala"
	if (old_value != value) {
#line 39 "../src/view.vala"
		self->priv->_autoclean_earmarks = value;
#line 39 "../src/view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_AUTOCLEAN_EARMARKS_PROPERTY]);
#line 3101 "view.c"
	}
}

gboolean
sudoku_view_get_number_picker_second_click (SudokuView* self)
{
	gboolean result;
#line 40 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../src/view.vala"
	result = self->priv->_number_picker_second_click;
#line 40 "../src/view.vala"
	return result;
#line 3115 "view.c"
}

void
sudoku_view_set_number_picker_second_click (SudokuView* self,
                                            gboolean value)
{
	gboolean old_value;
#line 40 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/view.vala"
	old_value = sudoku_view_get_number_picker_second_click (self);
#line 40 "../src/view.vala"
	if (old_value != value) {
#line 40 "../src/view.vala"
		self->priv->_number_picker_second_click = value;
#line 40 "../src/view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_NUMBER_PICKER_SECOND_CLICK_PROPERTY]);
#line 3133 "view.c"
	}
}

gboolean
sudoku_view_get_highlight_row_column (SudokuView* self)
{
	gboolean result;
#line 41 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/view.vala"
	result = self->priv->_highlight_row_column;
#line 41 "../src/view.vala"
	return result;
#line 3147 "view.c"
}

void
sudoku_view_set_highlight_row_column (SudokuView* self,
                                      gboolean value)
{
	gboolean old_value;
#line 41 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/view.vala"
	old_value = sudoku_view_get_highlight_row_column (self);
#line 41 "../src/view.vala"
	if (old_value != value) {
#line 41 "../src/view.vala"
		self->priv->_highlight_row_column = value;
#line 41 "../src/view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHT_ROW_COLUMN_PROPERTY]);
#line 3165 "view.c"
	}
}

gboolean
sudoku_view_get_highlight_block (SudokuView* self)
{
	gboolean result;
#line 42 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../src/view.vala"
	result = self->priv->_highlight_block;
#line 42 "../src/view.vala"
	return result;
#line 3179 "view.c"
}

void
sudoku_view_set_highlight_block (SudokuView* self,
                                 gboolean value)
{
	gboolean old_value;
#line 42 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/view.vala"
	old_value = sudoku_view_get_highlight_block (self);
#line 42 "../src/view.vala"
	if (old_value != value) {
#line 42 "../src/view.vala"
		self->priv->_highlight_block = value;
#line 42 "../src/view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHT_BLOCK_PROPERTY]);
#line 3197 "view.c"
	}
}

gboolean
sudoku_view_get_highlight_numbers (SudokuView* self)
{
	gboolean result;
#line 43 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../src/view.vala"
	result = self->priv->_highlight_numbers;
#line 43 "../src/view.vala"
	return result;
#line 3211 "view.c"
}

void
sudoku_view_set_highlight_numbers (SudokuView* self,
                                   gboolean value)
{
	gboolean old_value;
#line 43 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/view.vala"
	old_value = sudoku_view_get_highlight_numbers (self);
#line 43 "../src/view.vala"
	if (old_value != value) {
#line 43 "../src/view.vala"
		self->priv->_highlight_numbers = value;
#line 43 "../src/view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHT_NUMBERS_PROPERTY]);
#line 3229 "view.c"
	}
}

gdouble
sudoku_view_get_value_zoom_multiplier (SudokuView* self)
{
	gdouble result;
#line 44 "../src/view.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 44 "../src/view.vala"
	result = self->priv->_value_zoom_multiplier;
#line 44 "../src/view.vala"
	return result;
#line 3243 "view.c"
}

static void
sudoku_view_set_value_zoom_multiplier (SudokuView* self,
                                       gdouble value)
{
	gdouble old_value;
#line 44 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/view.vala"
	old_value = sudoku_view_get_value_zoom_multiplier (self);
#line 44 "../src/view.vala"
	if (old_value != value) {
#line 44 "../src/view.vala"
		self->priv->_value_zoom_multiplier = value;
#line 44 "../src/view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_VALUE_ZOOM_MULTIPLIER_PROPERTY]);
#line 3261 "view.c"
	}
}

gint
sudoku_view_get_selected_row (SudokuView* self)
{
	gint result;
#line 46 "../src/view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "../src/view.vala"
	result = self->priv->_selected_row;
#line 46 "../src/view.vala"
	return result;
#line 3275 "view.c"
}

static void
sudoku_view_set_selected_row (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 46 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/view.vala"
	old_value = sudoku_view_get_selected_row (self);
#line 46 "../src/view.vala"
	if (old_value != value) {
#line 46 "../src/view.vala"
		self->priv->_selected_row = value;
#line 46 "../src/view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY]);
#line 3293 "view.c"
	}
}

gint
sudoku_view_get_selected_col (SudokuView* self)
{
	gint result;
#line 47 "../src/view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "../src/view.vala"
	result = self->priv->_selected_col;
#line 47 "../src/view.vala"
	return result;
#line 3307 "view.c"
}

static void
sudoku_view_set_selected_col (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 47 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/view.vala"
	old_value = sudoku_view_get_selected_col (self);
#line 47 "../src/view.vala"
	if (old_value != value) {
#line 47 "../src/view.vala"
		self->priv->_selected_col = value;
#line 47 "../src/view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY]);
#line 3325 "view.c"
	}
}

static SudokuCell*
sudoku_view_get_selected_cell (SudokuView* self)
{
	SudokuCell* result;
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint _tmp2_;
	SudokuCell* _tmp3_;
#line 51 "../src/view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/view.vala"
	_tmp0_ = self->priv->cells;
#line 51 "../src/view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 51 "../src/view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 51 "../src/view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 51 "../src/view.vala"
	_tmp2_ = self->priv->_selected_col;
#line 51 "../src/view.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 51 "../src/view.vala"
	result = _tmp3_;
#line 51 "../src/view.vala"
	return result;
#line 3357 "view.c"
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
#line 417 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 417 "../src/view.vala"
	result = self->priv->_show_warnings;
#line 417 "../src/view.vala"
	return result;
#line 3370 "view.c"
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 418 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 419 "../src/view.vala"
	self->priv->_show_warnings = value;
#line 421 "../src/view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 421 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 421 "../src/view.vala"
	if (_tmp1_) {
#line 422 "../src/view.vala"
		sudoku_view_update_warnings (self);
#line 3391 "view.c"
	} else {
#line 424 "../src/view.vala"
		sudoku_view_clear_all_warnings (self);
#line 3395 "view.c"
	}
#line 418 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 3399 "view.c"
}

gboolean
sudoku_view_get_show_earmark_warnings (SudokuView* self)
{
	gboolean result;
#line 431 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 431 "../src/view.vala"
	result = self->priv->_show_earmark_warnings;
#line 431 "../src/view.vala"
	return result;
#line 3412 "view.c"
}

void
sudoku_view_set_show_earmark_warnings (SudokuView* self,
                                       gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 432 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 433 "../src/view.vala"
	self->priv->_show_earmark_warnings = value;
#line 434 "../src/view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 434 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 434 "../src/view.vala"
	sudoku_view_set_show_warnings (self, _tmp1_);
#line 432 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY]);
#line 3433 "view.c"
}

gboolean
sudoku_view_get_solution_warnings (SudokuView* self)
{
	gboolean result;
#line 441 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 441 "../src/view.vala"
	result = self->priv->_solution_warnings;
#line 441 "../src/view.vala"
	return result;
#line 3446 "view.c"
}

void
sudoku_view_set_solution_warnings (SudokuView* self,
                                   gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 442 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 443 "../src/view.vala"
	self->priv->_solution_warnings = value;
#line 444 "../src/view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 444 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 444 "../src/view.vala"
	sudoku_view_set_show_warnings (self, _tmp1_);
#line 442 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY]);
#line 3467 "view.c"
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
#line 451 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 451 "../src/view.vala"
	result = self->priv->_show_possibilities;
#line 451 "../src/view.vala"
	return result;
#line 3480 "view.c"
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 452 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 453 "../src/view.vala"
	self->priv->_show_possibilities = value;
#line 454 "../src/view.vala"
	_tmp2_ = sudoku_view_get_show_possibilities (self);
#line 454 "../src/view.vala"
	_tmp3_ = _tmp2_;
#line 454 "../src/view.vala"
	if (_tmp3_) {
#line 3501 "view.c"
		SudokuGame* _tmp4_;
		GameMode _tmp5_;
		GameMode _tmp6_;
#line 454 "../src/view.vala"
		_tmp4_ = self->priv->game;
#line 454 "../src/view.vala"
		_tmp5_ = sudoku_game_get_mode (_tmp4_);
#line 454 "../src/view.vala"
		_tmp6_ = _tmp5_;
#line 454 "../src/view.vala"
		_tmp1_ = _tmp6_ != GAME_MODE_CREATE;
#line 3513 "view.c"
	} else {
#line 454 "../src/view.vala"
		_tmp1_ = FALSE;
#line 3517 "view.c"
	}
#line 454 "../src/view.vala"
	if (_tmp1_) {
#line 3521 "view.c"
		gboolean _tmp7_ = FALSE;
		SudokuGame* _tmp8_;
		SudokuBoard* _tmp9_;
		SudokuBoard* _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
#line 455 "../src/view.vala"
		_tmp8_ = self->priv->game;
#line 455 "../src/view.vala"
		_tmp9_ = sudoku_game_get_board (_tmp8_);
#line 455 "../src/view.vala"
		_tmp10_ = _tmp9_;
#line 455 "../src/view.vala"
		_tmp11_ = sudoku_board_get_previous_played_time (_tmp10_);
#line 455 "../src/view.vala"
		_tmp12_ = _tmp11_;
#line 455 "../src/view.vala"
		if (_tmp12_ == 0.0) {
#line 455 "../src/view.vala"
			_tmp7_ = TRUE;
#line 3542 "view.c"
		} else {
			SudokuGame* _tmp13_;
#line 455 "../src/view.vala"
			_tmp13_ = self->priv->game;
#line 455 "../src/view.vala"
			_tmp7_ = sudoku_game_get_elapsed_time (_tmp13_) > 3.0;
#line 3549 "view.c"
		}
#line 455 "../src/view.vala"
		_tmp0_ = _tmp7_;
#line 3553 "view.c"
	} else {
#line 454 "../src/view.vala"
		_tmp0_ = FALSE;
#line 3557 "view.c"
	}
#line 454 "../src/view.vala"
	if (_tmp0_) {
#line 3561 "view.c"
		SudokuGame* _tmp14_;
#line 457 "../src/view.vala"
		_tmp14_ = self->priv->game;
#line 457 "../src/view.vala"
		sudoku_game_enable_all_earmark_possibilities (_tmp14_);
#line 3567 "view.c"
	} else {
		SudokuGame* _tmp15_;
#line 459 "../src/view.vala"
		_tmp15_ = self->priv->game;
#line 459 "../src/view.vala"
		if (sudoku_game_get_current_stack_action (_tmp15_) == STACK_ACTION_ENABLE_ALL_EARMARK_POSSIBILITIES) {
#line 3574 "view.c"
			SudokuGame* _tmp16_;
#line 460 "../src/view.vala"
			_tmp16_ = self->priv->game;
#line 460 "../src/view.vala"
			sudoku_game_undo (_tmp16_);
#line 3580 "view.c"
		}
	}
#line 452 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 3585 "view.c"
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
#line 467 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 467 "../src/view.vala"
	result = self->priv->_highlighter;
#line 467 "../src/view.vala"
	return result;
#line 3598 "view.c"
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 468 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 469 "../src/view.vala"
	_tmp0_ = sudoku_view_get_has_selection (self);
#line 469 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 469 "../src/view.vala"
	if (_tmp1_) {
#line 3617 "view.c"
		gint _tmp2_;
		gint _tmp3_;
#line 470 "../src/view.vala"
		_tmp2_ = self->priv->_selected_row;
#line 470 "../src/view.vala"
		_tmp3_ = self->priv->_selected_col;
#line 470 "../src/view.vala"
		sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, FALSE);
#line 3626 "view.c"
	}
#line 471 "../src/view.vala"
	self->priv->_highlighter = value;
#line 472 "../src/view.vala"
	_tmp4_ = sudoku_view_get_has_selection (self);
#line 472 "../src/view.vala"
	_tmp5_ = _tmp4_;
#line 472 "../src/view.vala"
	if (_tmp5_) {
#line 3636 "view.c"
		gint _tmp6_;
		gint _tmp7_;
#line 473 "../src/view.vala"
		_tmp6_ = self->priv->_selected_row;
#line 473 "../src/view.vala"
		_tmp7_ = self->priv->_selected_col;
#line 473 "../src/view.vala"
		sudoku_view_set_cell_highlighter (self, _tmp6_, _tmp7_, TRUE);
#line 3645 "view.c"
	}
#line 468 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 3649 "view.c"
}

gboolean
sudoku_view_get_has_selection (SudokuView* self)
{
	gboolean result;
#line 480 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 480 "../src/view.vala"
	result = self->priv->_has_selection;
#line 480 "../src/view.vala"
	return result;
#line 3662 "view.c"
}

void
sudoku_view_set_has_selection (SudokuView* self,
                               gboolean value)
{
	SudokuCell* _tmp0_;
	SudokuCell* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gint _tmp9_;
	gint _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
#line 481 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 482 "../src/view.vala"
	self->priv->_has_selection = value;
#line 483 "../src/view.vala"
	_tmp0_ = sudoku_view_get_selected_cell (self);
#line 483 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 483 "../src/view.vala"
	_tmp2_ = sudoku_view_get_has_selection (self);
#line 483 "../src/view.vala"
	_tmp3_ = _tmp2_;
#line 483 "../src/view.vala"
	sudoku_cell_set_selected (_tmp1_, _tmp3_);
#line 484 "../src/view.vala"
	_tmp4_ = sudoku_view_get_has_selection (self);
#line 484 "../src/view.vala"
	_tmp5_ = _tmp4_;
#line 484 "../src/view.vala"
	if (_tmp5_) {
#line 3699 "view.c"
		SudokuCell* _tmp6_;
		SudokuCell* _tmp7_;
#line 485 "../src/view.vala"
		_tmp6_ = sudoku_view_get_selected_cell (self);
#line 485 "../src/view.vala"
		_tmp7_ = _tmp6_;
#line 485 "../src/view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp7_);
#line 3708 "view.c"
	} else {
		SudokuNumberPicker* _tmp8_;
#line 487 "../src/view.vala"
		_tmp8_ = self->number_picker;
#line 487 "../src/view.vala"
		gtk_popover_popdown ((GtkPopover*) _tmp8_);
#line 3715 "view.c"
	}
#line 489 "../src/view.vala"
	_tmp9_ = self->priv->_selected_row;
#line 489 "../src/view.vala"
	_tmp10_ = self->priv->_selected_col;
#line 489 "../src/view.vala"
	_tmp11_ = sudoku_view_get_has_selection (self);
#line 489 "../src/view.vala"
	_tmp12_ = _tmp11_;
#line 489 "../src/view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp9_, _tmp10_, _tmp12_);
#line 481 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY]);
#line 3729 "view.c"
}

ZoomLevel
sudoku_view_get_zoom_level (SudokuView* self)
{
	ZoomLevel result;
#line 496 "../src/view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 496 "../src/view.vala"
	result = self->priv->_zoom_level;
#line 496 "../src/view.vala"
	return result;
#line 3742 "view.c"
}

void
sudoku_view_set_zoom_level (SudokuView* self,
                            ZoomLevel value)
{
	ZoomLevel _tmp0_;
	ZoomLevel _tmp1_;
	SudokuCell** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
#line 497 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 498 "../src/view.vala"
	self->priv->_zoom_level = value;
#line 499 "../src/view.vala"
	_tmp0_ = sudoku_view_get_zoom_level (self);
#line 499 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 499 "../src/view.vala"
	switch (_tmp1_) {
#line 499 "../src/view.vala"
		case ZOOM_LEVEL_SMALL:
#line 3766 "view.c"
		{
#line 502 "../src/view.vala"
			sudoku_view_set_value_zoom_multiplier (self, 0.4);
#line 503 "../src/view.vala"
			break;
#line 3772 "view.c"
		}
#line 499 "../src/view.vala"
		case ZOOM_LEVEL_MEDIUM:
#line 3776 "view.c"
		{
#line 505 "../src/view.vala"
			sudoku_view_set_value_zoom_multiplier (self, 0.5);
#line 506 "../src/view.vala"
			break;
#line 3782 "view.c"
		}
#line 499 "../src/view.vala"
		case ZOOM_LEVEL_LARGE:
#line 3786 "view.c"
		{
#line 508 "../src/view.vala"
			sudoku_view_set_value_zoom_multiplier (self, 0.6);
#line 509 "../src/view.vala"
			break;
#line 3792 "view.c"
		}
		default:
		{
#line 511 "../src/view.vala"
			g_assert_not_reached ();
#line 3798 "view.c"
		}
	}
#line 514 "../src/view.vala"
	_tmp2_ = self->priv->cells;
#line 514 "../src/view.vala"
	_tmp2__length1 = self->priv->cells_length1;
#line 514 "../src/view.vala"
	_tmp2__length2 = self->priv->cells_length2;
#line 3807 "view.c"
	{
		SudokuCell** cell_collection = NULL;
		gint cell_collection_length1 = 0;
		gint cell_collection_length2 = 0;
		gint cell_it = 0;
#line 514 "../src/view.vala"
		cell_collection = _tmp2_;
#line 514 "../src/view.vala"
		cell_collection_length1 = _tmp2__length1 * _tmp2__length2;
#line 514 "../src/view.vala"
		for (cell_it = 0; cell_it < cell_collection_length1; cell_it = cell_it + 1) {
#line 3819 "view.c"
			SudokuCell* _tmp3_;
			SudokuCell* cell = NULL;
#line 514 "../src/view.vala"
			_tmp3_ = _g_object_ref0 (cell_collection[cell_it]);
#line 514 "../src/view.vala"
			cell = _tmp3_;
#line 3826 "view.c"
			{
				SudokuCell* _tmp4_;
#line 515 "../src/view.vala"
				_tmp4_ = cell;
#line 515 "../src/view.vala"
				gtk_widget_queue_allocate ((GtkWidget*) _tmp4_);
#line 514 "../src/view.vala"
				_g_object_unref0 (cell);
#line 3835 "view.c"
			}
		}
	}
#line 497 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_ZOOM_LEVEL_PROPERTY]);
#line 3841 "view.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 26 "../src/view.vala"
	g_return_if_fail (n_param_values == 5);
#line 26 "../src/view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 26 "../src/view.vala"
		data1 = closure->data;
#line 26 "../src/view.vala"
		data2 = param_values->data[0].v_pointer;
#line 3866 "view.c"
	} else {
#line 26 "../src/view.vala"
		data1 = param_values->data[0].v_pointer;
#line 26 "../src/view.vala"
		data2 = closure->data;
#line 3872 "view.c"
	}
#line 26 "../src/view.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 26 "../src/view.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 3878 "view.c"
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
#line 26 "../src/view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 26 "../src/view.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_view_real_dispose;
#line 26 "../src/view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 26 "../src/view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 26 "../src/view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_EARMARK_MODE_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_EARMARK_MODE_PROPERTY] = g_param_spec_boolean ("earmark-mode", "earmark-mode", "earmark-mode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_AUTOCLEAN_EARMARKS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_AUTOCLEAN_EARMARKS_PROPERTY] = g_param_spec_boolean ("autoclean-earmarks", "autoclean-earmarks", "autoclean-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_NUMBER_PICKER_SECOND_CLICK_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_NUMBER_PICKER_SECOND_CLICK_PROPERTY] = g_param_spec_boolean ("number-picker-second-click", "number-picker-second-click", "number-picker-second-click", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHT_ROW_COLUMN_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHT_ROW_COLUMN_PROPERTY] = g_param_spec_boolean ("highlight-row-column", "highlight-row-column", "highlight-row-column", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHT_BLOCK_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHT_BLOCK_PROPERTY] = g_param_spec_boolean ("highlight-block", "highlight-block", "highlight-block", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHT_NUMBERS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHT_NUMBERS_PROPERTY] = g_param_spec_boolean ("highlight-numbers", "highlight-numbers", "highlight-numbers", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_VALUE_ZOOM_MULTIPLIER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_VALUE_ZOOM_MULTIPLIER_PROPERTY] = g_param_spec_double ("value-zoom-multiplier", "value-zoom-multiplier", "value-zoom-multiplier", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_ROW_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY] = g_param_spec_int ("selected-row", "selected-row", "selected-row", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_COL_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY] = g_param_spec_int ("selected-col", "selected-col", "selected-col", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-earmark-warnings", "show-earmark-warnings", "show-earmark-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY] = g_param_spec_boolean ("solution-warnings", "solution-warnings", "solution-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HAS_SELECTION_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY] = g_param_spec_boolean ("has-selection", "has-selection", "has-selection", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_ZOOM_LEVEL_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_ZOOM_LEVEL_PROPERTY] = g_param_spec_enum ("zoom-level", "zoom-level", "zoom-level", TYPE_ZOOM_LEVEL, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", TYPE_SUDOKU_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 3931 "view.c"
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
#line 26 "../src/view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 38 "../src/view.vala"
	self->priv->_earmark_mode = FALSE;
#line 46 "../src/view.vala"
	self->priv->_selected_row = 0;
#line 47 "../src/view.vala"
	self->priv->_selected_col = 0;
#line 477 "../src/view.vala"
	self->priv->_has_selection = TRUE;
#line 3948 "view.c"
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 26 "../src/view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 28 "../src/view.vala"
	_g_object_unref0 (self->priv->settings);
#line 29 "../src/view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 30 "../src/view.vala"
	_g_object_unref0 (self->priv->focus_controller);
#line 31 "../src/view.vala"
	_g_object_unref0 (self->priv->game);
#line 32 "../src/view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 33 "../src/view.vala"
	_g_object_unref0 (self->priv->frame);
#line 34 "../src/view.vala"
	_g_object_unref0 (self->priv->paused_label);
#line 36 "../src/view.vala"
	_g_object_unref0 (self->number_picker);
#line 26 "../src/view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 3975 "view.c"
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (adw_bin_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/view.vala"
	switch (property_id) {
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_EARMARK_MODE_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_earmark_mode (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_AUTOCLEAN_EARMARKS_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_autoclean_earmarks (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_NUMBER_PICKER_SECOND_CLICK_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_number_picker_second_click (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HIGHLIGHT_ROW_COLUMN_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlight_row_column (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HIGHLIGHT_BLOCK_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlight_block (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HIGHLIGHT_NUMBERS_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlight_numbers (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_VALUE_ZOOM_MULTIPLIER_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_double (value, sudoku_view_get_value_zoom_multiplier (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_int (value, sudoku_view_get_selected_row (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_int (value, sudoku_view_get_selected_col (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_earmark_warnings (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_solution_warnings (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_has_selection (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_ZOOM_LEVEL_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_enum (value, sudoku_view_get_zoom_level (self));
#line 26 "../src/view.vala"
		break;
#line 4106 "view.c"
		default:
#line 26 "../src/view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/view.vala"
		break;
#line 4112 "view.c"
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/view.vala"
	switch (property_id) {
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_EARMARK_MODE_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_earmark_mode (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_AUTOCLEAN_EARMARKS_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_autoclean_earmarks (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_NUMBER_PICKER_SECOND_CLICK_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_number_picker_second_click (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HIGHLIGHT_ROW_COLUMN_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_highlight_row_column (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HIGHLIGHT_BLOCK_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_highlight_block (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HIGHLIGHT_NUMBERS_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_highlight_numbers (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_VALUE_ZOOM_MULTIPLIER_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_value_zoom_multiplier (self, g_value_get_double (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_selected_row (self, g_value_get_int (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_selected_col (self, g_value_get_int (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_show_earmark_warnings (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_solution_warnings (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_has_selection (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_ZOOM_LEVEL_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_zoom_level (self, g_value_get_enum (value));
#line 26 "../src/view.vala"
		break;
#line 4222 "view.c"
		default:
#line 26 "../src/view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/view.vala"
		break;
#line 4228 "view.c"
	}
}

gboolean
zoom_level_is_fully_zoomed_out (ZoomLevel self)
{
	gboolean result;
#line 562 "../src/view.vala"
	switch (self) {
#line 562 "../src/view.vala"
		case ZOOM_LEVEL_SMALL:
#line 4240 "view.c"
		{
#line 565 "../src/view.vala"
			result = TRUE;
#line 565 "../src/view.vala"
			return result;
#line 4246 "view.c"
		}
		default:
		{
#line 567 "../src/view.vala"
			result = FALSE;
#line 567 "../src/view.vala"
			return result;
#line 4254 "view.c"
		}
	}
}

gboolean
zoom_level_is_fully_zoomed_in (ZoomLevel self)
{
	gboolean result;
#line 573 "../src/view.vala"
	switch (self) {
#line 573 "../src/view.vala"
		case ZOOM_LEVEL_LARGE:
#line 4267 "view.c"
		{
#line 576 "../src/view.vala"
			result = TRUE;
#line 576 "../src/view.vala"
			return result;
#line 4273 "view.c"
		}
		default:
		{
#line 578 "../src/view.vala"
			result = FALSE;
#line 578 "../src/view.vala"
			return result;
#line 4281 "view.c"
		}
	}
}

ZoomLevel
zoom_level_zoom_in (ZoomLevel self)
{
	ZoomLevel result;
#line 584 "../src/view.vala"
	switch (self) {
#line 584 "../src/view.vala"
		case ZOOM_LEVEL_SMALL:
#line 4294 "view.c"
		{
#line 587 "../src/view.vala"
			result = ZOOM_LEVEL_MEDIUM;
#line 587 "../src/view.vala"
			return result;
#line 4300 "view.c"
		}
#line 584 "../src/view.vala"
		case ZOOM_LEVEL_MEDIUM:
#line 4304 "view.c"
		{
#line 589 "../src/view.vala"
			result = ZOOM_LEVEL_LARGE;
#line 589 "../src/view.vala"
			return result;
#line 4310 "view.c"
		}
#line 584 "../src/view.vala"
		case ZOOM_LEVEL_LARGE:
#line 4314 "view.c"
		{
			{
#line 592 "../src/view.vala"
				g_warning ("view.vala:592: ZOOM already at maximum");
#line 593 "../src/view.vala"
				result = ZOOM_LEVEL_LARGE;
#line 593 "../src/view.vala"
				return result;
#line 4323 "view.c"
			}
		}
		default:
		{
#line 596 "../src/view.vala"
			g_assert_not_reached ();
#line 4330 "view.c"
		}
	}
}

ZoomLevel
zoom_level_zoom_out (ZoomLevel self)
{
	ZoomLevel result;
#line 602 "../src/view.vala"
	switch (self) {
#line 602 "../src/view.vala"
		case ZOOM_LEVEL_LARGE:
#line 4343 "view.c"
		{
#line 605 "../src/view.vala"
			result = ZOOM_LEVEL_MEDIUM;
#line 605 "../src/view.vala"
			return result;
#line 4349 "view.c"
		}
#line 602 "../src/view.vala"
		case ZOOM_LEVEL_MEDIUM:
#line 4353 "view.c"
		{
#line 607 "../src/view.vala"
			result = ZOOM_LEVEL_SMALL;
#line 607 "../src/view.vala"
			return result;
#line 4359 "view.c"
		}
#line 602 "../src/view.vala"
		case ZOOM_LEVEL_SMALL:
#line 4363 "view.c"
		{
			{
#line 610 "../src/view.vala"
				g_warning ("view.vala:610: ZOOM already at minimum");
#line 611 "../src/view.vala"
				result = ZOOM_LEVEL_SMALL;
#line 611 "../src/view.vala"
				return result;
#line 4372 "view.c"
			}
		}
		default:
		{
#line 614 "../src/view.vala"
			g_assert_not_reached ();
#line 4379 "view.c"
		}
	}
}

static GType
zoom_level_get_type_once (void)
{
	static const GEnumValue values[] = {{ZOOM_LEVEL_NONE, "ZOOM_LEVEL_NONE", "none"}, {ZOOM_LEVEL_SMALL, "ZOOM_LEVEL_SMALL", "small"}, {ZOOM_LEVEL_MEDIUM, "ZOOM_LEVEL_MEDIUM", "medium"}, {ZOOM_LEVEL_LARGE, "ZOOM_LEVEL_LARGE", "large"}, {0, NULL, NULL}};
	GType zoom_level_type_id;
	zoom_level_type_id = g_enum_register_static ("ZoomLevel", values);
	return zoom_level_type_id;
}

GType
zoom_level_get_type (void)
{
	static volatile gsize zoom_level_type_id__once = 0;
	if (g_once_init_enter (&zoom_level_type_id__once)) {
		GType zoom_level_type_id;
		zoom_level_type_id = zoom_level_get_type_once ();
		g_once_init_leave (&zoom_level_type_id__once, zoom_level_type_id);
	}
	return zoom_level_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

