/* window.c generated by valac 0.56.18, the Vala compiler
 * generated from window.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014, 2020 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include "libsudoku.h"
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define SUDOKU_WINDOW_SMALL_WINDOW_WIDTH 360
#define SUDOKU_WINDOW_MEDIUM_WINDOW_WIDTH 600
#define SUDOKU_WINDOW_MARGIN_DEFAULT_SIZE 25
#define SUDOKU_WINDOW_MARGIN_SMALL_SIZE 10
#define SUDOKU_WINDOW_MARGIN_SIZE_DIFF (SUDOKU_WINDOW_MARGIN_DEFAULT_SIZE - SUDOKU_WINDOW_MARGIN_SMALL_SIZE)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_WINDOW (sudoku_window_get_type ())
#define SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_WINDOW, SudokuWindow))
#define SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_WINDOW, SudokuWindowClass))
#define IS_SUDOKU_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_WINDOW))
#define IS_SUDOKU_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_WINDOW))
#define SUDOKU_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_WINDOW, SudokuWindowClass))

typedef struct _SudokuWindow SudokuWindow;
typedef struct _SudokuWindowClass SudokuWindowClass;
typedef struct _SudokuWindowPrivate SudokuWindowPrivate;

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef enum  {
	SUDOKU_WINDOW_SCREEN_NONE,
	SUDOKU_WINDOW_SCREEN_PLAY,
	SUDOKU_WINDOW_SCREEN_CREATE,
	SUDOKU_WINDOW_SCREEN_MENU
} SudokuWindowScreen;

#define TYPE_SUDOKU_WINDOW_SCREEN (sudoku_window_screen_get_type ())
enum  {
	SUDOKU_WINDOW_0_PROPERTY,
	SUDOKU_WINDOW_SETTINGS_PROPERTY,
	SUDOKU_WINDOW_VIEW_PROPERTY,
	SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY,
	SUDOKU_WINDOW_SHOW_TIMER_PROPERTY,
	SUDOKU_WINDOW_NUM_PROPERTIES
};
static GParamSpec* sudoku_window_properties[SUDOKU_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuWindow {
	AdwApplicationWindow parent_instance;
	SudokuWindowPrivate * priv;
};

struct _SudokuWindowClass {
	AdwApplicationWindowClass parent_class;
};

struct _SudokuWindowPrivate {
	AdwWindowTitle* windowtitle;
	AdwHeaderBar* headerbar;
	GtkBox* game_box;
	GtkPopoverMenu* main_menu;
	GtkBox* start_box;
	GtkButton* start_button;
	GtkCheckButton* custom_check;
	GtkCheckButton* easy_check;
	GtkCheckButton* medium_check;
	GtkCheckButton* hard_check;
	GtkCheckButton* very_hard_check;
	GtkStack* menu_fullscreen_stack;
	GtkStack* play_pause_stack;
	GtkToggleButton* earmark_mode_button;
	GtkButton* undo_button;
	GtkButton* redo_button;
	GtkButton* back_button;
	GtkButton* unfullscreen_button;
	GtkButton* menu_unfullscreen_button;
	GtkButton* menu_fullscreen_button;
	GtkButton* play_custom_game_button;
	GtkButton* pause_button;
	GtkButton* play_button;
	GtkBox* clock_box;
	GtkLabel* clock_label;
	gint _window_width;
	gint _window_height;
	gboolean _window_width_is_small;
	gboolean _window_height_is_small;
	gint small_window_height;
	gint medium_window_height;
	GtkCssProvider* accent_provider;
	AdwStyleManager* style_manager;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureClick* backwards_controller;
	GtkGestureClick* forwards_controller;
	GtkEventControllerScroll* scroll_controller;
	GSettings* _settings;
	SudokuView* _view;
	SudokuWindowScreen _current_screen;
	gboolean _show_timer;
};

static gint SudokuWindow_private_offset;
static gpointer sudoku_window_parent_class = NULL;

VALA_EXTERN GType sudoku_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuWindow, g_object_unref)
VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_window_screen_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SudokuWindow* sudoku_window_new (GSettings* settings);
VALA_EXTERN SudokuWindow* sudoku_window_construct (GType object_type,
                                       GSettings* settings);
static void sudoku_window_set_settings (SudokuWindow* self,
                                 GSettings* value);
static void sudoku_window_construct_window_parameters (SudokuWindow* self);
static void sudoku_window_fullscreen_cb (SudokuWindow* self);
static void _sudoku_window_fullscreen_cb_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static void sudoku_window_set_gamebox_width_margins (SudokuWindow* self,
                                              gint width);
static gint sudoku_window_get_window_width (SudokuWindow* self);
static void sudoku_window_set_gamebox_height_margins (SudokuWindow* self,
                                               gint height);
static gint sudoku_window_get_window_height (SudokuWindow* self);
static void sudoku_window_button_released_cb (SudokuWindow* self,
                                       GtkGestureClick* gesture,
                                       gint n_press,
                                       gdouble x,
                                       gdouble y);
static void _sudoku_window_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                   gint n_press,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   gpointer self);
static void sudoku_window_backwards_pressed_cb (SudokuWindow* self,
                                         GtkGestureClick* gesture,
                                         gint n_press,
                                         gdouble x,
                                         gdouble y);
static void _sudoku_window_backwards_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                    gint n_press,
                                                                    gdouble x,
                                                                    gdouble y,
                                                                    gpointer self);
static void sudoku_window_forwards_pressed_cb (SudokuWindow* self,
                                        GtkGestureClick* gesture,
                                        gint n_press,
                                        gdouble x,
                                        gdouble y);
static void _sudoku_window_forwards_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                   gint n_press,
                                                                   gdouble x,
                                                                   gdouble y,
                                                                   gpointer self);
static gboolean sudoku_window_scroll_cb (SudokuWindow* self,
                                  GtkEventControllerScroll* event,
                                  gdouble dx,
                                  gdouble dy);
static gboolean _sudoku_window_scroll_cb_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                      gdouble dx,
                                                                      gdouble dy,
                                                                      gpointer self);
static void sudoku_window_scroll_begin_cb (SudokuWindow* self,
                                    GtkEventControllerScroll* event);
static void _sudoku_window_scroll_begin_cb_gtk_event_controller_scroll_scroll_begin (GtkEventControllerScroll* _sender,
                                                                              gpointer self);
static void sudoku_window_scroll_end_cb (SudokuWindow* self,
                                  GtkEventControllerScroll* event);
static void _sudoku_window_scroll_end_cb_gtk_event_controller_scroll_scroll_end (GtkEventControllerScroll* _sender,
                                                                          gpointer self);
static void sudoku_window_set_accent_color (SudokuWindow* self,
                                     AdwAccentColor color);
static void __lambda6_ (SudokuWindow* self);
static void ___lambda6__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda7_ (SudokuWindow* self);
VALA_EXTERN SudokuWindowScreen sudoku_window_get_current_screen (SudokuWindow* self);
VALA_EXTERN SudokuView* sudoku_window_get_view (SudokuWindow* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda7__gtk_popover_closed (GtkPopover* _sender,
                                     gpointer self);
static void sudoku_window_visible_dialog_cb (SudokuWindow* self);
static void _sudoku_window_visible_dialog_cb_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static gboolean sudoku_window_close_cb (SudokuWindow* self);
static gboolean _sudoku_window_close_cb_gtk_window_close_request (GtkWindow* _sender,
                                                           gpointer self);
VALA_EXTERN GSettings* sudoku_window_get_settings (SudokuWindow* self);
static void sudoku_window_set_window_width (SudokuWindow* self,
                                     gint value);
static void sudoku_window_set_window_height (SudokuWindow* self,
                                      gint value);
static void sudoku_window_set_window_width_is_small (SudokuWindow* self,
                                              gboolean value);
static void sudoku_window_set_window_height_is_small (SudokuWindow* self,
                                               gboolean value);
static void sudoku_window_start_game_cb (SudokuWindow* self,
                                  GtkButton* btn);
static gboolean* _bool_dup (gboolean* self);
static void _sudoku_window_start_game_cb_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
static void sudoku_window_window_width_is_medium_cb (SudokuWindow* self);
VALA_EXTERN gboolean sudoku_window_get_show_timer (SudokuWindow* self);
static void sudoku_window_window_width_is_small_cb (SudokuWindow* self);
VALA_EXTERN void sudoku_window_will_start_game (SudokuWindow* self);
VALA_EXTERN void sudoku_window_start_game (SudokuWindow* self,
                               SudokuGame* game);
static void sudoku_window_tick_cb (SudokuWindow* self);
static void _sudoku_window_tick_cb_sudoku_game_tick (SudokuGame* _sender,
                                              gpointer self);
static void sudoku_window_paused_cb (SudokuWindow* self);
static void _sudoku_window_paused_cb_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self);
VALA_EXTERN void sudoku_window_show_game_view (SudokuWindow* self);
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game,
                             GSettings* settings);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game,
                                   GSettings* settings);
static void sudoku_window_set_view (SudokuWindow* self,
                             SudokuView* value);
VALA_EXTERN void sudoku_window_show_menu_screen (SudokuWindow* self);
static void sudoku_window_set_current_screen (SudokuWindow* self,
                                       SudokuWindowScreen value);
VALA_EXTERN void sudoku_window_set_board_visible (SudokuWindow* self,
                                      gboolean visible);
VALA_EXTERN void sudoku_window_activate_difficulty_checkbutton (SudokuWindow* self,
                                                    DifficultyCategory difficulty);
VALA_EXTERN gboolean sudoku_window_is_board_visible (SudokuWindow* self);
static gboolean sudoku_window_get_window_width_is_small (SudokuWindow* self);
VALA_EXTERN void sudoku_window_board_completed (SudokuWindow* self);
VALA_EXTERN void sudoku_view_dismiss_picker (SudokuView* self);
static gdouble sudoku_window_normalize (SudokuWindow* self,
                                 gint val,
                                 gint min,
                                 gint max);
static void sudoku_window_real_size_allocate (GtkWidget* base,
                                       gint width,
                                       gint height,
                                       gint baseline);
static void sudoku_window_real_dispose (GObject* base);
static gboolean sudoku_window_get_window_height_is_small (SudokuWindow* self);
VALA_EXTERN void sudoku_window_set_show_timer (SudokuWindow* self,
                                   gboolean value);
static void sudoku_window_finalize (GObject * obj);
static GType sudoku_window_get_type_once (void);
static void _vala_sudoku_window_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_sudoku_window_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
sudoku_window_get_instance_private (SudokuWindow* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuWindow_private_offset);
}

static void
_sudoku_window_fullscreen_cb_g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
#line 93 "../src/window.vala"
	sudoku_window_fullscreen_cb ((SudokuWindow*) self);
#line 332 "window.c"
}

static void
_sudoku_window_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                              gint n_press,
                                                              gdouble x,
                                                              gdouble y,
                                                              gpointer self)
{
#line 102 "../src/window.vala"
	sudoku_window_button_released_cb ((SudokuWindow*) self, _sender, n_press, x, y);
#line 344 "window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 103 "../src/window.vala"
	return self ? g_object_ref (self) : NULL;
#line 352 "window.c"
}

static void
_sudoku_window_backwards_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                               gint n_press,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self)
{
#line 107 "../src/window.vala"
	sudoku_window_backwards_pressed_cb ((SudokuWindow*) self, _sender, n_press, x, y);
#line 364 "window.c"
}

static void
_sudoku_window_forwards_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                              gint n_press,
                                                              gdouble x,
                                                              gdouble y,
                                                              gpointer self)
{
#line 113 "../src/window.vala"
	sudoku_window_forwards_pressed_cb ((SudokuWindow*) self, _sender, n_press, x, y);
#line 376 "window.c"
}

static gboolean
_sudoku_window_scroll_cb_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                             gdouble dx,
                                                             gdouble dy,
                                                             gpointer self)
{
	gboolean result;
	result = sudoku_window_scroll_cb ((SudokuWindow*) self, _sender, dx, dy);
#line 118 "../src/window.vala"
	return result;
#line 389 "window.c"
}

static void
_sudoku_window_scroll_begin_cb_gtk_event_controller_scroll_scroll_begin (GtkEventControllerScroll* _sender,
                                                                         gpointer self)
{
#line 119 "../src/window.vala"
	sudoku_window_scroll_begin_cb ((SudokuWindow*) self, _sender);
#line 398 "window.c"
}

static void
_sudoku_window_scroll_end_cb_gtk_event_controller_scroll_scroll_end (GtkEventControllerScroll* _sender,
                                                                     gpointer self)
{
#line 120 "../src/window.vala"
	sudoku_window_scroll_end_cb ((SudokuWindow*) self, _sender);
#line 407 "window.c"
}

static void
__lambda6_ (SudokuWindow* self)
{
	AdwStyleManager* _tmp0_;
#line 130 "../src/window.vala"
	_tmp0_ = self->priv->style_manager;
#line 130 "../src/window.vala"
	sudoku_window_set_accent_color (self, adw_style_manager_get_accent_color (_tmp0_));
#line 418 "window.c"
}

static void
___lambda6__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 129 "../src/window.vala"
	__lambda6_ ((SudokuWindow*) self);
#line 428 "window.c"
}

static void
__lambda7_ (SudokuWindow* self)
{
	SudokuWindowScreen _tmp0_;
#line 134 "../src/window.vala"
	_tmp0_ = self->priv->_current_screen;
#line 134 "../src/window.vala"
	if (_tmp0_ != SUDOKU_WINDOW_SCREEN_MENU) {
#line 439 "window.c"
		SudokuView* _tmp1_;
#line 135 "../src/window.vala"
		_tmp1_ = self->priv->_view;
#line 135 "../src/window.vala"
		sudoku_view_set_has_selection (_tmp1_, TRUE);
#line 445 "window.c"
	} else {
		GtkButton* _tmp2_;
#line 137 "../src/window.vala"
		_tmp2_ = self->priv->start_button;
#line 137 "../src/window.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
#line 452 "window.c"
	}
}

static void
___lambda7__gtk_popover_closed (GtkPopover* _sender,
                                gpointer self)
{
#line 133 "../src/window.vala"
	__lambda7_ ((SudokuWindow*) self);
#line 462 "window.c"
}

static void
_sudoku_window_visible_dialog_cb_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 140 "../src/window.vala"
	sudoku_window_visible_dialog_cb ((SudokuWindow*) self);
#line 472 "window.c"
}

static gboolean
_sudoku_window_close_cb_gtk_window_close_request (GtkWindow* _sender,
                                                  gpointer self)
{
	gboolean result;
	result = sudoku_window_close_cb ((SudokuWindow*) self);
#line 141 "../src/window.vala"
	return result;
#line 483 "window.c"
}

SudokuWindow*
sudoku_window_construct (GType object_type,
                         GSettings* settings)
{
	SudokuWindow * self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GtkGestureClick* _tmp2_;
	GtkGestureClick* _tmp3_;
	GtkGestureClick* _tmp4_;
	GtkGestureClick* _tmp5_;
	GtkEventController* _tmp6_;
	GtkGestureClick* _tmp7_;
	GtkGestureClick* _tmp8_;
	GtkGestureClick* _tmp9_;
	GtkGestureClick* _tmp10_;
	GtkGestureClick* _tmp11_;
	GtkEventController* _tmp12_;
	GtkGestureClick* _tmp13_;
	GtkGestureClick* _tmp14_;
	GtkGestureClick* _tmp15_;
	GtkGestureClick* _tmp16_;
	GtkGestureClick* _tmp17_;
	GtkEventController* _tmp18_;
	GtkEventControllerScroll* _tmp19_;
	GtkEventControllerScroll* _tmp20_;
	GtkEventControllerScroll* _tmp21_;
	GtkEventControllerScroll* _tmp22_;
	GtkEventControllerScroll* _tmp23_;
	GtkEventControllerScroll* _tmp24_;
	GtkEventController* _tmp25_;
	GtkCssProvider* _tmp26_;
	GdkDisplay* _tmp27_;
	GtkCssProvider* _tmp28_;
	AdwStyleManager* _tmp29_;
	AdwStyleManager* _tmp30_;
	AdwStyleManager* _tmp31_;
	AdwStyleManager* _tmp32_;
	GtkPopoverMenu* _tmp33_;
#line 87 "../src/window.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 87 "../src/window.vala"
	self = (SudokuWindow*) g_object_new (object_type, NULL);
#line 89 "../src/window.vala"
	sudoku_window_set_settings (self, settings);
#line 91 "../src/window.vala"
	sudoku_window_construct_window_parameters (self);
#line 93 "../src/window.vala"
	g_signal_connect_object ((GObject*) self, "notify::fullscreened", (GCallback) _sudoku_window_fullscreen_cb_g_object_notify, self, 0);
#line 95 "../src/window.vala"
	g_object_set ((GtkWindow*) self, "fullscreened", g_settings_get_boolean (settings, "window-is-fullscreen"), NULL);
#line 96 "../src/window.vala"
	g_object_set ((GtkWindow*) self, "maximized", g_settings_get_boolean (settings, "window-is-maximized"), NULL);
#line 97 "../src/window.vala"
	_tmp0_ = self->priv->_window_width;
#line 97 "../src/window.vala"
	sudoku_window_set_gamebox_width_margins (self, _tmp0_);
#line 98 "../src/window.vala"
	_tmp1_ = self->priv->_window_height;
#line 98 "../src/window.vala"
	sudoku_window_set_gamebox_height_margins (self, _tmp1_);
#line 100 "../src/window.vala"
	_tmp2_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 100 "../src/window.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 100 "../src/window.vala"
	self->priv->button_controller = _tmp2_;
#line 101 "../src/window.vala"
	_tmp3_ = self->priv->button_controller;
#line 101 "../src/window.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp3_, (guint) 0);
#line 102 "../src/window.vala"
	_tmp4_ = self->priv->button_controller;
#line 102 "../src/window.vala"
	g_signal_connect_object (_tmp4_, "released", (GCallback) _sudoku_window_button_released_cb_gtk_gesture_click_released, self, 0);
#line 103 "../src/window.vala"
	_tmp5_ = self->priv->button_controller;
#line 103 "../src/window.vala"
	_tmp6_ = _g_object_ref0 ((GtkEventController*) _tmp5_);
#line 103 "../src/window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp6_);
#line 105 "../src/window.vala"
	_tmp7_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 105 "../src/window.vala"
	_g_object_unref0 (self->priv->backwards_controller);
#line 105 "../src/window.vala"
	self->priv->backwards_controller = _tmp7_;
#line 106 "../src/window.vala"
	_tmp8_ = self->priv->backwards_controller;
#line 106 "../src/window.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp8_, (guint) 8);
#line 107 "../src/window.vala"
	_tmp9_ = self->priv->backwards_controller;
#line 107 "../src/window.vala"
	g_signal_connect_object (_tmp9_, "pressed", (GCallback) _sudoku_window_backwards_pressed_cb_gtk_gesture_click_pressed, self, 0);
#line 108 "../src/window.vala"
	_tmp10_ = self->priv->backwards_controller;
#line 108 "../src/window.vala"
	gtk_event_controller_set_propagation_limit ((GtkEventController*) _tmp10_, GTK_LIMIT_NONE);
#line 109 "../src/window.vala"
	_tmp11_ = self->priv->backwards_controller;
#line 109 "../src/window.vala"
	_tmp12_ = _g_object_ref0 ((GtkEventController*) _tmp11_);
#line 109 "../src/window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp12_);
#line 111 "../src/window.vala"
	_tmp13_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 111 "../src/window.vala"
	_g_object_unref0 (self->priv->forwards_controller);
#line 111 "../src/window.vala"
	self->priv->forwards_controller = _tmp13_;
#line 112 "../src/window.vala"
	_tmp14_ = self->priv->forwards_controller;
#line 112 "../src/window.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp14_, (guint) 9);
#line 113 "../src/window.vala"
	_tmp15_ = self->priv->forwards_controller;
#line 113 "../src/window.vala"
	g_signal_connect_object (_tmp15_, "pressed", (GCallback) _sudoku_window_forwards_pressed_cb_gtk_gesture_click_pressed, self, 0);
#line 114 "../src/window.vala"
	_tmp16_ = self->priv->forwards_controller;
#line 114 "../src/window.vala"
	gtk_event_controller_set_propagation_limit ((GtkEventController*) _tmp16_, GTK_LIMIT_NONE);
#line 115 "../src/window.vala"
	_tmp17_ = self->priv->forwards_controller;
#line 115 "../src/window.vala"
	_tmp18_ = _g_object_ref0 ((GtkEventController*) _tmp17_);
#line 115 "../src/window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp18_);
#line 117 "../src/window.vala"
	_tmp19_ = (GtkEventControllerScroll*) gtk_event_controller_scroll_new (GTK_EVENT_CONTROLLER_SCROLL_VERTICAL);
#line 117 "../src/window.vala"
	_g_object_unref0 (self->priv->scroll_controller);
#line 117 "../src/window.vala"
	self->priv->scroll_controller = _tmp19_;
#line 118 "../src/window.vala"
	_tmp20_ = self->priv->scroll_controller;
#line 118 "../src/window.vala"
	g_signal_connect_object (_tmp20_, "scroll", (GCallback) _sudoku_window_scroll_cb_gtk_event_controller_scroll_scroll, self, 0);
#line 119 "../src/window.vala"
	_tmp21_ = self->priv->scroll_controller;
#line 119 "../src/window.vala"
	g_signal_connect_object (_tmp21_, "scroll-begin", (GCallback) _sudoku_window_scroll_begin_cb_gtk_event_controller_scroll_scroll_begin, self, 0);
#line 120 "../src/window.vala"
	_tmp22_ = self->priv->scroll_controller;
#line 120 "../src/window.vala"
	g_signal_connect_object (_tmp22_, "scroll-end", (GCallback) _sudoku_window_scroll_end_cb_gtk_event_controller_scroll_scroll_end, self, 0);
#line 121 "../src/window.vala"
	_tmp23_ = self->priv->scroll_controller;
#line 121 "../src/window.vala"
	gtk_event_controller_set_propagation_limit ((GtkEventController*) _tmp23_, GTK_LIMIT_NONE);
#line 122 "../src/window.vala"
	_tmp24_ = self->priv->scroll_controller;
#line 122 "../src/window.vala"
	_tmp25_ = _g_object_ref0 ((GtkEventController*) _tmp24_);
#line 122 "../src/window.vala"
	gtk_widget_add_controller (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), _tmp25_);
#line 124 "../src/window.vala"
	_tmp26_ = gtk_css_provider_new ();
#line 124 "../src/window.vala"
	_g_object_unref0 (self->priv->accent_provider);
#line 124 "../src/window.vala"
	self->priv->accent_provider = _tmp26_;
#line 125 "../src/window.vala"
	_tmp27_ = gtk_root_get_display ((GtkRoot*) self);
#line 125 "../src/window.vala"
	_tmp28_ = self->priv->accent_provider;
#line 125 "../src/window.vala"
	gtk_style_context_add_provider_for_display (_tmp27_, (GtkStyleProvider*) _tmp28_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 127 "../src/window.vala"
	_tmp29_ = adw_style_manager_get_default ();
#line 127 "../src/window.vala"
	_tmp30_ = _g_object_ref0 (_tmp29_);
#line 127 "../src/window.vala"
	_g_object_unref0 (self->priv->style_manager);
#line 127 "../src/window.vala"
	self->priv->style_manager = _tmp30_;
#line 128 "../src/window.vala"
	_tmp31_ = self->priv->style_manager;
#line 128 "../src/window.vala"
	sudoku_window_set_accent_color (self, adw_style_manager_get_accent_color (_tmp31_));
#line 129 "../src/window.vala"
	_tmp32_ = self->priv->style_manager;
#line 129 "../src/window.vala"
	g_signal_connect_object ((GObject*) _tmp32_, "notify::accent-color", (GCallback) ___lambda6__g_object_notify, self, 0);
#line 133 "../src/window.vala"
	_tmp33_ = self->priv->main_menu;
#line 133 "../src/window.vala"
	g_signal_connect_object ((GtkPopover*) _tmp33_, "closed", (GCallback) ___lambda7__gtk_popover_closed, self, 0);
#line 140 "../src/window.vala"
	g_signal_connect_object ((GObject*) self, "notify::visible-dialog", (GCallback) _sudoku_window_visible_dialog_cb_g_object_notify, self, 0);
#line 141 "../src/window.vala"
	g_signal_connect_object ((GtkWindow*) self, "close-request", (GCallback) _sudoku_window_close_cb_gtk_window_close_request, self, 0);
#line 87 "../src/window.vala"
	return self;
#line 681 "window.c"
}

SudokuWindow*
sudoku_window_new (GSettings* settings)
{
#line 87 "../src/window.vala"
	return sudoku_window_construct (TYPE_SUDOKU_WINDOW, settings);
#line 689 "window.c"
}

static void
sudoku_window_construct_window_parameters (SudokuWindow* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	gint headerbar_natural_height = 0;
	AdwHeaderBar* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GtkLabel* title_label = NULL;
	AdwWindowTitle* _tmp9_;
	GtkWidget* _tmp10_;
	GtkWidget* _tmp11_;
	GtkLabel* _tmp12_;
	GValue _tmp13_ = {0};
#line 173 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/window.vala"
	_tmp0_ = self->priv->_settings;
#line 175 "../src/window.vala"
	sudoku_window_set_window_width (self, g_settings_get_int (_tmp0_, "window-width"));
#line 176 "../src/window.vala"
	_tmp1_ = self->priv->_settings;
#line 176 "../src/window.vala"
	sudoku_window_set_window_height (self, g_settings_get_int (_tmp1_, "window-height"));
#line 178 "../src/window.vala"
	_tmp2_ = self->priv->_settings;
#line 178 "../src/window.vala"
	g_settings_bind (_tmp2_, "show-timer", (GObject*) self, "show-timer", G_SETTINGS_BIND_GET);
#line 181 "../src/window.vala"
	_tmp3_ = self->priv->headerbar;
#line 181 "../src/window.vala"
	gtk_widget_measure ((GtkWidget*) _tmp3_, GTK_ORIENTATION_VERTICAL, -1, NULL, &_tmp4_, NULL, NULL);
#line 181 "../src/window.vala"
	headerbar_natural_height = _tmp4_;
#line 183 "../src/window.vala"
	self->priv->small_window_height = SUDOKU_WINDOW_SMALL_WINDOW_WIDTH + headerbar_natural_height;
#line 184 "../src/window.vala"
	self->priv->medium_window_height = SUDOKU_WINDOW_MEDIUM_WINDOW_WIDTH + headerbar_natural_height;
#line 186 "../src/window.vala"
	_tmp5_ = self->priv->_window_width;
#line 186 "../src/window.vala"
	sudoku_window_set_window_width_is_small (self, _tmp5_ <= SUDOKU_WINDOW_MEDIUM_WINDOW_WIDTH);
#line 187 "../src/window.vala"
	_tmp6_ = self->priv->_window_height;
#line 187 "../src/window.vala"
	sudoku_window_set_window_height_is_small (self, _tmp6_ <= self->priv->medium_window_height);
#line 189 "../src/window.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, SUDOKU_WINDOW_SMALL_WINDOW_WIDTH, self->priv->small_window_height);
#line 190 "../src/window.vala"
	_tmp7_ = self->priv->_window_width;
#line 190 "../src/window.vala"
	_tmp8_ = self->priv->_window_height;
#line 190 "../src/window.vala"
	gtk_window_set_default_size ((GtkWindow*) self, _tmp7_, _tmp8_);
#line 192 "../src/window.vala"
	_tmp9_ = self->priv->windowtitle;
#line 192 "../src/window.vala"
	_tmp10_ = gtk_widget_get_first_child ((GtkWidget*) _tmp9_);
#line 192 "../src/window.vala"
	_tmp11_ = gtk_widget_get_first_child (_tmp10_);
#line 192 "../src/window.vala"
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_label_get_type (), GtkLabel));
#line 192 "../src/window.vala"
	title_label = _tmp12_;
#line 193 "../src/window.vala"
	g_value_init (&_tmp13_, G_TYPE_BOOLEAN);
#line 193 "../src/window.vala"
	g_value_set_boolean (&_tmp13_, FALSE);
#line 193 "../src/window.vala"
	g_object_set_property ((GObject*) title_label, "ellipsize", &_tmp13_);
#line 193 "../src/window.vala"
	G_IS_VALUE (&_tmp13_) ? (g_value_unset (&_tmp13_), NULL) : NULL;
#line 173 "../src/window.vala"
	_g_object_unref0 (title_label);
#line 771 "window.c"
}

static void
sudoku_window_set_accent_color (SudokuWindow* self,
                                AdwAccentColor color)
{
	gchar* css_color = NULL;
	gchar* s = NULL;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkCssProvider* _tmp15_;
#line 196 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/window.vala"
	switch (color) {
#line 199 "../src/window.vala"
		case ADW_ACCENT_COLOR_BLUE:
#line 792 "window.c"
		{
			gchar* _tmp0_;
#line 202 "../src/window.vala"
			_tmp0_ = g_strdup ("blue");
#line 202 "../src/window.vala"
			_g_free0 (css_color);
#line 202 "../src/window.vala"
			css_color = _tmp0_;
#line 203 "../src/window.vala"
			break;
#line 803 "window.c"
		}
#line 199 "../src/window.vala"
		case ADW_ACCENT_COLOR_TEAL:
#line 807 "window.c"
		{
			gchar* _tmp1_;
#line 205 "../src/window.vala"
			_tmp1_ = g_strdup ("teal");
#line 205 "../src/window.vala"
			_g_free0 (css_color);
#line 205 "../src/window.vala"
			css_color = _tmp1_;
#line 206 "../src/window.vala"
			break;
#line 818 "window.c"
		}
#line 199 "../src/window.vala"
		case ADW_ACCENT_COLOR_GREEN:
#line 822 "window.c"
		{
			gchar* _tmp2_;
#line 208 "../src/window.vala"
			_tmp2_ = g_strdup ("green");
#line 208 "../src/window.vala"
			_g_free0 (css_color);
#line 208 "../src/window.vala"
			css_color = _tmp2_;
#line 209 "../src/window.vala"
			break;
#line 833 "window.c"
		}
#line 199 "../src/window.vala"
		case ADW_ACCENT_COLOR_YELLOW:
#line 837 "window.c"
		{
			gchar* _tmp3_;
#line 211 "../src/window.vala"
			_tmp3_ = g_strdup ("yellow");
#line 211 "../src/window.vala"
			_g_free0 (css_color);
#line 211 "../src/window.vala"
			css_color = _tmp3_;
#line 212 "../src/window.vala"
			break;
#line 848 "window.c"
		}
#line 199 "../src/window.vala"
		case ADW_ACCENT_COLOR_ORANGE:
#line 852 "window.c"
		{
			gchar* _tmp4_;
#line 214 "../src/window.vala"
			_tmp4_ = g_strdup ("orange");
#line 214 "../src/window.vala"
			_g_free0 (css_color);
#line 214 "../src/window.vala"
			css_color = _tmp4_;
#line 215 "../src/window.vala"
			break;
#line 863 "window.c"
		}
#line 199 "../src/window.vala"
		case ADW_ACCENT_COLOR_RED:
#line 867 "window.c"
		{
			gchar* _tmp5_;
#line 217 "../src/window.vala"
			_tmp5_ = g_strdup ("red");
#line 217 "../src/window.vala"
			_g_free0 (css_color);
#line 217 "../src/window.vala"
			css_color = _tmp5_;
#line 218 "../src/window.vala"
			break;
#line 878 "window.c"
		}
#line 199 "../src/window.vala"
		case ADW_ACCENT_COLOR_PINK:
#line 882 "window.c"
		{
			gchar* _tmp6_;
#line 220 "../src/window.vala"
			_tmp6_ = g_strdup ("pink");
#line 220 "../src/window.vala"
			_g_free0 (css_color);
#line 220 "../src/window.vala"
			css_color = _tmp6_;
#line 221 "../src/window.vala"
			break;
#line 893 "window.c"
		}
#line 199 "../src/window.vala"
		case ADW_ACCENT_COLOR_PURPLE:
#line 897 "window.c"
		{
			gchar* _tmp7_;
#line 223 "../src/window.vala"
			_tmp7_ = g_strdup ("purple");
#line 223 "../src/window.vala"
			_g_free0 (css_color);
#line 223 "../src/window.vala"
			css_color = _tmp7_;
#line 224 "../src/window.vala"
			break;
#line 908 "window.c"
		}
#line 199 "../src/window.vala"
		case ADW_ACCENT_COLOR_SLATE:
#line 912 "window.c"
		{
			gchar* _tmp8_;
#line 226 "../src/window.vala"
			_tmp8_ = g_strdup ("slate");
#line 226 "../src/window.vala"
			_g_free0 (css_color);
#line 226 "../src/window.vala"
			css_color = _tmp8_;
#line 227 "../src/window.vala"
			break;
#line 923 "window.c"
		}
		default:
		{
			gchar* _tmp9_;
#line 229 "../src/window.vala"
			_tmp9_ = g_strdup ("blue");
#line 229 "../src/window.vala"
			_g_free0 (css_color);
#line 229 "../src/window.vala"
			css_color = _tmp9_;
#line 230 "../src/window.vala"
			break;
#line 936 "window.c"
		}
	}
#line 232 "../src/window.vala"
	_tmp10_ = css_color;
#line 232 "../src/window.vala"
	_tmp11_ = g_strconcat (":root {--sudoku-accent-color: var(--sudoku-accent-", _tmp10_, NULL);
#line 232 "../src/window.vala"
	_tmp12_ = _tmp11_;
#line 232 "../src/window.vala"
	_tmp13_ = g_strconcat (_tmp12_, ");}", NULL);
#line 232 "../src/window.vala"
	_tmp14_ = _tmp13_;
#line 232 "../src/window.vala"
	_g_free0 (_tmp12_);
#line 232 "../src/window.vala"
	s = _tmp14_;
#line 233 "../src/window.vala"
	_tmp15_ = self->priv->accent_provider;
#line 233 "../src/window.vala"
	gtk_css_provider_load_from_string (_tmp15_, s);
#line 196 "../src/window.vala"
	_g_free0 (s);
#line 196 "../src/window.vala"
	_g_free0 (css_color);
#line 961 "window.c"
}

static gboolean
sudoku_window_close_cb (SudokuWindow* self)
{
	GSettings* _tmp0_;
	gint default_width = 0;
	gint default_height = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	GSettings* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GSettings* _tmp11_;
	gboolean result;
#line 236 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 239 "../src/window.vala"
	_tmp0_ = self->priv->_settings;
#line 239 "../src/window.vala"
	g_settings_delay (_tmp0_);
#line 242 "../src/window.vala"
	gtk_window_get_default_size ((GtkWindow*) self, &_tmp1_, &_tmp2_);
#line 242 "../src/window.vala"
	default_width = _tmp1_;
#line 242 "../src/window.vala"
	default_height = _tmp2_;
#line 243 "../src/window.vala"
	_tmp3_ = self->priv->_settings;
#line 243 "../src/window.vala"
	g_settings_set_int (_tmp3_, "window-width", default_width);
#line 244 "../src/window.vala"
	_tmp4_ = self->priv->_settings;
#line 244 "../src/window.vala"
	g_settings_set_int (_tmp4_, "window-height", default_height);
#line 245 "../src/window.vala"
	_tmp5_ = self->priv->_settings;
#line 245 "../src/window.vala"
	g_object_get ((GtkWindow*) self, "maximized", &_tmp6_, NULL);
#line 245 "../src/window.vala"
	_tmp7_ = _tmp6_;
#line 245 "../src/window.vala"
	g_settings_set_boolean (_tmp5_, "window-is-maximized", _tmp7_);
#line 246 "../src/window.vala"
	_tmp8_ = self->priv->_settings;
#line 246 "../src/window.vala"
	g_object_get ((GtkWindow*) self, "fullscreened", &_tmp9_, NULL);
#line 246 "../src/window.vala"
	_tmp10_ = _tmp9_;
#line 246 "../src/window.vala"
	g_settings_set_boolean (_tmp8_, "window-is-fullscreen", _tmp10_);
#line 247 "../src/window.vala"
	_tmp11_ = self->priv->_settings;
#line 247 "../src/window.vala"
	g_settings_apply (_tmp11_);
#line 248 "../src/window.vala"
	result = GDK_EVENT_PROPAGATE;
#line 248 "../src/window.vala"
	return result;
#line 1026 "window.c"
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 255 "../src/window.vala"
	dup = g_new0 (gboolean, 1);
#line 255 "../src/window.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 255 "../src/window.vala"
	return dup;
#line 1039 "window.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 255 "../src/window.vala"
	return self ? _bool_dup (self) : NULL;
#line 1047 "window.c"
}

static void
sudoku_window_start_game_cb (SudokuWindow* self,
                             GtkButton* btn)
{
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 252 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/window.vala"
	g_return_if_fail (btn != NULL);
#line 254 "../src/window.vala"
	_tmp0_ = self->priv->easy_check;
#line 254 "../src/window.vala"
	_tmp1_ = gtk_check_button_get_active (_tmp0_);
#line 254 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 254 "../src/window.vala"
	if (_tmp2_) {
#line 1069 "window.c"
		GtkWidget* _tmp3_ = NULL;
		gboolean* _tmp4_ = NULL;
#line 255 "../src/window.vala"
		_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 255 "../src/window.vala"
		_tmp4_ = NULL;
#line 255 "../src/window.vala"
		if (_tmp3_ != NULL) {
#line 1078 "window.c"
			gboolean _tmp5_;
			gboolean* _tmp6_;
#line 255 "../src/window.vala"
			_tmp5_ = gtk_widget_activate_action (_tmp3_, "app.start-game", "i", 1, NULL);
#line 255 "../src/window.vala"
			_tmp6_ = __bool_dup0 (&_tmp5_);
#line 255 "../src/window.vala"
			_g_free0 (_tmp4_);
#line 255 "../src/window.vala"
			_tmp4_ = _tmp6_;
#line 1089 "window.c"
		}
#line 254 "../src/window.vala"
		_g_free0 (_tmp4_);
#line 1093 "window.c"
	} else {
		GtkCheckButton* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 256 "../src/window.vala"
		_tmp7_ = self->priv->medium_check;
#line 256 "../src/window.vala"
		_tmp8_ = gtk_check_button_get_active (_tmp7_);
#line 256 "../src/window.vala"
		_tmp9_ = _tmp8_;
#line 256 "../src/window.vala"
		if (_tmp9_) {
#line 1106 "window.c"
			GtkWidget* _tmp10_ = NULL;
			gboolean* _tmp11_ = NULL;
#line 257 "../src/window.vala"
			_tmp10_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 257 "../src/window.vala"
			_tmp11_ = NULL;
#line 257 "../src/window.vala"
			if (_tmp10_ != NULL) {
#line 1115 "window.c"
				gboolean _tmp12_;
				gboolean* _tmp13_;
#line 257 "../src/window.vala"
				_tmp12_ = gtk_widget_activate_action (_tmp10_, "app.start-game", "i", 2, NULL);
#line 257 "../src/window.vala"
				_tmp13_ = __bool_dup0 (&_tmp12_);
#line 257 "../src/window.vala"
				_g_free0 (_tmp11_);
#line 257 "../src/window.vala"
				_tmp11_ = _tmp13_;
#line 1126 "window.c"
			}
#line 256 "../src/window.vala"
			_g_free0 (_tmp11_);
#line 1130 "window.c"
		} else {
			GtkCheckButton* _tmp14_;
			gboolean _tmp15_;
			gboolean _tmp16_;
#line 258 "../src/window.vala"
			_tmp14_ = self->priv->hard_check;
#line 258 "../src/window.vala"
			_tmp15_ = gtk_check_button_get_active (_tmp14_);
#line 258 "../src/window.vala"
			_tmp16_ = _tmp15_;
#line 258 "../src/window.vala"
			if (_tmp16_) {
#line 1143 "window.c"
				GtkWidget* _tmp17_ = NULL;
				gboolean* _tmp18_ = NULL;
#line 259 "../src/window.vala"
				_tmp17_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 259 "../src/window.vala"
				_tmp18_ = NULL;
#line 259 "../src/window.vala"
				if (_tmp17_ != NULL) {
#line 1152 "window.c"
					gboolean _tmp19_;
					gboolean* _tmp20_;
#line 259 "../src/window.vala"
					_tmp19_ = gtk_widget_activate_action (_tmp17_, "app.start-game", "i", 3, NULL);
#line 259 "../src/window.vala"
					_tmp20_ = __bool_dup0 (&_tmp19_);
#line 259 "../src/window.vala"
					_g_free0 (_tmp18_);
#line 259 "../src/window.vala"
					_tmp18_ = _tmp20_;
#line 1163 "window.c"
				}
#line 258 "../src/window.vala"
				_g_free0 (_tmp18_);
#line 1167 "window.c"
			} else {
				GtkCheckButton* _tmp21_;
				gboolean _tmp22_;
				gboolean _tmp23_;
#line 260 "../src/window.vala"
				_tmp21_ = self->priv->very_hard_check;
#line 260 "../src/window.vala"
				_tmp22_ = gtk_check_button_get_active (_tmp21_);
#line 260 "../src/window.vala"
				_tmp23_ = _tmp22_;
#line 260 "../src/window.vala"
				if (_tmp23_) {
#line 1180 "window.c"
					GtkWidget* _tmp24_ = NULL;
					gboolean* _tmp25_ = NULL;
#line 261 "../src/window.vala"
					_tmp24_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 261 "../src/window.vala"
					_tmp25_ = NULL;
#line 261 "../src/window.vala"
					if (_tmp24_ != NULL) {
#line 1189 "window.c"
						gboolean _tmp26_;
						gboolean* _tmp27_;
#line 261 "../src/window.vala"
						_tmp26_ = gtk_widget_activate_action (_tmp24_, "app.start-game", "i", 4, NULL);
#line 261 "../src/window.vala"
						_tmp27_ = __bool_dup0 (&_tmp26_);
#line 261 "../src/window.vala"
						_g_free0 (_tmp25_);
#line 261 "../src/window.vala"
						_tmp25_ = _tmp27_;
#line 1200 "window.c"
					}
#line 260 "../src/window.vala"
					_g_free0 (_tmp25_);
#line 1204 "window.c"
				} else {
					GtkCheckButton* _tmp28_;
					gboolean _tmp29_;
					gboolean _tmp30_;
#line 262 "../src/window.vala"
					_tmp28_ = self->priv->custom_check;
#line 262 "../src/window.vala"
					_tmp29_ = gtk_check_button_get_active (_tmp28_);
#line 262 "../src/window.vala"
					_tmp30_ = _tmp29_;
#line 262 "../src/window.vala"
					if (_tmp30_) {
#line 1217 "window.c"
						GtkWidget* _tmp31_ = NULL;
						gboolean* _tmp32_ = NULL;
#line 263 "../src/window.vala"
						_tmp31_ = G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL;
#line 263 "../src/window.vala"
						_tmp32_ = NULL;
#line 263 "../src/window.vala"
						if (_tmp31_ != NULL) {
#line 1226 "window.c"
							gboolean _tmp33_;
							gboolean* _tmp34_;
#line 263 "../src/window.vala"
							_tmp33_ = gtk_widget_activate_action (_tmp31_, "app.start-game", "i", 5, NULL);
#line 263 "../src/window.vala"
							_tmp34_ = __bool_dup0 (&_tmp33_);
#line 263 "../src/window.vala"
							_g_free0 (_tmp32_);
#line 263 "../src/window.vala"
							_tmp32_ = _tmp34_;
#line 1237 "window.c"
						}
#line 262 "../src/window.vala"
						_g_free0 (_tmp32_);
#line 1241 "window.c"
					}
				}
			}
		}
	}
}

static void
_sudoku_window_start_game_cb_gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 26 "../src/window.vala"
	sudoku_window_start_game_cb ((SudokuWindow*) self, _sender);
#line 1255 "window.c"
}

static void
sudoku_window_window_width_is_medium_cb (SudokuWindow* self)
{
	SudokuWindowScreen _tmp0_;
#line 266 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 268 "../src/window.vala"
	sudoku_window_set_window_width_is_small (self, FALSE);
#line 269 "../src/window.vala"
	_tmp0_ = self->priv->_current_screen;
#line 269 "../src/window.vala"
	if (_tmp0_ == SUDOKU_WINDOW_SCREEN_PLAY) {
#line 1270 "window.c"
		GtkBox* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
		GtkToggleButton* _tmp4_;
#line 271 "../src/window.vala"
		_tmp1_ = self->priv->clock_box;
#line 271 "../src/window.vala"
		_tmp2_ = sudoku_window_get_show_timer (self);
#line 271 "../src/window.vala"
		_tmp3_ = _tmp2_;
#line 271 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, _tmp3_);
#line 272 "../src/window.vala"
		_tmp4_ = self->priv->earmark_mode_button;
#line 272 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
#line 1287 "window.c"
	}
}

static void
sudoku_window_window_width_is_small_cb (SudokuWindow* self)
{
	GtkBox* _tmp0_;
	SudokuWindowScreen _tmp1_;
#line 276 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/window.vala"
	sudoku_window_set_window_width_is_small (self, TRUE);
#line 279 "../src/window.vala"
	_tmp0_ = self->priv->clock_box;
#line 279 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 280 "../src/window.vala"
	_tmp1_ = self->priv->_current_screen;
#line 280 "../src/window.vala"
	if (_tmp1_ == SUDOKU_WINDOW_SCREEN_PLAY) {
#line 1308 "window.c"
		GtkToggleButton* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 281 "../src/window.vala"
		_tmp2_ = self->priv->earmark_mode_button;
#line 281 "../src/window.vala"
		_tmp3_ = sudoku_window_get_show_timer (self);
#line 281 "../src/window.vala"
		_tmp4_ = _tmp3_;
#line 281 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, !_tmp4_);
#line 1320 "window.c"
	}
}

void
sudoku_window_will_start_game (SudokuWindow* self)
{
	GtkButton* _tmp0_;
#line 312 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 314 "../src/window.vala"
	_tmp0_ = self->priv->back_button;
#line 314 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 1334 "window.c"
}

static void
_sudoku_window_tick_cb_sudoku_game_tick (SudokuGame* _sender,
                                         gpointer self)
{
#line 320 "../src/window.vala"
	sudoku_window_tick_cb ((SudokuWindow*) self);
#line 1343 "window.c"
}

static void
_sudoku_window_paused_cb_g_object_notify (GObject* _sender,
                                          GParamSpec* pspec,
                                          gpointer self)
{
#line 321 "../src/window.vala"
	sudoku_window_paused_cb ((SudokuWindow*) self);
#line 1353 "window.c"
}

void
sudoku_window_start_game (SudokuWindow* self,
                          SudokuGame* game)
{
	SudokuGame* _tmp0_;
	SudokuView* _tmp1_;
	GSettings* _tmp4_;
	SudokuView* _tmp5_;
	SudokuView* _tmp6_;
	GtkBox* _tmp7_;
	SudokuView* _tmp8_;
	SudokuView* _tmp9_;
	GtkButton* _tmp10_;
#line 317 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 317 "../src/window.vala"
	g_return_if_fail (game != NULL);
#line 319 "../src/window.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 319 "../src/window.vala"
	_g_object_unref0 (self->priv->game);
#line 319 "../src/window.vala"
	self->priv->game = _tmp0_;
#line 320 "../src/window.vala"
	g_signal_connect_object (game, "tick", (GCallback) _sudoku_window_tick_cb_sudoku_game_tick, self, 0);
#line 321 "../src/window.vala"
	g_signal_connect_object ((GObject*) game, "notify::paused", (GCallback) _sudoku_window_paused_cb_g_object_notify, self, 0);
#line 323 "../src/window.vala"
	_tmp1_ = self->priv->_view;
#line 323 "../src/window.vala"
	if (_tmp1_ != NULL) {
#line 1387 "window.c"
		GtkBox* _tmp2_;
		SudokuView* _tmp3_;
#line 324 "../src/window.vala"
		_tmp2_ = self->priv->game_box;
#line 324 "../src/window.vala"
		_tmp3_ = self->priv->_view;
#line 324 "../src/window.vala"
		gtk_box_remove (_tmp2_, (GtkWidget*) _tmp3_);
#line 1396 "window.c"
	}
#line 326 "../src/window.vala"
	sudoku_window_show_game_view (self);
#line 328 "../src/window.vala"
	_tmp4_ = self->priv->_settings;
#line 328 "../src/window.vala"
	_tmp5_ = sudoku_view_new (game, _tmp4_);
#line 328 "../src/window.vala"
	g_object_ref_sink (_tmp5_);
#line 328 "../src/window.vala"
	_tmp6_ = _tmp5_;
#line 328 "../src/window.vala"
	sudoku_window_set_view (self, _tmp6_);
#line 328 "../src/window.vala"
	_g_object_unref0 (_tmp6_);
#line 330 "../src/window.vala"
	_tmp7_ = self->priv->game_box;
#line 330 "../src/window.vala"
	_tmp8_ = self->priv->_view;
#line 330 "../src/window.vala"
	gtk_box_prepend (_tmp7_, (GtkWidget*) _tmp8_);
#line 331 "../src/window.vala"
	_tmp9_ = self->priv->_view;
#line 331 "../src/window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
#line 332 "../src/window.vala"
	sudoku_game_start_clock (game);
#line 334 "../src/window.vala"
	_tmp10_ = self->priv->back_button;
#line 334 "../src/window.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, TRUE);
#line 1428 "window.c"
}

void
sudoku_window_show_menu_screen (SudokuWindow* self)
{
	AdwWindowTitle* _tmp0_;
	GtkButton* _tmp1_;
	SudokuGame* _tmp2_;
	GtkToggleButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkBox* _tmp6_;
	GtkStack* _tmp7_;
	GtkButton* _tmp8_;
#line 337 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/window.vala"
	sudoku_window_set_current_screen (self, SUDOKU_WINDOW_SCREEN_MENU);
#line 340 "../src/window.vala"
	_tmp0_ = self->priv->windowtitle;
#line 340 "../src/window.vala"
	adw_window_title_set_subtitle (_tmp0_, _ ("Select Difficulty"));
#line 341 "../src/window.vala"
	sudoku_window_set_board_visible (self, FALSE);
#line 342 "../src/window.vala"
	_tmp1_ = self->priv->back_button;
#line 342 "../src/window.vala"
	_tmp2_ = self->priv->game;
#line 342 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, _tmp2_ != NULL);
#line 343 "../src/window.vala"
	_tmp3_ = self->priv->earmark_mode_button;
#line 343 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 344 "../src/window.vala"
	_tmp4_ = self->priv->undo_button;
#line 344 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
#line 345 "../src/window.vala"
	_tmp5_ = self->priv->redo_button;
#line 345 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 346 "../src/window.vala"
	_tmp6_ = self->priv->clock_box;
#line 346 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, FALSE);
#line 347 "../src/window.vala"
	_tmp7_ = self->priv->play_pause_stack;
#line 347 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
#line 348 "../src/window.vala"
	_tmp8_ = self->priv->start_button;
#line 348 "../src/window.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp8_);
#line 1483 "window.c"
}

void
sudoku_window_activate_difficulty_checkbutton (SudokuWindow* self,
                                               DifficultyCategory difficulty)
{
#line 351 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 353 "../src/window.vala"
	switch (difficulty) {
#line 353 "../src/window.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 1496 "window.c"
		{
			GtkCheckButton* _tmp0_;
#line 356 "../src/window.vala"
			_tmp0_ = self->priv->easy_check;
#line 356 "../src/window.vala"
			g_signal_emit_by_name (_tmp0_, "activate");
#line 357 "../src/window.vala"
			return;
#line 1505 "window.c"
		}
#line 353 "../src/window.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 1509 "window.c"
		{
			GtkCheckButton* _tmp1_;
#line 359 "../src/window.vala"
			_tmp1_ = self->priv->medium_check;
#line 359 "../src/window.vala"
			g_signal_emit_by_name (_tmp1_, "activate");
#line 360 "../src/window.vala"
			return;
#line 1518 "window.c"
		}
#line 353 "../src/window.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 1522 "window.c"
		{
			GtkCheckButton* _tmp2_;
#line 362 "../src/window.vala"
			_tmp2_ = self->priv->hard_check;
#line 362 "../src/window.vala"
			g_signal_emit_by_name (_tmp2_, "activate");
#line 363 "../src/window.vala"
			return;
#line 1531 "window.c"
		}
#line 353 "../src/window.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 1535 "window.c"
		{
			GtkCheckButton* _tmp3_;
#line 365 "../src/window.vala"
			_tmp3_ = self->priv->very_hard_check;
#line 365 "../src/window.vala"
			g_signal_emit_by_name (_tmp3_, "activate");
#line 366 "../src/window.vala"
			return;
#line 1544 "window.c"
		}
#line 353 "../src/window.vala"
		case DIFFICULTY_CATEGORY_CUSTOM:
#line 1548 "window.c"
		{
			GtkCheckButton* _tmp4_;
#line 368 "../src/window.vala"
			_tmp4_ = self->priv->custom_check;
#line 368 "../src/window.vala"
			g_signal_emit_by_name (_tmp4_, "activate");
#line 369 "../src/window.vala"
			return;
#line 1557 "window.c"
		}
		default:
		{
#line 371 "../src/window.vala"
			g_assert_not_reached ();
#line 1563 "window.c"
		}
	}
}

void
sudoku_window_set_board_visible (SudokuWindow* self,
                                 gboolean visible)
{
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkButton* _tmp6_;
#line 375 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 377 "../src/window.vala"
	_tmp0_ = self->priv->start_box;
#line 377 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, !visible);
#line 378 "../src/window.vala"
	_tmp1_ = self->priv->game_box;
#line 378 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, visible);
#line 379 "../src/window.vala"
	if (visible) {
#line 1588 "window.c"
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
#line 379 "../src/window.vala"
		_tmp3_ = self->priv->game;
#line 379 "../src/window.vala"
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
#line 379 "../src/window.vala"
		_tmp5_ = _tmp4_;
#line 379 "../src/window.vala"
		_tmp2_ = _tmp5_ == GAME_MODE_CREATE;
#line 1600 "window.c"
	} else {
#line 379 "../src/window.vala"
		_tmp2_ = FALSE;
#line 1604 "window.c"
	}
#line 379 "../src/window.vala"
	_tmp6_ = self->priv->play_custom_game_button;
#line 379 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, _tmp2_);
#line 1610 "window.c"
}

gboolean
sudoku_window_is_board_visible (SudokuWindow* self)
{
	GtkBox* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 382 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 384 "../src/window.vala"
	_tmp0_ = self->priv->game_box;
#line 384 "../src/window.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 384 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 384 "../src/window.vala"
	result = _tmp2_;
#line 384 "../src/window.vala"
	return result;
#line 1632 "window.c"
}

void
sudoku_window_show_game_view (SudokuWindow* self)
{
	SudokuGame* _tmp0_;
	SudokuGame* _tmp1_;
	GameMode _tmp2_;
	GameMode _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	SudokuGame* _tmp7_;
	GameMode _tmp8_;
	GameMode _tmp9_;
#line 387 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 387 "../src/window.vala"
	_tmp0_ = self->priv->game;
#line 387 "../src/window.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "game != null");
#line 390 "../src/window.vala"
	_tmp1_ = self->priv->game;
#line 390 "../src/window.vala"
	_tmp2_ = sudoku_game_get_mode (_tmp1_);
#line 390 "../src/window.vala"
	_tmp3_ = _tmp2_;
#line 390 "../src/window.vala"
	sudoku_window_set_current_screen (self, (SudokuWindowScreen) _tmp3_);
#line 391 "../src/window.vala"
	sudoku_window_set_board_visible (self, TRUE);
#line 392 "../src/window.vala"
	_tmp4_ = self->priv->back_button;
#line 392 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
#line 393 "../src/window.vala"
	_tmp5_ = self->priv->undo_button;
#line 393 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
#line 394 "../src/window.vala"
	_tmp6_ = self->priv->redo_button;
#line 394 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
#line 396 "../src/window.vala"
	_tmp7_ = self->priv->game;
#line 396 "../src/window.vala"
	_tmp8_ = sudoku_game_get_mode (_tmp7_);
#line 396 "../src/window.vala"
	_tmp9_ = _tmp8_;
#line 396 "../src/window.vala"
	if (_tmp9_ == GAME_MODE_PLAY) {
#line 1684 "window.c"
		GtkButton* _tmp10_;
		GtkStack* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_;
		gboolean _tmp16_;
		GtkBox* _tmp18_;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_;
		GtkToggleButton* _tmp23_;
		AdwWindowTitle* _tmp24_;
		SudokuGame* _tmp25_;
		SudokuBoard* _tmp26_;
		SudokuBoard* _tmp27_;
		DifficultyCategory _tmp28_;
		DifficultyCategory _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
#line 398 "../src/window.vala"
		_tmp10_ = self->priv->play_custom_game_button;
#line 398 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp10_, FALSE);
#line 399 "../src/window.vala"
		_tmp11_ = self->priv->play_pause_stack;
#line 399 "../src/window.vala"
		_tmp12_ = sudoku_window_get_show_timer (self);
#line 399 "../src/window.vala"
		_tmp13_ = _tmp12_;
#line 399 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp11_, _tmp13_);
#line 400 "../src/window.vala"
		_tmp15_ = sudoku_window_get_show_timer (self);
#line 400 "../src/window.vala"
		_tmp16_ = _tmp15_;
#line 400 "../src/window.vala"
		if (_tmp16_) {
#line 1722 "window.c"
			gboolean _tmp17_;
#line 400 "../src/window.vala"
			_tmp17_ = self->priv->_window_width_is_small;
#line 400 "../src/window.vala"
			_tmp14_ = !_tmp17_;
#line 1728 "window.c"
		} else {
#line 400 "../src/window.vala"
			_tmp14_ = FALSE;
#line 1732 "window.c"
		}
#line 400 "../src/window.vala"
		_tmp18_ = self->priv->clock_box;
#line 400 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp18_, _tmp14_);
#line 401 "../src/window.vala"
		_tmp20_ = self->priv->_window_width_is_small;
#line 401 "../src/window.vala"
		if (!_tmp20_) {
#line 401 "../src/window.vala"
			_tmp19_ = TRUE;
#line 1744 "window.c"
		} else {
			gboolean _tmp21_;
			gboolean _tmp22_;
#line 401 "../src/window.vala"
			_tmp21_ = sudoku_window_get_show_timer (self);
#line 401 "../src/window.vala"
			_tmp22_ = _tmp21_;
#line 401 "../src/window.vala"
			_tmp19_ = !_tmp22_;
#line 1754 "window.c"
		}
#line 401 "../src/window.vala"
		_tmp23_ = self->priv->earmark_mode_button;
#line 401 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp23_, _tmp19_);
#line 402 "../src/window.vala"
		_tmp24_ = self->priv->windowtitle;
#line 402 "../src/window.vala"
		_tmp25_ = self->priv->game;
#line 402 "../src/window.vala"
		_tmp26_ = sudoku_game_get_board (_tmp25_);
#line 402 "../src/window.vala"
		_tmp27_ = _tmp26_;
#line 402 "../src/window.vala"
		_tmp28_ = sudoku_board_get_difficulty_category (_tmp27_);
#line 402 "../src/window.vala"
		_tmp29_ = _tmp28_;
#line 402 "../src/window.vala"
		_tmp30_ = difficulty_category_to_string (_tmp29_);
#line 402 "../src/window.vala"
		_tmp31_ = _tmp30_;
#line 402 "../src/window.vala"
		adw_window_title_set_subtitle (_tmp24_, _tmp31_);
#line 402 "../src/window.vala"
		_g_free0 (_tmp31_);
#line 1780 "window.c"
	} else {
		GtkToggleButton* _tmp32_;
		GtkBox* _tmp33_;
		GtkButton* _tmp34_;
		GtkStack* _tmp35_;
		AdwWindowTitle* _tmp36_;
#line 406 "../src/window.vala"
		_tmp32_ = self->priv->earmark_mode_button;
#line 406 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp32_, FALSE);
#line 407 "../src/window.vala"
		_tmp33_ = self->priv->clock_box;
#line 407 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp33_, FALSE);
#line 408 "../src/window.vala"
		_tmp34_ = self->priv->play_custom_game_button;
#line 408 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp34_, TRUE);
#line 409 "../src/window.vala"
		_tmp35_ = self->priv->play_pause_stack;
#line 409 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp35_, FALSE);
#line 410 "../src/window.vala"
		_tmp36_ = self->priv->windowtitle;
#line 410 "../src/window.vala"
		adw_window_title_set_subtitle (_tmp36_, _ ("Create Puzzle"));
#line 1807 "window.c"
	}
}

void
sudoku_window_board_completed (SudokuWindow* self)
{
	GtkButton* _tmp0_;
#line 414 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 416 "../src/window.vala"
	_tmp0_ = self->priv->play_custom_game_button;
#line 416 "../src/window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 1821 "window.c"
}

static void
sudoku_window_visible_dialog_cb (SudokuWindow* self)
{
	SudokuWindowScreen _tmp0_;
	AdwDialog* _tmp1_;
	AdwDialog* _tmp2_;
#line 419 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 421 "../src/window.vala"
	_tmp0_ = self->priv->_current_screen;
#line 421 "../src/window.vala"
	if (_tmp0_ == SUDOKU_WINDOW_SCREEN_MENU) {
#line 422 "../src/window.vala"
		return;
#line 1838 "window.c"
	}
#line 424 "../src/window.vala"
	_tmp1_ = adw_application_window_get_visible_dialog ((AdwApplicationWindow*) self);
#line 424 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 424 "../src/window.vala"
	if (_tmp2_ != NULL) {
#line 1846 "window.c"
		SudokuGame* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		SudokuView* _tmp7_;
#line 426 "../src/window.vala"
		_tmp3_ = self->priv->game;
#line 426 "../src/window.vala"
		_tmp4_ = sudoku_game_get_paused (_tmp3_);
#line 426 "../src/window.vala"
		_tmp5_ = _tmp4_;
#line 426 "../src/window.vala"
		if (!_tmp5_) {
#line 1859 "window.c"
			SudokuGame* _tmp6_;
#line 427 "../src/window.vala"
			_tmp6_ = self->priv->game;
#line 427 "../src/window.vala"
			sudoku_game_stop_clock (_tmp6_);
#line 1865 "window.c"
		}
#line 429 "../src/window.vala"
		_tmp7_ = self->priv->_view;
#line 429 "../src/window.vala"
		sudoku_view_set_has_selection (_tmp7_, FALSE);
#line 1871 "window.c"
	} else {
		SudokuGame* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		SudokuView* _tmp12_;
#line 433 "../src/window.vala"
		_tmp8_ = self->priv->game;
#line 433 "../src/window.vala"
		_tmp9_ = sudoku_game_get_paused (_tmp8_);
#line 433 "../src/window.vala"
		_tmp10_ = _tmp9_;
#line 433 "../src/window.vala"
		if (!_tmp10_) {
#line 1885 "window.c"
			SudokuGame* _tmp11_;
#line 434 "../src/window.vala"
			_tmp11_ = self->priv->game;
#line 434 "../src/window.vala"
			sudoku_game_resume_clock (_tmp11_);
#line 1891 "window.c"
		}
#line 436 "../src/window.vala"
		_tmp12_ = self->priv->_view;
#line 436 "../src/window.vala"
		sudoku_view_set_has_selection (_tmp12_, TRUE);
#line 1897 "window.c"
	}
}

static void
sudoku_window_tick_cb (SudokuWindow* self)
{
	gint elapsed_time = 0;
	SudokuGame* _tmp0_;
	gint hours = 0;
	gint minutes = 0;
	gint seconds = 0;
#line 440 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 442 "../src/window.vala"
	_tmp0_ = self->priv->game;
#line 442 "../src/window.vala"
	elapsed_time = (gint) sudoku_game_get_total_time_played (_tmp0_);
#line 443 "../src/window.vala"
	hours = elapsed_time / 3600;
#line 444 "../src/window.vala"
	minutes = (elapsed_time - (hours * 3600)) / 60;
#line 445 "../src/window.vala"
	seconds = (elapsed_time - (hours * 3600)) - (minutes * 60);
#line 446 "../src/window.vala"
	if (hours > 0) {
#line 1923 "window.c"
		GtkLabel* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 447 "../src/window.vala"
		_tmp1_ = self->priv->clock_label;
#line 447 "../src/window.vala"
		_tmp2_ = g_strdup_printf ("%02d∶\xE2\x80\x8E%02d∶\xE2\x80\x8E%02d", hours, minutes, seconds);
#line 447 "../src/window.vala"
		_tmp3_ = _tmp2_;
#line 447 "../src/window.vala"
		gtk_label_set_text (_tmp1_, _tmp3_);
#line 447 "../src/window.vala"
		_g_free0 (_tmp3_);
#line 1937 "window.c"
	} else {
		GtkLabel* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 449 "../src/window.vala"
		_tmp4_ = self->priv->clock_label;
#line 449 "../src/window.vala"
		_tmp5_ = g_strdup_printf ("%02d∶\xE2\x80\x8E%02d", minutes, seconds);
#line 449 "../src/window.vala"
		_tmp6_ = _tmp5_;
#line 449 "../src/window.vala"
		gtk_label_set_text (_tmp4_, _tmp6_);
#line 449 "../src/window.vala"
		_g_free0 (_tmp6_);
#line 1952 "window.c"
	}
}

static void
sudoku_window_paused_cb (SudokuWindow* self)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 452 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 454 "../src/window.vala"
	_tmp0_ = self->priv->game;
#line 454 "../src/window.vala"
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
#line 454 "../src/window.vala"
	_tmp2_ = _tmp1_;
#line 454 "../src/window.vala"
	if (_tmp2_) {
#line 1972 "window.c"
		GtkStack* _tmp3_;
		GtkButton* _tmp4_;
#line 455 "../src/window.vala"
		_tmp3_ = self->priv->play_pause_stack;
#line 455 "../src/window.vala"
		_tmp4_ = self->priv->play_button;
#line 455 "../src/window.vala"
		gtk_stack_set_visible_child (_tmp3_, (GtkWidget*) _tmp4_);
#line 1981 "window.c"
	} else {
		GtkStack* _tmp5_;
		GtkButton* _tmp6_;
#line 457 "../src/window.vala"
		_tmp5_ = self->priv->play_pause_stack;
#line 457 "../src/window.vala"
		_tmp6_ = self->priv->pause_button;
#line 457 "../src/window.vala"
		gtk_stack_set_visible_child (_tmp5_, (GtkWidget*) _tmp6_);
#line 1991 "window.c"
	}
}

static void
sudoku_window_button_released_cb (SudokuWindow* self,
                                  GtkGestureClick* gesture,
                                  gint n_press,
                                  gdouble x,
                                  gdouble y)
{
	gboolean _tmp0_ = FALSE;
	SudokuWindowScreen _tmp1_;
#line 460 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 460 "../src/window.vala"
	g_return_if_fail (gesture != NULL);
#line 465 "../src/window.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 466 "../src/window.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
#line 2012 "window.c"
	} else {
#line 465 "../src/window.vala"
		_tmp0_ = FALSE;
#line 2016 "window.c"
	}
#line 465 "../src/window.vala"
	if (_tmp0_) {
#line 467 "../src/window.vala"
		return;
#line 2022 "window.c"
	}
#line 469 "../src/window.vala"
	_tmp1_ = self->priv->_current_screen;
#line 469 "../src/window.vala"
	if (_tmp1_ != SUDOKU_WINDOW_SCREEN_MENU) {
#line 2028 "window.c"
		SudokuView* _tmp2_;
#line 470 "../src/window.vala"
		_tmp2_ = self->priv->_view;
#line 470 "../src/window.vala"
		sudoku_view_dismiss_picker (_tmp2_);
#line 2034 "window.c"
	}
#line 472 "../src/window.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 2038 "window.c"
}

static void
sudoku_window_fullscreen_cb (SudokuWindow* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 475 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 477 "../src/window.vala"
	g_object_get ((GtkWindow*) self, "fullscreened", &_tmp0_, NULL);
#line 477 "../src/window.vala"
	_tmp1_ = _tmp0_;
#line 477 "../src/window.vala"
	if (_tmp1_) {
#line 2054 "window.c"
		AdwHeaderBar* _tmp2_;
		GtkButton* _tmp3_;
		GtkStack* _tmp4_;
		GtkButton* _tmp5_;
#line 479 "../src/window.vala"
		_tmp2_ = self->priv->headerbar;
#line 479 "../src/window.vala"
		adw_header_bar_set_decoration_layout (_tmp2_, ":close");
#line 480 "../src/window.vala"
		_tmp3_ = self->priv->unfullscreen_button;
#line 480 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp3_, TRUE);
#line 481 "../src/window.vala"
		_tmp4_ = self->priv->menu_fullscreen_stack;
#line 481 "../src/window.vala"
		_tmp5_ = self->priv->menu_unfullscreen_button;
#line 481 "../src/window.vala"
		gtk_stack_set_visible_child (_tmp4_, (GtkWidget*) _tmp5_);
#line 2073 "window.c"
	} else {
		AdwHeaderBar* _tmp6_;
		GtkButton* _tmp7_;
		GtkStack* _tmp8_;
		GtkButton* _tmp9_;
#line 485 "../src/window.vala"
		_tmp6_ = self->priv->headerbar;
#line 485 "../src/window.vala"
		adw_header_bar_set_decoration_layout (_tmp6_, NULL);
#line 486 "../src/window.vala"
		_tmp7_ = self->priv->unfullscreen_button;
#line 486 "../src/window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
#line 487 "../src/window.vala"
		_tmp8_ = self->priv->menu_fullscreen_stack;
#line 487 "../src/window.vala"
		_tmp9_ = self->priv->menu_fullscreen_button;
#line 487 "../src/window.vala"
		gtk_stack_set_visible_child (_tmp8_, (GtkWidget*) _tmp9_);
#line 2093 "window.c"
	}
}

static void
sudoku_window_backwards_pressed_cb (SudokuWindow* self,
                                    GtkGestureClick* gesture,
                                    gint n_press,
                                    gdouble x,
                                    gdouble y)
{
#line 491 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 491 "../src/window.vala"
	g_return_if_fail (gesture != NULL);
#line 496 "../src/window.vala"
	gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.undo", NULL, NULL);
#line 497 "../src/window.vala"
	gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.back", NULL, NULL);
#line 498 "../src/window.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 2114 "window.c"
}

static void
sudoku_window_forwards_pressed_cb (SudokuWindow* self,
                                   GtkGestureClick* gesture,
                                   gint n_press,
                                   gdouble x,
                                   gdouble y)
{
#line 501 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 501 "../src/window.vala"
	g_return_if_fail (gesture != NULL);
#line 506 "../src/window.vala"
	gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.redo", NULL, NULL);
#line 507 "../src/window.vala"
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 2132 "window.c"
}

static gboolean
sudoku_window_scroll_cb (SudokuWindow* self,
                         GtkEventControllerScroll* event,
                         gdouble dx,
                         gdouble dy)
{
	GdkModifierType state = 0U;
	gboolean control_pressed = FALSE;
	gboolean result;
#line 510 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 510 "../src/window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 515 "../src/window.vala"
	state = gtk_event_controller_get_current_event_state ((GtkEventController*) event);
#line 516 "../src/window.vala"
	control_pressed = (gboolean) (state & GDK_CONTROL_MASK);
#line 517 "../src/window.vala"
	if (control_pressed) {
#line 519 "../src/window.vala"
		if (dy <= ((gdouble) -1)) {
#line 521 "../src/window.vala"
			gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.zoom-in", NULL, NULL);
#line 522 "../src/window.vala"
			result = GDK_EVENT_STOP;
#line 522 "../src/window.vala"
			return result;
#line 2162 "window.c"
		} else {
#line 524 "../src/window.vala"
			if (dy >= ((gdouble) 1)) {
#line 526 "../src/window.vala"
				gtk_widget_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "app.zoom-out", NULL, NULL);
#line 527 "../src/window.vala"
				result = GDK_EVENT_STOP;
#line 527 "../src/window.vala"
				return result;
#line 2172 "window.c"
			}
		}
	}
#line 531 "../src/window.vala"
	result = GDK_EVENT_PROPAGATE;
#line 531 "../src/window.vala"
	return result;
#line 2180 "window.c"
}

static void
sudoku_window_scroll_begin_cb (SudokuWindow* self,
                               GtkEventControllerScroll* event)
{
	GdkModifierType state = 0U;
	gboolean control_pressed = FALSE;
#line 534 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 534 "../src/window.vala"
	g_return_if_fail (event != NULL);
#line 537 "../src/window.vala"
	state = gtk_event_controller_get_current_event_state ((GtkEventController*) event);
#line 538 "../src/window.vala"
	control_pressed = (gboolean) (state & GDK_CONTROL_MASK);
#line 539 "../src/window.vala"
	if (control_pressed) {
#line 541 "../src/window.vala"
		gtk_event_controller_scroll_set_flags (event, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL | GTK_EVENT_CONTROLLER_SCROLL_DISCRETE);
#line 2201 "window.c"
	}
}

static void
sudoku_window_scroll_end_cb (SudokuWindow* self,
                             GtkEventControllerScroll* event)
{
#line 546 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 546 "../src/window.vala"
	g_return_if_fail (event != NULL);
#line 548 "../src/window.vala"
	gtk_event_controller_scroll_set_flags (event, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL);
#line 2215 "window.c"
}

static gdouble
sudoku_window_normalize (SudokuWindow* self,
                         gint val,
                         gint min,
                         gint max)
{
	gdouble result;
#line 551 "../src/window.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 553 "../src/window.vala"
	CLAMP (val, min, max);
#line 554 "../src/window.vala"
	result = (val - min) / ((gdouble) (max - min));
#line 554 "../src/window.vala"
	return result;
#line 2233 "window.c"
}

static void
sudoku_window_set_gamebox_width_margins (SudokuWindow* self,
                                         gint width)
{
	gdouble factor = 0.0;
	gint margin_size = 0;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
#line 557 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 559 "../src/window.vala"
	factor = sudoku_window_normalize (self, width, SUDOKU_WINDOW_SMALL_WINDOW_WIDTH, SUDOKU_WINDOW_MEDIUM_WINDOW_WIDTH);
#line 560 "../src/window.vala"
	margin_size = SUDOKU_WINDOW_MARGIN_SMALL_SIZE + ((gint) (SUDOKU_WINDOW_MARGIN_SIZE_DIFF * factor));
#line 561 "../src/window.vala"
	_tmp0_ = self->priv->game_box;
#line 561 "../src/window.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp0_, margin_size);
#line 562 "../src/window.vala"
	_tmp1_ = self->priv->game_box;
#line 562 "../src/window.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp1_, margin_size);
#line 2258 "window.c"
}

static void
sudoku_window_set_gamebox_height_margins (SudokuWindow* self,
                                          gint height)
{
	gdouble factor = 0.0;
	gint margin_size = 0;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
#line 565 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 567 "../src/window.vala"
	factor = sudoku_window_normalize (self, height, self->priv->small_window_height, self->priv->medium_window_height);
#line 568 "../src/window.vala"
	margin_size = SUDOKU_WINDOW_MARGIN_SMALL_SIZE + ((gint) (SUDOKU_WINDOW_MARGIN_SIZE_DIFF * factor));
#line 569 "../src/window.vala"
	_tmp0_ = self->priv->game_box;
#line 569 "../src/window.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp0_, margin_size);
#line 570 "../src/window.vala"
	_tmp1_ = self->priv->game_box;
#line 570 "../src/window.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp1_, margin_size);
#line 2283 "window.c"
}

static void
sudoku_window_real_size_allocate (GtkWidget* base,
                                  gint width,
                                  gint height,
                                  gint baseline)
{
	SudokuWindow * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_;
#line 573 "../src/window.vala"
	self = (SudokuWindow*) base;
#line 575 "../src/window.vala"
	if (width < SUDOKU_WINDOW_MEDIUM_WINDOW_WIDTH) {
#line 2300 "window.c"
		gboolean _tmp1_;
#line 575 "../src/window.vala"
		_tmp1_ = self->priv->_window_width_is_small;
#line 575 "../src/window.vala"
		_tmp0_ = !_tmp1_;
#line 2306 "window.c"
	} else {
#line 575 "../src/window.vala"
		_tmp0_ = FALSE;
#line 2310 "window.c"
	}
#line 575 "../src/window.vala"
	if (_tmp0_) {
#line 576 "../src/window.vala"
		sudoku_window_window_width_is_small_cb (self);
#line 2316 "window.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 577 "../src/window.vala"
		if (width >= SUDOKU_WINDOW_MEDIUM_WINDOW_WIDTH) {
#line 2321 "window.c"
			gboolean _tmp3_;
#line 577 "../src/window.vala"
			_tmp3_ = self->priv->_window_width_is_small;
#line 577 "../src/window.vala"
			_tmp2_ = _tmp3_;
#line 2327 "window.c"
		} else {
#line 577 "../src/window.vala"
			_tmp2_ = FALSE;
#line 2331 "window.c"
		}
#line 577 "../src/window.vala"
		if (_tmp2_) {
#line 578 "../src/window.vala"
			sudoku_window_window_width_is_medium_cb (self);
#line 2337 "window.c"
		}
	}
#line 580 "../src/window.vala"
	_tmp5_ = self->priv->_window_width;
#line 580 "../src/window.vala"
	if (_tmp5_ != width) {
#line 580 "../src/window.vala"
		_tmp4_ = TRUE;
#line 2346 "window.c"
	} else {
		gint _tmp6_;
#line 580 "../src/window.vala"
		_tmp6_ = self->priv->_window_height;
#line 580 "../src/window.vala"
		_tmp4_ = _tmp6_ != height;
#line 2353 "window.c"
	}
#line 580 "../src/window.vala"
	if (_tmp4_) {
#line 2357 "window.c"
		GtkRequisition min_size = {0};
		GtkRequisition _tmp7_ = {0};
		GtkRequisition _tmp8_;
		GtkRequisition _tmp9_;
#line 582 "../src/window.vala"
		sudoku_window_set_gamebox_width_margins (self, width);
#line 583 "../src/window.vala"
		sudoku_window_set_gamebox_height_margins (self, height);
#line 586 "../src/window.vala"
		gtk_widget_get_preferred_size ((GtkWidget*) self, &_tmp7_, NULL);
#line 586 "../src/window.vala"
		min_size = _tmp7_;
#line 587 "../src/window.vala"
		_tmp8_ = min_size;
#line 587 "../src/window.vala"
		width = MAX (_tmp8_.width, width);
#line 587 "../src/window.vala"
		sudoku_window_set_window_width (self, width);
#line 588 "../src/window.vala"
		_tmp9_ = min_size;
#line 588 "../src/window.vala"
		height = MAX (_tmp9_.height, height);
#line 588 "../src/window.vala"
		sudoku_window_set_window_height (self, height);
#line 2382 "window.c"
	}
#line 591 "../src/window.vala"
	GTK_WIDGET_CLASS (sudoku_window_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow), width, height, baseline);
#line 2386 "window.c"
}

static void
sudoku_window_real_dispose (GObject* base)
{
	SudokuWindow * self;
#line 594 "../src/window.vala"
	self = (SudokuWindow*) base;
#line 598 "../src/window.vala"
	gtk_widget_dispose_template ((GtkWidget*) self, G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 599 "../src/window.vala"
	G_OBJECT_CLASS (sudoku_window_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_window_get_type (), AdwApplicationWindow));
#line 2399 "window.c"
}

static gint
sudoku_window_get_window_width (SudokuWindow* self)
{
	gint result;
#line 58 "../src/window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 58 "../src/window.vala"
	result = self->priv->_window_width;
#line 58 "../src/window.vala"
	return result;
#line 2412 "window.c"
}

static void
sudoku_window_set_window_width (SudokuWindow* self,
                                gint value)
{
#line 58 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/window.vala"
	self->priv->_window_width = value;
#line 2423 "window.c"
}

static gint
sudoku_window_get_window_height (SudokuWindow* self)
{
	gint result;
#line 59 "../src/window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 59 "../src/window.vala"
	result = self->priv->_window_height;
#line 59 "../src/window.vala"
	return result;
#line 2436 "window.c"
}

static void
sudoku_window_set_window_height (SudokuWindow* self,
                                 gint value)
{
#line 59 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/window.vala"
	self->priv->_window_height = value;
#line 2447 "window.c"
}

static gboolean
sudoku_window_get_window_width_is_small (SudokuWindow* self)
{
	gboolean result;
#line 60 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../src/window.vala"
	result = self->priv->_window_width_is_small;
#line 60 "../src/window.vala"
	return result;
#line 2460 "window.c"
}

static void
sudoku_window_set_window_width_is_small (SudokuWindow* self,
                                         gboolean value)
{
#line 60 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/window.vala"
	self->priv->_window_width_is_small = value;
#line 2471 "window.c"
}

static gboolean
sudoku_window_get_window_height_is_small (SudokuWindow* self)
{
	gboolean result;
#line 61 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../src/window.vala"
	result = self->priv->_window_height_is_small;
#line 61 "../src/window.vala"
	return result;
#line 2484 "window.c"
}

static void
sudoku_window_set_window_height_is_small (SudokuWindow* self,
                                          gboolean value)
{
#line 61 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/window.vala"
	self->priv->_window_height_is_small = value;
#line 2495 "window.c"
}

GSettings*
sudoku_window_get_settings (SudokuWindow* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 83 "../src/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 83 "../src/window.vala"
	_tmp0_ = self->priv->_settings;
#line 83 "../src/window.vala"
	result = _tmp0_;
#line 83 "../src/window.vala"
	return result;
#line 2511 "window.c"
}

static void
sudoku_window_set_settings (SudokuWindow* self,
                            GSettings* value)
{
	GSettings* old_value;
#line 83 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/window.vala"
	old_value = sudoku_window_get_settings (self);
#line 83 "../src/window.vala"
	if (old_value != value) {
#line 2525 "window.c"
		GSettings* _tmp0_;
#line 83 "../src/window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 83 "../src/window.vala"
		_g_object_unref0 (self->priv->_settings);
#line 83 "../src/window.vala"
		self->priv->_settings = _tmp0_;
#line 83 "../src/window.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_SETTINGS_PROPERTY]);
#line 2535 "window.c"
	}
}

SudokuView*
sudoku_window_get_view (SudokuWindow* self)
{
	SudokuView* result;
	SudokuView* _tmp0_;
#line 84 "../src/window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "../src/window.vala"
	_tmp0_ = self->priv->_view;
#line 84 "../src/window.vala"
	result = _tmp0_;
#line 84 "../src/window.vala"
	return result;
#line 2552 "window.c"
}

static void
sudoku_window_set_view (SudokuWindow* self,
                        SudokuView* value)
{
	SudokuView* old_value;
#line 84 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/window.vala"
	old_value = sudoku_window_get_view (self);
#line 84 "../src/window.vala"
	if (old_value != value) {
#line 2566 "window.c"
		SudokuView* _tmp0_;
#line 84 "../src/window.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 84 "../src/window.vala"
		_g_object_unref0 (self->priv->_view);
#line 84 "../src/window.vala"
		self->priv->_view = _tmp0_;
#line 84 "../src/window.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_VIEW_PROPERTY]);
#line 2576 "window.c"
	}
}

SudokuWindowScreen
sudoku_window_get_current_screen (SudokuWindow* self)
{
	SudokuWindowScreen result;
#line 85 "../src/window.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 85 "../src/window.vala"
	result = self->priv->_current_screen;
#line 85 "../src/window.vala"
	return result;
#line 2590 "window.c"
}

static void
sudoku_window_set_current_screen (SudokuWindow* self,
                                  SudokuWindowScreen value)
{
	SudokuWindowScreen old_value;
#line 85 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/window.vala"
	old_value = sudoku_window_get_current_screen (self);
#line 85 "../src/window.vala"
	if (old_value != value) {
#line 85 "../src/window.vala"
		self->priv->_current_screen = value;
#line 85 "../src/window.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY]);
#line 2608 "window.c"
	}
}

gboolean
sudoku_window_get_show_timer (SudokuWindow* self)
{
	gboolean result;
#line 287 "../src/window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 287 "../src/window.vala"
	result = self->priv->_show_timer;
#line 287 "../src/window.vala"
	return result;
#line 2622 "window.c"
}

void
sudoku_window_set_show_timer (SudokuWindow* self,
                              gboolean value)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	SudokuWindowScreen _tmp6_;
#line 288 "../src/window.vala"
	g_return_if_fail (self != NULL);
#line 289 "../src/window.vala"
	self->priv->_show_timer = value;
#line 291 "../src/window.vala"
	_tmp1_ = self->priv->game;
#line 291 "../src/window.vala"
	if (_tmp1_ != NULL) {
#line 2640 "window.c"
		SudokuGame* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 291 "../src/window.vala"
		_tmp2_ = self->priv->game;
#line 291 "../src/window.vala"
		_tmp3_ = sudoku_game_get_paused (_tmp2_);
#line 291 "../src/window.vala"
		_tmp4_ = _tmp3_;
#line 291 "../src/window.vala"
		_tmp0_ = _tmp4_;
#line 2652 "window.c"
	} else {
#line 291 "../src/window.vala"
		_tmp0_ = FALSE;
#line 2656 "window.c"
	}
#line 291 "../src/window.vala"
	if (_tmp0_) {
#line 2660 "window.c"
		SudokuGame* _tmp5_;
#line 292 "../src/window.vala"
		_tmp5_ = self->priv->game;
#line 292 "../src/window.vala"
		sudoku_game_set_paused (_tmp5_, FALSE);
#line 2666 "window.c"
	}
#line 294 "../src/window.vala"
	_tmp6_ = self->priv->_current_screen;
#line 294 "../src/window.vala"
	if (_tmp6_ == SUDOKU_WINDOW_SCREEN_PLAY) {
#line 2672 "window.c"
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 296 "../src/window.vala"
		_tmp7_ = sudoku_window_get_show_timer (self);
#line 296 "../src/window.vala"
		_tmp8_ = _tmp7_;
#line 296 "../src/window.vala"
		if (_tmp8_) {
#line 2681 "window.c"
			GtkToggleButton* _tmp9_;
			gboolean _tmp10_;
			GtkBox* _tmp11_;
			gboolean _tmp12_;
			GtkStack* _tmp13_;
#line 298 "../src/window.vala"
			_tmp9_ = self->priv->earmark_mode_button;
#line 298 "../src/window.vala"
			_tmp10_ = self->priv->_window_width_is_small;
#line 298 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp9_, !_tmp10_);
#line 299 "../src/window.vala"
			_tmp11_ = self->priv->clock_box;
#line 299 "../src/window.vala"
			_tmp12_ = self->priv->_window_width_is_small;
#line 299 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp11_, !_tmp12_);
#line 300 "../src/window.vala"
			_tmp13_ = self->priv->play_pause_stack;
#line 300 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp13_, TRUE);
#line 2703 "window.c"
		} else {
			GtkBox* _tmp14_;
			GtkToggleButton* _tmp15_;
			GtkStack* _tmp16_;
#line 304 "../src/window.vala"
			_tmp14_ = self->priv->clock_box;
#line 304 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp14_, FALSE);
#line 305 "../src/window.vala"
			_tmp15_ = self->priv->earmark_mode_button;
#line 305 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp15_, TRUE);
#line 306 "../src/window.vala"
			_tmp16_ = self->priv->play_pause_stack;
#line 306 "../src/window.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp16_, FALSE);
#line 2720 "window.c"
		}
	}
#line 288 "../src/window.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_window_properties[SUDOKU_WINDOW_SHOW_TIMER_PROPERTY]);
#line 2725 "window.c"
}

static void
sudoku_window_class_init (SudokuWindowClass * klass,
                          gpointer klass_data)
{
#line 26 "../src/window.vala"
	sudoku_window_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/window.vala"
	g_type_class_adjust_private_offset (klass, &SudokuWindow_private_offset);
#line 26 "../src/window.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_window_real_size_allocate;
#line 26 "../src/window.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_window_real_dispose;
#line 26 "../src/window.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_window_get_property;
#line 26 "../src/window.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_window_set_property;
#line 26 "../src/window.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_window_finalize;
#line 26 "../src/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_SETTINGS_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_VIEW_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", TYPE_SUDOKU_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY] = g_param_spec_enum ("current-screen", "current-screen", "current-screen", TYPE_SUDOKU_WINDOW_SCREEN, SUDOKU_WINDOW_SCREEN_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/window.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_WINDOW_SHOW_TIMER_PROPERTY, sudoku_window_properties[SUDOKU_WINDOW_SHOW_TIMER_PROPERTY] = g_param_spec_boolean ("show-timer", "show-timer", "show-timer", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Sudoku/ui/sudoku-window.ui");
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "windowtitle", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, windowtitle));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, headerbar));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "game_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, game_box));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_menu", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, main_menu));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "start_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, start_box));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "start_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, start_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "custom_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, custom_check));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "easy_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, easy_check));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "medium_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, medium_check));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "hard_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, hard_check));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "very_hard_check", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, very_hard_check));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menu_fullscreen_stack", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, menu_fullscreen_stack));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "play_pause_stack", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, play_pause_stack));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "earmark_mode_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, earmark_mode_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "undo_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, undo_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "redo_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, redo_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, back_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "unfullscreen_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, unfullscreen_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menu_unfullscreen_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, menu_unfullscreen_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menu_fullscreen_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, menu_fullscreen_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "play_custom_game_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, play_custom_game_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pause_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, pause_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "play_button", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, play_button));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_box", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, clock_box));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "clock_label", FALSE, SudokuWindow_private_offset + G_STRUCT_OFFSET (SudokuWindowPrivate, clock_label));
#line 26 "../src/window.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "start_game_cb", G_CALLBACK(_sudoku_window_start_game_cb_gtk_button_clicked));
#line 146 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_n, GDK_CONTROL_MASK, "app.new-game", NULL, NULL);
#line 147 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_p, GDK_CONTROL_MASK, "app.print-current-board", NULL, NULL);
#line 148 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_p, GDK_NO_MODIFIER_MASK, "app.toggle-pause", NULL, NULL);
#line 149 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_r, GDK_CONTROL_MASK, "app.reset-board", NULL, NULL);
#line 150 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_u, GDK_NO_MODIFIER_MASK, "app.undo", NULL, NULL);
#line 151 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_z, GDK_CONTROL_MASK, "app.undo", NULL, NULL);
#line 152 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_r, GDK_NO_MODIFIER_MASK, "app.redo", NULL, NULL);
#line 153 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_z, GDK_CONTROL_MASK | GDK_SHIFT_MASK, "app.redo", NULL, NULL);
#line 154 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_e, GDK_NO_MODIFIER_MASK, "app.earmark-mode", NULL, NULL);
#line 155 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_question, GDK_CONTROL_MASK, "app.shortcuts-window", NULL, NULL);
#line 156 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_comma, GDK_CONTROL_MASK, "app.preferences-dialog", NULL, NULL);
#line 157 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_f, GDK_NO_MODIFIER_MASK, "app.toggle-fullscreen", NULL, NULL);
#line 158 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_F11, GDK_NO_MODIFIER_MASK, "app.toggle-fullscreen", NULL, NULL);
#line 159 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_h, GDK_CONTROL_MASK, "app.highlighter", NULL, NULL);
#line 160 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_w, GDK_CONTROL_MASK, "app.show-warnings", NULL, NULL);
#line 161 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_0, GDK_CONTROL_MASK, "app.zoom-reset", NULL, NULL);
#line 162 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_0, GDK_CONTROL_MASK, "app.zoom-reset", NULL, NULL);
#line 163 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_plus, GDK_CONTROL_MASK, "app.zoom-in", NULL, NULL);
#line 164 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_equal, GDK_CONTROL_MASK, "app.zoom-in", NULL, NULL);
#line 165 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Add, GDK_CONTROL_MASK, "app.zoom-in", NULL, NULL);
#line 166 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_ZoomIn, GDK_NO_MODIFIER_MASK, "app.zoom-in", NULL, NULL);
#line 167 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_minus, GDK_CONTROL_MASK, "app.zoom-out", NULL, NULL);
#line 168 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Subtract, GDK_CONTROL_MASK, "app.zoom-out", NULL, NULL);
#line 169 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_ZoomOut, GDK_NO_MODIFIER_MASK, "app.zoom-out", NULL, NULL);
#line 170 "../src/window.vala"
	gtk_widget_class_add_binding_action (GTK_WIDGET_CLASS (klass), GDK_KEY_Left, GDK_ALT_MASK, "app.back", NULL, NULL);
#line 2858 "window.c"
}

static void
sudoku_window_instance_init (SudokuWindow * self,
                             gpointer klass)
{
#line 26 "../src/window.vala"
	self->priv = sudoku_window_get_instance_private (self);
#line 76 "../src/window.vala"
	self->priv->game = NULL;
#line 84 "../src/window.vala"
	self->priv->_view = NULL;
#line 85 "../src/window.vala"
	self->priv->_current_screen = SUDOKU_WINDOW_SCREEN_NONE;
#line 26 "../src/window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2875 "window.c"
}

static void
sudoku_window_finalize (GObject * obj)
{
	SudokuWindow * self;
#line 26 "../src/window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_WINDOW, SudokuWindow);
#line 69 "../src/window.vala"
	_g_object_unref0 (self->priv->accent_provider);
#line 70 "../src/window.vala"
	_g_object_unref0 (self->priv->style_manager);
#line 76 "../src/window.vala"
	_g_object_unref0 (self->priv->game);
#line 78 "../src/window.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 79 "../src/window.vala"
	_g_object_unref0 (self->priv->backwards_controller);
#line 80 "../src/window.vala"
	_g_object_unref0 (self->priv->forwards_controller);
#line 81 "../src/window.vala"
	_g_object_unref0 (self->priv->scroll_controller);
#line 83 "../src/window.vala"
	_g_object_unref0 (self->priv->_settings);
#line 84 "../src/window.vala"
	_g_object_unref0 (self->priv->_view);
#line 26 "../src/window.vala"
	G_OBJECT_CLASS (sudoku_window_parent_class)->finalize (obj);
#line 2904 "window.c"
}

static GType
sudoku_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuWindow), 0, (GInstanceInitFunc) sudoku_window_instance_init, NULL };
	GType sudoku_window_type_id;
	sudoku_window_type_id = g_type_register_static (adw_application_window_get_type (), "SudokuWindow", &g_define_type_info, 0);
	SudokuWindow_private_offset = g_type_add_instance_private (sudoku_window_type_id, sizeof (SudokuWindowPrivate));
	return sudoku_window_type_id;
}

GType
sudoku_window_get_type (void)
{
	static volatile gsize sudoku_window_type_id__once = 0;
	if (g_once_init_enter (&sudoku_window_type_id__once)) {
		GType sudoku_window_type_id;
		sudoku_window_type_id = sudoku_window_get_type_once ();
		g_once_init_leave (&sudoku_window_type_id__once, sudoku_window_type_id);
	}
	return sudoku_window_type_id__once;
}

static void
_vala_sudoku_window_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	SudokuWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_WINDOW, SudokuWindow);
#line 26 "../src/window.vala"
	switch (property_id) {
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_SETTINGS_PROPERTY:
#line 26 "../src/window.vala"
		g_value_set_object (value, sudoku_window_get_settings (self));
#line 26 "../src/window.vala"
		break;
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_VIEW_PROPERTY:
#line 26 "../src/window.vala"
		g_value_set_object (value, sudoku_window_get_view (self));
#line 26 "../src/window.vala"
		break;
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY:
#line 26 "../src/window.vala"
		g_value_set_enum (value, sudoku_window_get_current_screen (self));
#line 26 "../src/window.vala"
		break;
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_SHOW_TIMER_PROPERTY:
#line 26 "../src/window.vala"
		g_value_set_boolean (value, sudoku_window_get_show_timer (self));
#line 26 "../src/window.vala"
		break;
#line 2963 "window.c"
		default:
#line 26 "../src/window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/window.vala"
		break;
#line 2969 "window.c"
	}
}

static void
_vala_sudoku_window_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	SudokuWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_WINDOW, SudokuWindow);
#line 26 "../src/window.vala"
	switch (property_id) {
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_SETTINGS_PROPERTY:
#line 26 "../src/window.vala"
		sudoku_window_set_settings (self, g_value_get_object (value));
#line 26 "../src/window.vala"
		break;
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_VIEW_PROPERTY:
#line 26 "../src/window.vala"
		sudoku_window_set_view (self, g_value_get_object (value));
#line 26 "../src/window.vala"
		break;
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_CURRENT_SCREEN_PROPERTY:
#line 26 "../src/window.vala"
		sudoku_window_set_current_screen (self, g_value_get_enum (value));
#line 26 "../src/window.vala"
		break;
#line 26 "../src/window.vala"
		case SUDOKU_WINDOW_SHOW_TIMER_PROPERTY:
#line 26 "../src/window.vala"
		sudoku_window_set_show_timer (self, g_value_get_boolean (value));
#line 26 "../src/window.vala"
		break;
#line 3007 "window.c"
		default:
#line 26 "../src/window.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/window.vala"
		break;
#line 3013 "window.c"
	}
}

static GType
sudoku_window_screen_get_type_once (void)
{
	static const GEnumValue values[] = {{SUDOKU_WINDOW_SCREEN_NONE, "SUDOKU_WINDOW_SCREEN_NONE", "none"}, {SUDOKU_WINDOW_SCREEN_PLAY, "SUDOKU_WINDOW_SCREEN_PLAY", "play"}, {SUDOKU_WINDOW_SCREEN_CREATE, "SUDOKU_WINDOW_SCREEN_CREATE", "create"}, {SUDOKU_WINDOW_SCREEN_MENU, "SUDOKU_WINDOW_SCREEN_MENU", "menu"}, {0, NULL, NULL}};
	GType sudoku_window_screen_type_id;
	sudoku_window_screen_type_id = g_enum_register_static ("SudokuWindowScreen", values);
	return sudoku_window_screen_type_id;
}

GType
sudoku_window_screen_get_type (void)
{
	static volatile gsize sudoku_window_screen_type_id__once = 0;
	if (g_once_init_enter (&sudoku_window_screen_type_id__once)) {
		GType sudoku_window_screen_type_id;
		sudoku_window_screen_type_id = sudoku_window_screen_get_type_once ();
		g_once_init_leave (&sudoku_window_screen_type_id__once, sudoku_window_screen_type_id);
	}
	return sudoku_window_screen_type_id__once;
}

